/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20170709

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 20 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "sip.h"

void yyerror(char* s);
int yylex();

#define MAX_NESTED_IF       10
#define MAX_NESTED_SCOPE    10

#define inMainModule()      (currentSpec->module == currentModule || currentModule->container != NULL)


static sipSpec *currentSpec;            /* The current spec being parsed. */
static stringList *neededQualifiers;    /* The list of required qualifiers. */
static stringList *excludedQualifiers;  /* The list of excluded qualifiers. */
static moduleDef *currentModule;        /* The current module being parsed. */
static mappedTypeDef *currentMappedType;    /* The current mapped type. */
static enumDef *currentEnum;            /* The current enum being parsed. */
static int sectionFlags;                /* The current section flags. */
static int currentOverIsVirt;           /* Set if the overload is virtual. */
static int currentCtorIsExplicit;       /* Set if the ctor is explicit. */
static int currentIsStatic;             /* Set if the current is static. */
static int currentIsSignal;             /* Set if the current is Q_SIGNAL. */
static int currentIsSlot;               /* Set if the current is Q_SLOT. */
static int currentIsTemplate;           /* Set if the current is a template. */
static char *previousFile;              /* The file just parsed. */
static parserContext currentContext;    /* The current context. */
static int skipStackPtr;                /* The skip stack pointer. */
static int skipStack[MAX_NESTED_IF];    /* Stack of skip flags. */
static classDef *scopeStack[MAX_NESTED_SCOPE];  /* The scope stack. */
static int sectFlagsStack[MAX_NESTED_SCOPE];    /* The section flags stack. */
static int currentScopeIdx;             /* The scope stack index. */
static int currentTimelineOrder;        /* The current timeline order. */
static classList *currentSupers;        /* The current super-class list. */
static int defaultKwdArgs;              /* Support keyword arguments by default. */
static int makeProtPublic;              /* Treat protected items as public. */


static const char *getPythonName(optFlags *optflgs, const char *cname);
static classDef *findClass(sipSpec *pt, ifaceFileType iftype,
        apiVersionRangeDef *api_range, scopedNameDef *fqname);
static classDef *findClassWithInterface(sipSpec *pt, ifaceFileDef *iff);
static classDef *newClass(sipSpec *pt, ifaceFileType iftype,
        apiVersionRangeDef *api_range, scopedNameDef *snd);
static void finishClass(sipSpec *, moduleDef *, classDef *, optFlags *);
static exceptionDef *findException(sipSpec *pt, scopedNameDef *fqname, int new);
static mappedTypeDef *newMappedType(sipSpec *,argDef *, optFlags *);
static enumDef *newEnum(sipSpec *pt, moduleDef *mod, mappedTypeDef *mt_scope,
        char *name, optFlags *of, int flags);
static void instantiateClassTemplate(sipSpec *pt, moduleDef *mod, classDef *scope, scopedNameDef *fqname, classTmplDef *tcd, templateDef *td);
static void newTypedef(sipSpec *, moduleDef *, char *, argDef *, optFlags *);
static void newVar(sipSpec *, moduleDef *, char *, int, argDef *, optFlags *,
        codeBlock *, codeBlock *, codeBlock *);
static void newCtor(char *, int, signatureDef *, optFlags *, codeBlock *,
        throwArgs *, signatureDef *, int, codeBlock *);
static void newFunction(sipSpec *, moduleDef *, classDef *, mappedTypeDef *,
        int, int, int, int, int, char *, signatureDef *, int, int, optFlags *,
        codeBlock *, codeBlock *, throwArgs *, signatureDef *, codeBlock *);
static optFlag *findOptFlag(optFlags *,char *,flagType);
static memberDef *findFunction(sipSpec *, moduleDef *, classDef *,
        mappedTypeDef *, const char *, int, int, int);
static void checkAttributes(sipSpec *, moduleDef *, classDef *,
        mappedTypeDef *, const char *, int);
static void newModule(FILE *fp, char *filename);
static moduleDef *allocModule();
static void parseFile(FILE *fp, char *name, moduleDef *prevmod, int optional);
static void handleEOF(void);
static void handleEOM(void);
static qualDef *findQualifier(const char *name);
static scopedNameDef *text2scopedName(ifaceFileDef *scope, char *text);
static scopedNameDef *scopeScopedName(ifaceFileDef *scope,
        scopedNameDef *name);
static void pushScope(classDef *);
static void popScope(void);
static classDef *currentScope(void);
static void newQualifier(moduleDef *,int,int,char *,qualType);
static void newImport(char *filename);
static int timePeriod(char *,char *);
static int platOrFeature(char *,int);
static int isNeeded(qualDef *);
static int notSkipping(void);
static void getHooks(optFlags *,char **,char **);
static int getTransfer(optFlags *optflgs);
static int getReleaseGIL(optFlags *optflgs);
static int getHoldGIL(optFlags *optflgs);
static int getDeprecated(optFlags *optflgs);
static int getAllowNone(optFlags *optflgs);
static const char *getDocType(optFlags *optflgs);
static const char *getDocValue(optFlags *optflgs);
static void templateSignature(signatureDef *sd, int result, classTmplDef *tcd, templateDef *td, classDef *ncd);
static void templateType(argDef *ad, classTmplDef *tcd, templateDef *td, classDef *ncd);
static int search_back(const char *end, const char *start, const char *target);
static char *type2string(argDef *ad);
static char *scopedNameToString(scopedNameDef *name);
static void addUsedFromCode(sipSpec *pt, ifaceFileList **used, const char *sname);
static int sameName(scopedNameDef *snd, const char *sname);
static int stringFind(stringList *sl, const char *s);
static void setModuleName(sipSpec *pt, moduleDef *mod, const char *fullname);
static int foundInScope(scopedNameDef *fq_name, scopedNameDef *rel_name);
static void defineClass(scopedNameDef *snd, classList *supers, optFlags *of);
static classDef *completeClass(scopedNameDef *snd, optFlags *of, int has_def);
static memberDef *instantiateTemplateMethods(memberDef *tmd, moduleDef *mod);
static void instantiateTemplateEnums(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values);
static void instantiateTemplateVars(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values);
static overDef *instantiateTemplateOverloads(sipSpec *pt, overDef *tod,
        memberDef *tmethods, memberDef *methods, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values);
static void resolveAnyTypedef(sipSpec *pt, argDef *ad);
static void addVariable(sipSpec *pt, varDef *vd);
static void applyTypeFlags(moduleDef *mod, argDef *ad, optFlags *flags);
static argType convertEncoding(const char *encoding);
static apiVersionRangeDef *getAPIRange(optFlags *optflgs);
static apiVersionRangeDef *convertAPIRange(moduleDef *mod, nameDef *name,
        int from, int to);
static char *convertFeaturedString(char *fs);
static scopedNameDef *text2scopePart(char *text);
static int usesKeywordArgs(optFlags *optflgs, signatureDef *sd);
static char *strip(char *s);
static int isEnabledFeature(const char *name);
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 149 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
typedef union {
    char            qchar;
    char            *text;
    long            number;
    double          real;
    argDef          memArg;
    signatureDef    signature;
    signatureDef    *optsignature;
    throwArgs       *throwlist;
    codeBlock       *codeb;
    valueDef        value;
    valueDef        *valp;
    optFlags        optflags;
    optFlag         flag;
    scopedNameDef   *scpvalp;
    fcallDef        fcall;
    int             boolean;
    exceptionDef    exceptionbase;
    classDef        *klass;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 177 "parser.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define TK_API 257
#define TK_DEFENCODING 258
#define TK_PLUGIN 259
#define TK_DOCSTRING 260
#define TK_DOC 261
#define TK_EXPORTEDDOC 262
#define TK_MAKEFILE 263
#define TK_ACCESSCODE 264
#define TK_GETCODE 265
#define TK_SETCODE 266
#define TK_PREINITCODE 267
#define TK_INITCODE 268
#define TK_POSTINITCODE 269
#define TK_UNITCODE 270
#define TK_MODCODE 271
#define TK_TYPECODE 272
#define TK_PREPYCODE 273
#define TK_COPYING 274
#define TK_MAPPEDTYPE 275
#define TK_CODELINE 276
#define TK_IF 277
#define TK_END 278
#define TK_NAME 279
#define TK_PATHNAME 280
#define TK_STRING 281
#define TK_VIRTUALCATCHERCODE 282
#define TK_TRAVERSECODE 283
#define TK_CLEARCODE 284
#define TK_GETBUFFERCODE 285
#define TK_RELEASEBUFFERCODE 286
#define TK_READBUFFERCODE 287
#define TK_WRITEBUFFERCODE 288
#define TK_SEGCOUNTCODE 289
#define TK_CHARBUFFERCODE 290
#define TK_PICKLECODE 291
#define TK_METHODCODE 292
#define TK_FROMTYPE 293
#define TK_TOTYPE 294
#define TK_TOSUBCLASS 295
#define TK_INCLUDE 296
#define TK_OPTINCLUDE 297
#define TK_IMPORT 298
#define TK_EXPHEADERCODE 299
#define TK_MODHEADERCODE 300
#define TK_TYPEHEADERCODE 301
#define TK_MODULE 302
#define TK_CMODULE 303
#define TK_CONSMODULE 304
#define TK_COMPOMODULE 305
#define TK_CLASS 306
#define TK_STRUCT 307
#define TK_PUBLIC 308
#define TK_PROTECTED 309
#define TK_PRIVATE 310
#define TK_SIGNALS 311
#define TK_SIGNAL_METHOD 312
#define TK_SLOTS 313
#define TK_SLOT_METHOD 314
#define TK_BOOL 315
#define TK_SHORT 316
#define TK_INT 317
#define TK_LONG 318
#define TK_FLOAT 319
#define TK_DOUBLE 320
#define TK_CHAR 321
#define TK_WCHAR_T 322
#define TK_VOID 323
#define TK_PYOBJECT 324
#define TK_PYTUPLE 325
#define TK_PYLIST 326
#define TK_PYDICT 327
#define TK_PYCALLABLE 328
#define TK_PYSLICE 329
#define TK_PYTYPE 330
#define TK_VIRTUAL 331
#define TK_ENUM 332
#define TK_SIGNED 333
#define TK_UNSIGNED 334
#define TK_SCOPE 335
#define TK_LOGICAL_OR 336
#define TK_CONST 337
#define TK_STATIC 338
#define TK_SIPSIGNAL 339
#define TK_SIPSLOT 340
#define TK_SIPANYSLOT 341
#define TK_SIPRXCON 342
#define TK_SIPRXDIS 343
#define TK_SIPSLOTCON 344
#define TK_SIPSLOTDIS 345
#define TK_NUMBER 346
#define TK_REAL 347
#define TK_TYPEDEF 348
#define TK_NAMESPACE 349
#define TK_TIMELINE 350
#define TK_PLATFORMS 351
#define TK_FEATURE 352
#define TK_LICENSE 353
#define TK_TQCHAR 354
#define TK_TRUE 355
#define TK_FALSE 356
#define TK_NULL 357
#define TK_OPERATOR 358
#define TK_THROW 359
#define TK_TQOBJECT 360
#define TK_EXCEPTION 361
#define TK_RAISECODE 362
#define TK_EXPLICIT 363
#define TK_TEMPLATE 364
#define TK_ELLIPSIS 365
#define TK_DEFMETATYPE 366
#define TK_DEFSUPERTYPE 367
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,   70,   68,   69,   69,   69,   69,   69,   69,
   69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
   69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
   69,   69,   69,   69,   97,   97,   97,   97,   97,   97,
   97,   97,   97,   97,   97,   97,   84,   74,   79,  103,
   66,   66,   46,  109,   95,  110,   96,  108,  111,  111,
  112,  112,  112,  112,  112,  113,  114,  100,  115,  115,
  116,   81,  117,  117,  118,   82,  119,   80,  120,  120,
  121,   98,   63,   63,   63,   63,   62,   62,   99,   83,
   85,   86,   72,   73,   71,   64,   64,   52,   52,   19,
   19,   76,   77,   78,   24,   24,   25,   25,   26,   26,
   75,   27,   28,   29,   30,   30,   31,   32,   33,   34,
   35,   36,   37,   38,   39,   40,   41,   87,   88,   89,
   90,   91,   92,   93,   94,   42,   43,   43,  122,  105,
   50,   50,   51,   51,  123,  123,  124,  124,  125,  125,
  125,  127,  127,  126,  126,   23,   23,   22,   22,   58,
   58,   58,   58,   58,   58,   57,   57,   57,   57,   57,
   21,   60,   60,   59,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   61,   61,   61,  104,  104,  129,  130,
  101,  131,  102,    5,  132,  133,   67,  128,  128,  134,
  134,  135,   65,   65,  136,  136,  137,  137,  137,  137,
  137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
  137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
  137,  137,  137,  137,  137,   13,   13,  139,  142,  138,
  138,  141,   10,   10,    9,    9,   16,   16,  106,  106,
  106,  106,   49,   49,   49,   49,   49,   49,   49,   49,
   49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
   49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
   49,   15,   15,   17,   17,   53,   53,   54,   54,   55,
   55,   56,   56,   56,   56,   47,   48,   48,   45,   45,
   44,   44,    6,    7,    7,    7,    1,    1,    1,    1,
    1,    1,    1,    1,    1,  144,  140,  145,  140,  140,
  147,  143,  143,  146,  146,  149,  148,  148,  107,    3,
    3,    2,   14,   14,   18,   18,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    8,    8,   11,   11,   12,   12,
   12,
};
static const YYINT yylen[] = {                            2,
    1,    2,    0,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    3,    9,
    0,    3,    2,    0,    5,    0,    6,    4,    1,    2,
    1,    2,    2,    1,    1,   13,    0,    7,    1,    2,
    0,    5,    1,    2,    1,    2,    0,    5,    1,    2,
    1,    4,    1,    2,    3,    4,    1,    3,    1,    2,
    2,    2,    2,    2,    3,    1,    1,    1,    1,    0,
    1,    2,    2,    2,    0,    2,    0,    2,    0,    2,
    2,    2,    2,    2,    0,    1,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    4,    2,    1,    2,    0,    8,
    0,    1,    0,    1,    0,    1,    1,    2,    1,    1,
    4,    0,    1,    0,    2,    0,    2,    1,    3,    1,
    1,    1,    1,    1,    1,    0,    1,    1,    1,    1,
    2,    1,    3,    1,    1,    4,    1,    1,    1,    1,
    1,    1,    1,    0,    1,    3,    5,   11,    0,    0,
    8,    0,    3,    4,    0,    0,    8,    0,    2,    1,
    3,    1,    0,    3,    1,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    2,    3,    3,    3,    2,    0,    1,   11,    0,    3,
    1,   10,    0,    5,    0,    6,    0,    1,   14,    7,
   14,   13,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    3,    3,    1,    2,    2,    1,    2,    2,    2,    1,
    2,    0,    1,    0,    2,    0,    3,    1,    3,    1,
    3,    1,    5,    1,    1,    2,    0,    1,    0,    2,
    0,    2,    1,    0,    1,    3,    4,    4,    4,    3,
    3,    6,    6,    3,    2,    0,    3,    0,    3,    1,
    0,    3,    1,    1,    1,    0,    3,    1,    7,    4,
    3,    3,    0,    1,    0,    2,    1,    4,    2,    2,
    1,    1,    2,    1,    1,    2,    2,    3,    1,    1,
    1,    2,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    3,    0,    4,    0,    1,
    3,
};
static const YYINT yydefred[] = {                         3,
    3,    1,    0,    2,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   89,
  174,    0,    0,    0,    0,    0,    0,   96,   97,    0,
    0,    0,    0,  351,  341,  344,    0,  349,  350,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,    0,
    0,    0,    0,    0,    0,   77,   71,    0,    0,    0,
    0,    0,  364,    0,    0,    0,  335,    0,   21,   22,
   46,   23,  172,    0,    0,   39,    4,    5,    6,    7,
    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
   18,   19,   20,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   40,   41,
   42,   43,   44,   45,    0,   47,   48,  137,  133,    0,
  134,    0,  128,  129,  130,  131,  126,  132,  111,    0,
    0,    0,  102,  103,  104,  112,  113,  114,   98,   99,
   93,   94,    0,    0,  347,  144,    0,  352,  340,  343,
    0,  353,  335,    0,   67,    0,    0,   76,    0,   90,
    0,    0,    0,   91,   92,    0,    0,    0,    0,    0,
    0,    0,    0,   49,  138,  136,  142,    0,    0,   54,
    0,    0,    0,    0,    0,    0,    0,  139,  348,    0,
    0,  335,    0,    0,    0,    0,    0,  288,    0,    0,
    0,  365,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  273,    0,    0,    0,    0,    0,
    0,  336,  334,  331,    0,  193,  173,    0,  101,   95,
  135,    0,   84,    0,   82,    0,    0,    0,    0,    0,
  330,    0,    0,    0,   81,    0,   79,   75,    0,   73,
    0,    0,  287,    0,    0,    0,    0,    0,    0,    0,
    0,  305,    0,    0,    0,    0,    0,    0,    0,  194,
    0,    0,  274,  279,  264,    0,  278,  263,  265,  266,
  268,  269,  277,    0,  281,    0,  275,  267,  270,    0,
   56,  338,    0,   55,   88,   85,    0,    0,    0,  200,
  196,  190,    0,  187,    0,  192,   69,    0,   78,   80,
   72,   74,    0,  294,  295,  292,  291,  289,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  315,    0,    0,
    0,   52,    0,  366,    0,    0,    0,    0,  271,  272,
    0,    0,    0,    0,    0,   61,   64,    0,   59,   65,
   86,    0,    0,    0,    0,  149,  150,    0,    0,  147,
    0,    0,   70,    0,    0,    0,    0,  310,  311,    0,
    0,  314,  167,  169,  170,  168,  158,    0,    0,  332,
  283,    0,  306,  116,    0,    0,  106,    0,    0,    0,
    0,   57,   62,   63,    0,    0,   60,  201,    0,    0,
    0,    0,    0,    0,  148,    0,   68,    0,  307,  308,
  309,    0,    0,  160,  161,  162,  163,  164,  165,    0,
  182,  178,  177,  183,  179,  180,  181,    0,  171,    0,
    0,    0,    0,    0,    0,  108,    0,  329,  250,    0,
    0,   58,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  316,  318,    0,  321,  239,    0,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  216,  215,  211,  207,
  208,  209,  210,  212,  213,  214,  328,  325,    0,  205,
  227,  228,  229,  241,  320,  323,  324,  197,  191,  155,
    0,  140,    0,    0,    0,    0,  159,    0,    0,    0,
    0,   53,    0,    0,  110,    0,    0,  296,  127,    0,
  117,  118,  119,  120,  121,  122,  123,  124,  125,  231,
  230,  237,    0,    0,    0,  235,    0,    0,    0,    0,
    0,    0,  204,  206,  153,  151,    0,  293,  312,  313,
    0,    0,    0,    0,  285,    0,   50,    0,    0,    0,
    0,  232,  233,  234,  326,  317,  319,    0,  327,  322,
    0,  240,    0,    0,  176,    0,  368,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  188,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  298,
    0,    0,    0,    0,    0,    0,  300,    0,  252,    0,
    0,    0,    0,    0,    0,    0,  302,  249,  251,    0,
    0,    0,    0,  246,    0,    0,    0,    0,    0,    0,
  242,    0,   66,  244,  238,
};
static const YYINT yydgoto[] = {                          1,
  262,  263,  264,   67,  306,  265,  266,  203,  580,  614,
  432,  553,  533,  224,  382,  466,  511,  168,  230,  429,
  377,  378,  328,  337,  389,  438,   69,   70,   71,  385,
  468,  469,  470,  471,  472,  473,  474,  475,  476,   72,
  477,  119,  120,  609,  599,  434,  600,  601,  221,  178,
  147,  141,  160,  197,  198,  317,  379,  420,   73,   74,
  552,  184,  185,   75,  400,  201,   76,    2,   77,    3,
   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
  108,  109,  110,  111,  112,  487,  488,  294,  232,  342,
  348,  349,  350,  193,  308,  157,  249,  250,  156,  246,
  247,  240,  358,  359,  360,  403,  546,  238,  187,  354,
  170,  186,  353,  299,  300,  489,  490,  491,  492,  493,
  494,  541,  495,  537,  538,  496,  540,  497,  539,
};
static const YYINT yysindex[] = {                         0,
    0,    0, 1830,    0,  -60,  -33,  -26,   -6,   -6,   33,
   -6,   -6,   -6,   -6,   -6,   -6,   -6, 2403,  262,    0,
    0,   51,   57,   61,   -6,   -6,   -6,    0,    0,  -83,
  -83,   71,   71,    0,    0,    0,   40,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   97,
   70,   68, 2403, 2379,  108,    0,    0,  120,  354, 2379,
   71,  356,    0,  -83,  -83, -203,    0,  191,    0,    0,
    0,    0,    0,  -28,  -83,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  126,    0,    0,    0,    0,   18,
    0,  215,    0,    0,    0,    0,    0,    0,    0,   71,
  354,    4,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  139,  139,    0,    0,  354,    0,    0,    0,
  162,    0,    0,    1,    0,  362,  373,    0,  219,    0,
  457,  -16, 2379,    0,    0,   47, 2243,  165, 2403,  193,
   71, 2379,  154,    0,    0,    0,    0,   -6,  139,    0,
    0,  223,  458,  464,  171,  448,  448,    0,    0,  165,
  354,    0,  385,  247,  250,  469,    7,    0, 2056,   71,
  354,    0,  213, 2056,  466,  490,  471,  472,  205,  473,
  478,  481,  482,  483,    0,  306,  370,  452,  485,  491,
  513,    0,    0,    0,  354,    0,    0,  246,    0,    0,
    0,  431,    0,   97,    0,    6,   71,  354,  354,  433,
    0,  498,    3, 1991,    0,  -85,    0,    0,  -66,    0,
   84,  219,    0,   97,   97,   97,   97,   97,  518,  520,
   97,    0,  500,   97,  521,  519,  -12,  441, 2379,    0,
  524,  302,    0,    0,    0, 2379,    0,    0,    0,    0,
    0,    0,    0,  506,    0,  507,    0,    0,    0, 2056,
    0,    0,   76,    0,    0,    0,  290,  139,  526,    0,
    0,    0,  144,    0,  530,    0,    0, 1689,    0,    0,
    0,    0,  514,    0,    0,    0,    0,    0,  354,  354,
  354,  354,  354, 2056, 2056,  354,   96,    0,  354,  237,
 2056,    0,  274,    0,  237,   -6,  311,  537,    0,    0,
  538,  431,   -6,   -6, 2379,    0,    0,   17,    0,    0,
    0,   71,  459,  459,  522,    0,    0,  460,  144,    0,
  544,  527,    0,  154,  500,  500,  500,    0,    0,  546,
  547,    0,    0,    0,    0,    0,    0,  364, 2113,    0,
    0,  231,    0,    0,  229,  231,    0,   -6,  326,  534,
  237,    0,    0,    0,  315,  536,    0,    0, 1926,  539,
  541,   96,  354,  549,    0, 2379,    0,  551,    0,    0,
    0,   97,   97,    0,    0,    0,    0,    0,    0,   96,
    0,    0,    0,    0,    0,    0,    0,  557,    0,  -28,
  580,  563,   -6,  501,  563,    0,   -6,    0,    0,  231,
  585,    0,   -6,   -6,  596,   -6,   -6,   -6,   -6,   -6,
   -6,   -6,   -6,   -6,   -6,   -6,  324,  324,  324,  599,
    0,    0,    0,    0,    0,  553,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1624,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  636,    0,  273,  154,  354,  354,    0,   96,   71,  337,
  354,    0,  626,  354,    0,  563, 2056,    0,    0, 2056,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  628,  629,  630,    0, 2221, 2221, 2327, 2274,
  410,  411,    0,    0,    0,    0,  354,    0,    0,    0,
  364,  316,  327,  139,    0,  600,    0,  600,  354,  659,
  660,    0,    0,    0,    0,    0,    0, -200,    0,    0,
  596,    0,  663,  645,    0,   96,    0,   71, 2379,  647,
  661,  600,  237,  231,  679,  690,    0,  364,  139,  695,
  444,  477,  688,  231,  354,  231, 2056,   -6,  486,    0,
  444,  444,  354,  657,  563,  749,    0,   -6,    0,  486,
  486,  600,  751,  735,  354,  702,    0,    0,    0,  737,
 2056,  477,  738,    0,  477,  757,  444,  444,  444,  706,
    0,  486,    0,    0,    0,
};
static const YYINT yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -19,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  121,
    0,   22,    0,    0,    0,    0,    0,    0, 1024,    0,
    0,    0,    0,    0,    0,    0,    0,  494,    0,    0,
    0,    0,    0,   30,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  525,    0,    0,    0,    0,    0,    0,    0,    0,
  689,  766,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  174,   93,    0,    0,  689,    0,    0,    0,
   59,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  132,    0,    0,    0,  755,    0,  119,    0,    0,
    0,    0, 1137,    0,    0,    0,    0,    0,   75,    0,
  -15,    0,    0,    0,  774,   64,   64,    0,    0,  119,
  755,    0,    0,    0,    0,  366,    0,    0,  371,    0,
  689,    0,    0,  371,    0,    0,    0,  777,    0,  783,
  784,  785,  786,  787,    0,  788,  789,    0,  797,  798,
    0,    0,    0,    0,  689,    0,    0,    0,    0,    0,
    0,    0,    0,  808,    0,    0,    0,   50,   50,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  301,  301,  301,  334,  334,    0,    0,
  334,    0,  408,  301,    0,  812,    0,    0,    0,    0,
    0,  344,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  799,    0,  814,    0,    0,    0,  371,
    0,    0,    0,    0,    0,    0,    0,   49,  217,    0,
    0,    0,  740,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  406,    0,    0,    0,    0,    0,  271,  271,
  271,  413,  413,  371,  371,  413, 2169,    0,  271,   14,
    0,    0,  504,    0,   14,    0,  455,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  827,  827,    9,    0,    0,    0,  790,    0,
    0,    0,    0,  863,  408,  408,  408,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  415,    0,    0,
    0,   65,    0,    0,    0,   65,    0,    0,  802,    0,
   14,    0,    0,    0,    0,    0,    0,    0,  791,    0,
    0, 2169,   21,    0,    0,    0,    0,    0,    0,    0,
    0,  334,  334,    0,    0,    0,    0,    0,    0, 2169,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  148,
    0,  170,    0,    0,  170,    0,    0,    0,    0,   65,
    0,    0,    0,    0,  -11,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  851,  851,  851,    0,
    0,    0, 1748,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  791,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -78,    0,    0,  414,  413,  413,    0,  194,  419,    0,
   66,    0,    0,   66,    0,  170,  371,    0,    0,  371,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  755,    0,    0,    0,
  421,    0,    0,  423,    0,  853,    0,  853,   66,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2169,    0,    0,    0,    0,
    0,  853,  -13,  200,    0,    0,    0,  427,  435,    0,
  573,  684,    0,  200,   66,  218,  371,    0,  913,    0,
  573,  573,   66,  855,  115,    0,    0,    0,    0,  913,
  913,  853,    0,    0,  755,    0,    0,    0,    0,    0,
  371, 1324,    0,    0,  -43,    0, 1444, 1234,   58,    0,
    0, 1534,    0,    0,    0,
};
static const YYINT yygindex[] = {                         0,
  587,    0,   -2,   -5,  916, -192,    0, -137, -328,    0,
 -291,    0,   24,  726, -302,    0, -368,   86, -320,    0,
  -98, -458,  124,    0,    0,    0,    0,    0, -128,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   -9,    0, -370, -209,    0, -342, -144,    0,    0,
  -30,   79, -111,    0,  668,    0,    0,    0,  758,  -23,
    0,    0,    0,    0,  576,    0, -156,  931,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -106, -153, -136, -318,
 -314,    0, -313, -311, -163,    8,   12,  591,    0,    0,
    0,  601,    0,    0,    0,    0,    0,  686,    0,    0,
  698,    0,    0,    0,  589,    0,    0,  763,    0,    0,
    0,    0,    0,    0,  608,    0,  475,    0,    0,    0,
  424,    0,  -44,    0,    0,  437,    0,    0,    0,
};
#define YYTABLESIZE 2768
static const YYINT yytable[] = {                        121,
   66,  123,  124,  125,  126,  127,  128,  129,  143,  144,
  113,  271,  131,  226,  114,  136,  137,  138,  345,  180,
  345,  345,  345,  200,  345,   83,  174,  345,  332,  144,
  174,  172,  386,  282,  228,  188,  182,  162,  297,  309,
  192,  345,  345,  408,  222,  282,  152,  153,  174,  551,
  252,  154,  154,  253,  205,  154,  478,  161,  311,  342,
  282,  342,  342,  342,  286,  342,  514,  337,  342,  337,
  337,  337,  282,  337,  282,  166,  337,  282,  585,  242,
  482,  297,  342,  342,  483,  484,  204,  485,  440,  268,
  337,  337,  202,  159,  435,  202,  346,  341,  346,  346,
  346,  183,  346,  345,  282,  346,  179,  202,  286,  142,
  198,  367,  339,  291,  339,  339,  339,  588,  339,  346,
  346,  339,  198,  367,  286,  367,  301,  302,  373,  347,
  339,  370,  371,  154,  339,  339,  339,  307,  375,  189,
  374,  396,  164,  165,  342,  286,  478,  559,  516,  356,
  189,  189,  337,  173,  167,  367,  286,  167,  333,  333,
  202,  284,  333,  225,  346,  333,  357,  143,  231,  202,
  482,  202,  286,  284,  483,  484,  267,  485,   51,  333,
  333,  346,  299,  548,  347,  175,  198,  337,  175,  175,
  175,  175,  175,  245,  175,  139,  140,  339,  152,  152,
  152,  363,  223,  295,  384,  356,  222,  365,  366,  367,
  368,  369,  248,  298,  372,  189,  284,  380,  115,  346,
  195,  376,  357,  319,  320,  321,  322,  323,  284,  581,
  326,  195,  195,  329,  184,  486,  615,  184,  190,  618,
  619,   66,  479,  143,  276,  480,  367,  116,  297,  297,
  297,  113,  117,  593,   51,  114,  269,  297,  367,  345,
  284,  635,  481,  199,  367,  277,  334,  174,  503,  118,
  467,  175,  175,  338,  270,  199,  367,  243,  367,  191,
  594,  305,  181,  620,  296,  154,  154,  154,  297,  269,
  367,  501,  595,  175,  297,  176,  195,  286,  286,  286,
  342,  132,  603,  500,  605,   66,  171,  292,  337,  343,
  344,  286,  122,  547,  286,  113,  269,   27,  171,  114,
   83,  507,  171,  174,  560,  486,  387,  561,  298,  316,
  133,  286,  479,  393,  394,  480,  134,  346,  345,  199,
  135,  143,  395,  105,  143,  282,  174,  143,   50,   21,
  299,  299,  481,  339,  345,  430,  575,  145,  299,  576,
  467,  143,  313,  140,  314,  284,  283,  577,  343,  344,
  578,  339,  282,  428,  143,  146,   27,  143,  436,  342,
  143,  505,  506,  149,  150,  151,  155,  337,  152,  299,
  148,  610,  611,  549,  550,  299,   66,  333,  158,  556,
  159,  418,  558,  202,  606,  416,  415,   50,  414,  290,
  417,  304,  290,  345,  304,  163,  346,  631,  632,  633,
   19,   20,  355,  512,  175,  175,  175,  515,  626,  315,
  285,  286,  339,  518,  519,  574,  521,  522,  523,  524,
  525,  526,  527,  528,  529,  530,  531,  582,  156,   98,
  339,  156,   98,  286,  107,  157,  286,  100,  157,  369,
  100,  185,  369,  370,  185,  169,  370,  186,  105,  105,
  186,  174,  166,  171,  166,  371,  333,  627,  371,  189,
  629,  534,  535,  604,  194,  554,   66,  419,  409,  410,
  411,  612,  566,  567,  177,  195,  199,  196,   32,  229,
  166,  233,  234,  623,  235,  237,  236,  244,  166,  166,
  166,  166,  166,  166,  166,  166,  166,  166,  166,  166,
  166,  166,  166,  166,  272,  245,  166,  166,  248,  251,
  273,  274,  275,  278,   66,   66,  568,   66,  279,  166,
  166,  280,  281,  282,  287,  288,  569,  166,  166,  166,
  166,  289,  290,  293,  589,  303,  304,  324,  166,  325,
  327,  330,  331,  333,  335,  336,  339,  340,  351,  352,
  361,  364,  299,  381,   27,  388,  590,  390,  391,  107,
  107,  399,  402,  406,  404,  407,  412,  413,  607,  431,
  433,  437,  439,  441,  442,  504,  508,  498,  617,  499,
  105,  105,  105,  105,  105,  105,  105,  502,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  509,
  105,  105,  105,  510,  517,  513,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  520,  532,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  536,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  542,  545,
  105,  105,  555,  297,  557,  562,  563,  564,  571,  573,
  579,  105,  105,  105,  105,  105,  105,  299,  299,  583,
  584,  105,  586,  587,  105,  591,  105,  105,  105,  105,
  105,  107,  107,  107,  107,  107,  107,  107,  204,  592,
  107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
  596,  107,  107,  107,  597,  598,  443,  107,  107,  107,
  107,  107,  107,  107,  107,  107,  602,  613,  107,  107,
  107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
  107,  107,  107,  107,  107,  107,  107,  608,  107,  107,
  107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
  107,  107,  107,  107,  107,  107,  107,  107,  107,  616,
  621,  107,  107,  622,  624,  625,  628,  630,  634,  192,
  141,  109,  107,  107,  107,  107,  107,  107,  297,  297,
  143,  286,  107,  286,   87,  107,  254,  107,  107,  107,
  107,  107,  253,  255,  256,  258,  259,  276,  280,  299,
  299,  299,  299,  299,  299,  299,  257,  260,  261,  299,
  299,  299,  299,  299,  299,  299,  299,  299,  143,  299,
  299,  299,  303,  262,  299,  299,  299,  299,  299,  299,
  299,  299,  299,  299,  145,  115,  299,  299,  299,  299,
  299,  299,  299,  299,  299,  299,  299,  299,  299,  299,
  299,  299,  299,  299,  299,  203,  299,  299,  299,  299,
  299,  299,  299,  299,  299,  299,  299,  299,  299,  299,
  299,  299,  299,  299,  299,  299,  299,  100,  236,  299,
  299,  245,  301,  243,  146,  241,  247,  383,   68,  318,
  299,  299,  299,  299,  299,  299,  109,  109,  227,  401,
  299,    4,  392,  299,  312,  299,  299,  299,  299,  299,
  297,  297,  297,  310,  297,  297,  297,  405,  397,  239,
  297,  297,  297,  297,  297,  297,  297,  297,  297,  398,
  297,  297,  297,  544,  572,  297,  297,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  570,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
  297,  297,  297,  297,  297,  297,    0,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  297,    0,    0,
  297,  297,    0,  286,    0,    0,    0,    0,    0,    0,
    0,  297,  297,  297,  297,  297,  297,  301,  301,    0,
    0,  297,    0,    0,  297,    0,  297,  297,  297,  297,
  297,    0,    0,    0,    0,    0,    0,    0,  109,  109,
  109,  109,  109,  109,  109,    0,    0,    0,  109,  109,
  109,  109,  109,  109,  109,  109,  109,    0,  109,  109,
  109,    0,    0,    0,  109,  109,  109,  109,  109,  109,
  109,  109,  109,    0,    0,  109,  109,  109,  109,  109,
  109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
  109,  109,  109,  109,    0,  109,  109,  109,  109,  109,
  109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
  109,  109,  109,  109,  109,  109,  100,    0,  109,  109,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  109,
  109,  109,  109,  109,  109,    0,    0,    0,    0,  109,
    0,    0,  109,    0,  109,  109,  109,  109,  109,  301,
  301,  301,  301,  301,  301,  301,    0,    0,    0,  301,
  301,  301,  301,  301,  301,  301,  301,  301,    0,  301,
  301,  301,    0,    0,    0,  301,  301,  301,  301,  301,
  301,  301,  301,  301,    0,    0,  301,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
  301,  301,  301,  301,  301,    0,  301,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  301,    0,    0,  301,
  301,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  301,  301,  301,  301,  301,  301,    0,    0,    0,    0,
  301,    0,    0,  301,    0,  301,  301,  301,  301,  301,
  286,  286,  286,    0,  286,  286,  286,    0,    0,    0,
  286,  286,  286,  286,  286,    0,  286,  286,  286,    0,
  286,  286,  286,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  286,
  286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
  286,    0,    0,    0,    0,    0,    0,    0,  286,  286,
  286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
  286,  286,  286,  286,    0,  286,  286,  286,  299,  299,
  286,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  286,  286,  286,  286,  286,  286,    0,    0,    0,
    0,  286,    0,    0,  286,    0,    0,  286,  286,  286,
  286,    0,    0,  100,  100,  100,    0,  100,  100,  100,
    0,    0,    0,  100,  100,  100,  100,  100,    0,  100,
  100,  100,    0,  100,  100,  100,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  100,  100,  100,  100,  100,  100,  100,  100,
  100,  100,  100,  100,    0,    0,    0,    0,  297,  297,
    0,  100,  100,  100,  100,  100,  100,  100,  100,  100,
  100,  100,  100,  100,  100,  100,  100,    0,  100,  100,
  100,    0,    0,  100,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  100,  100,  100,  100,  100,  100,
    0,    0,    0,  299,  100,    0,    0,  100,    0,    0,
  100,  100,  100,  100,    0,  299,    0,    0,    0,    0,
  299,  299,  299,    0,    0,  299,  299,  299,  299,  299,
  299,  299,  299,  299,  299,    0,    0,  299,  299,    0,
    0,    0,    0,    0,  299,    0,    0,    0,    0,  299,
  299,  299,  299,  299,  299,  299,    0,  299,  299,  299,
  299,  299,  299,  299,  299,  299,  299,  299,  299,  299,
  299,  299,  299,  299,  299,  299,  299,  299,  299,  299,
  299,  299,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  299,  299,    0,    0,    0,    0,    0,    0,    0,
    0,  299,    0,    0,  299,  297,  299,    0,  299,    0,
  297,  297,  297,    0,    0,    0,  297,  297,  297,  297,
  297,  297,  297,  297,  297,  297,    0,  297,  297,    0,
    0,    0,    0,    0,  297,    0,    0,    0,    0,  297,
  297,  297,  297,  297,  297,  297,    0,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  297,  301,  301,
  297,  297,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  297,  297,    0,    0,    0,    0,    0,    0,    0,
    0,  297,    0,    0,  297,    0,  297,    0,  297,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  299,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  299,    0,    0,    0,    0,
  299,  299,  299,    0,    0,    0,  299,  299,  299,  299,
  299,  299,  299,  299,  299,    0,    0,  299,  299,    0,
    0,    0,    0,    0,  299,    0,    0,    0,  543,  299,
  299,  299,  299,  299,  299,  299,    0,  299,  299,  299,
  299,  299,  299,  299,  299,  299,  299,  299,  299,  299,
  299,  299,  299,  299,  299,  299,  299,  299,    0,    0,
  299,  299,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  299,  299,  301,    0,    0,    0,    0,    0,    0,
    0,  299,    0,    0,  299,  301,  299,    0,  299,    0,
  301,  301,  301,  362,    0,    0,  301,  301,  301,  301,
  301,  301,  301,  301,  301,    0,    0,  301,  301,    0,
    0,    0,    0,    0,  301,    0,    0,    0,    0,  301,
  301,  301,  301,  301,  301,  301,    0,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  301,  301,  301,  301,
  301,  301,  301,  301,  301,  301,  301,  301,    0,    0,
  301,  301,    0,  248,    0,    0,    0,    0,    0,    0,
    0,  301,  301,  443,    0,    0,    0,    0,    0,    0,
    0,  301,    0,    0,  301,  444,  301,    0,  301,    0,
   19,   20,  445,    0,    0,    0,  446,  447,  448,  449,
  450,  451,  452,  453,  454,    0,    0,  455,  456,    0,
    0,    0,    0,    0,   27,    0,    0,    0,    0,   32,
   33,  457,  458,  459,  460,  461,    0,  462,   34,   35,
   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
   46,   47,   48,   49,  463,   50,   51,   52,    0,    0,
   53,  464,    0,    0,    0,   19,   20,   21,    0,    0,
    0,   54,   55,    0,    0,    0,    0,    0,    0,    0,
    0,   60,    0,    0,   61,    0,  465,    0,   63,   27,
    0,    0,    0,    0,   32,   33,    0,    0,    0,    0,
    0,    0,    0,   34,   35,   36,   37,   38,   39,   40,
   41,   42,   43,   44,   45,   46,   47,   48,   49,    0,
   50,   51,   52,    0,    0,   53,  326,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   54,   55,    0,    0,
    0,    0,    0,    0,    0,    0,   60,    0,    0,   61,
    0,    0,   62,   63,  326,    0,    0,    0,    0,    0,
    0,    0,  326,  326,  326,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,    0,    0,
  326,  326,    0,    0,  326,    0,    5,    6,    7,    0,
    8,    9,   10,    0,    0,    0,   11,   12,   13,   14,
   15,    0,   16,   17,   18,  326,   19,   20,   21,    0,
    0,    0,  326,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,   33,    0,    0,    0,
    0,    0,    0,    0,   34,   35,   36,   37,   38,   39,
   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
    0,   50,   51,   52,    0,    0,   53,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   54,   55,   56,
   57,   58,   59,    0,    0,  443,    0,   60,    0,    0,
   61,    0,    0,   62,   63,   64,   65,  444,    0,    0,
    0,    0,   19,   20,  445,    0,    0,    0,  446,  447,
  448,  449,  450,  451,  452,  453,  454,    0,    0,  455,
  456,    0,    0,    0,    0,    0,   27,    0,    0,    0,
    0,   32,   33,  457,  458,  459,  460,  461,    0,  462,
   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
   44,   45,   46,   47,   48,   49,  463,   50,   51,   52,
    0,    0,   53,  464,    0,    0,    0,   19,   20,   21,
    0,    0,    0,   54,   55,  207,    0,    0,    0,  219,
  213,    0,  206,   60,  211,  210,   61,  208,  465,  212,
   63,   27,    0,    0,    0,    0,   32,   33,    0,    0,
    0,    0,  216,  209,  217,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
   49,    0,   50,   51,   52,    0,    0,   53,    0,    0,
    0,    0,    0,  218,   21,    0,  220,    0,   54,   55,
    0,    0,    0,    0,    0,    0,    0,    0,   60,    0,
    0,   61,    0,    0,   62,   63,    0,    0,    0,    0,
    0,    0,  130,    0,    0,    0,  214,    0,  215,    0,
   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
   44,   45,   46,   47,   48,   49,    0,    0,   51,   52,
    0,   21,   53,  421,  254,  255,  256,  257,  258,  259,
  260,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  261,    0,    0,    0,  130,
   63,    0,    0,    0,    0,    0,    0,   34,   35,   36,
   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
   47,   48,   49,    0,    0,   51,   52,  166,    0,  166,
    0,    0,    0,    0,    0,    0,    0,    0,  422,  423,
    0,    0,    0,    0,    0,    0,  424,  425,  426,  427,
    0,    0,    0,    0,    0,  166,    0,   63,    0,    0,
    0,    0,    0,  166,  166,  166,  166,  166,  166,  166,
  166,  166,  166,  166,  166,  166,  166,  166,  166,   21,
    0,  166,  166,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  166,  166,    0,    0,    0,    0,
    0,    0,  166,  166,  166,  166,    0,  130,    0,    0,
    0,    0,    0,  166,    0,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
   49,  565,   21,   51,   52,    0,    0,   53,  464,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   60,    0,
  130,    0,    0,    0,    0,   63,    0,    0,   34,   35,
   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
   46,   47,   48,   49,  565,   21,   51,   52,    0,    0,
   53,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   60,    0,  130,    0,    0,    0,    0,   63,    0,
    0,   34,   35,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45,   46,   47,   48,   49,   21,    0,   51,
   52,    0,    0,   53,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   21,    0,    0,   60,  130,    0,    0,    0,    0,
    0,   63,    0,   34,   35,   36,   37,   38,   39,   40,
   41,   42,   43,   44,   45,   46,   47,   48,   49,  130,
    0,   51,   52,    0,    0,   53,    0,   34,   35,   36,
   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
   47,   48,   49,    0,    0,   51,   52,    0,    0,    0,
    0,    0,    0,   63,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   63,
};
static const YYINT yycheck[] = {                          9,
    3,   11,   12,   13,   14,   15,   16,   17,   32,   33,
    3,  204,   18,  170,    3,   25,   26,   27,   38,  131,
   40,   41,   42,   40,   44,   41,   38,   47,   41,   45,
   42,   60,  335,   47,  172,  147,   33,   61,   33,  125,
   40,   61,   62,  364,   42,   59,  125,   53,   60,  508,
   44,   54,   44,   47,  166,   47,  399,   60,  125,   38,
   47,   40,   41,   42,   44,   44,  435,   38,   47,   40,
   41,   42,   59,   44,   61,  279,   47,   91,  279,  191,
  399,  125,   61,   62,  399,  399,   40,  399,  391,  201,
   61,   62,   44,   47,  386,   47,   38,  290,   40,   41,
   42,  132,   44,  123,   91,   47,  130,   59,   59,   31,
   47,   47,   38,  225,   40,   41,   42,  576,   44,   61,
   62,   47,   59,   59,   59,   61,  238,  239,   33,  293,
   38,  324,  325,  125,   42,   61,   62,  244,   43,   47,
   45,  125,   64,   65,  123,  125,  489,  516,  440,  303,
   58,   59,  123,   75,  358,   91,   91,  358,   40,   41,
  163,   47,   44,  169,  293,   47,  303,   47,  178,  172,
  489,  123,  123,   59,  489,  489,  200,  489,   47,   61,
   62,  123,  125,  504,  348,   38,  123,   40,   41,   42,
   43,   44,   45,  279,   47,  279,  280,  123,  277,  278,
  279,  308,   38,  234,  333,  359,   42,  319,  320,  321,
  322,  323,  279,  237,  326,  123,   47,  329,  279,  348,
   47,  126,  359,  254,  255,  256,  257,  258,   59,  558,
  261,   58,   59,  264,   41,  399,  605,   44,  153,  610,
  611,  244,  399,  123,   40,  399,   47,  281,  292,  293,
  294,  244,  279,  582,  123,  244,   44,  301,   59,  279,
   91,  632,  399,   47,   47,   61,  269,  279,  406,  276,
  399,  124,  125,  276,   62,   59,   59,  192,   61,  279,
  583,  279,  279,  612,  279,  277,  278,  279,  332,   44,
   91,  403,  584,  276,  338,  278,  123,  277,  278,  279,
  279,   40,  594,  402,  596,  308,  335,   62,  279,  293,
  294,   41,  280,   41,   44,  308,   44,  301,  335,  308,
  336,  420,  335,  335,  517,  489,  336,  520,  352,  251,
  280,   61,  489,  343,  344,  489,  280,  279,  358,  123,
  280,   41,  345,    0,   44,  359,  358,   47,  332,  279,
  293,  294,  489,  279,  338,  379,   41,  318,  301,   44,
  489,   61,  279,  280,  281,   60,   61,   41,  293,  294,
   44,  279,  359,  379,   41,  279,  301,   44,  388,  358,
   47,  412,  413,  316,  317,  318,  279,  358,  321,  332,
  321,  601,  602,  505,  506,  338,  399,  279,  279,  511,
   47,   38,  514,  406,  597,   42,   43,  332,   45,   44,
   47,   41,   47,  338,   44,   60,  358,  627,  628,  629,
  277,  278,  279,  433,  277,  278,  279,  437,  621,  346,
   61,   62,  358,  443,  444,  547,  446,  447,  448,  449,
  450,  451,  452,  453,  454,  455,  456,  559,   41,   44,
  358,   44,   47,   41,    0,   41,   44,   44,   44,   41,
   47,   41,   44,   41,   44,  275,   44,   41,  125,  126,
   44,  346,  279,  335,  281,   41,  358,  622,   44,  318,
  625,  458,  459,  595,  123,  509,  489,  124,  365,  366,
  367,  603,  537,  538,  280,  123,   40,  279,  306,  346,
  307,  279,   45,  615,   41,   58,  336,  123,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   59,  279,  333,  334,  279,   61,
   41,   61,   61,   61,  537,  538,  539,  540,   61,  346,
  347,   61,   61,   61,   93,   61,  539,  354,  355,  356,
  357,   61,   40,  123,  578,  123,   59,   40,  365,   40,
   61,   41,   44,  123,   41,  264,   61,   61,  279,   44,
   41,   58,    0,  337,  301,  265,  579,   41,   41,  125,
  126,  123,   61,   40,  125,   59,   41,   41,  598,  359,
  362,  266,   59,  279,   59,   45,   40,   59,  608,   59,
  257,  258,  259,  260,  261,  262,  263,   59,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,   40,
  277,  278,  279,   61,   40,  125,  283,  284,  285,  286,
  287,  288,  289,  290,  291,   40,  313,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,   58,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  126,   44,
  337,  338,  346,    0,   59,   58,   58,   58,  279,  279,
   91,  348,  349,  350,  351,  352,  353,  125,  126,   41,
   41,  358,   40,   59,  361,   59,  363,  364,  365,  366,
  367,  257,  258,  259,  260,  261,  262,  263,   40,   59,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
   41,  277,  278,  279,   40,  292,  260,  283,  284,  285,
  286,  287,  288,  289,  290,  291,   59,   91,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,  312,  282,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   41,
   40,  337,  338,   59,   93,   59,   59,   41,   93,  306,
  276,    0,  348,  349,  350,  351,  352,  353,  125,  126,
   45,  123,  358,   59,   41,  361,   40,  363,  364,  365,
  366,  367,   40,   40,   40,   40,   40,   40,   40,  257,
  258,  259,  260,  261,  262,  263,   40,   40,   40,  267,
  268,  269,  270,  271,  272,  273,  274,  275,   41,  277,
  278,  279,   41,   40,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  125,  362,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,   59,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   45,   58,  337,
  338,   59,    0,   59,  125,  190,  126,  331,    3,  252,
  348,  349,  350,  351,  352,  353,  125,  126,  171,  354,
  358,    1,  342,  361,  249,  363,  364,  365,  366,  367,
  257,  258,  259,  246,  261,  262,  263,  359,  348,  187,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  352,
  277,  278,  279,  489,  541,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  540,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,   -1,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
  337,  338,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,  349,  350,  351,  352,  353,  125,  126,   -1,
   -1,  358,   -1,   -1,  361,   -1,  363,  364,  365,  366,
  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,  261,  262,  263,   -1,   -1,   -1,  267,  268,
  269,  270,  271,  272,  273,  274,  275,   -1,  277,  278,
  279,   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,
  289,  290,  291,   -1,   -1,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,   -1,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,    0,   -1,  337,  338,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
  349,  350,  351,  352,  353,   -1,   -1,   -1,   -1,  358,
   -1,   -1,  361,   -1,  363,  364,  365,  366,  367,  257,
  258,  259,  260,  261,  262,  263,   -1,   -1,   -1,  267,
  268,  269,  270,  271,  272,  273,  274,  275,   -1,  277,
  278,  279,   -1,   -1,   -1,  283,  284,  285,  286,  287,
  288,  289,  290,  291,   -1,   -1,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,   -1,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,   -1,  337,
  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,  349,  350,  351,  352,  353,   -1,   -1,   -1,   -1,
  358,   -1,   -1,  361,   -1,  363,  364,  365,  366,  367,
  257,  258,  259,   -1,  261,  262,  263,   -1,   -1,   -1,
  267,  268,  269,  270,  271,   -1,  273,  274,  275,   -1,
  277,  278,  279,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,  332,  333,  334,  125,  126,
  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,  349,  350,  351,  352,  353,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,   -1,  364,  365,  366,
  367,   -1,   -1,  257,  258,  259,   -1,  261,  262,  263,
   -1,   -1,   -1,  267,  268,  269,  270,  271,   -1,  273,
  274,  275,   -1,  277,  278,  279,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,   -1,   -1,   -1,   -1,  125,  126,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   -1,  332,  333,
  334,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,  349,  350,  351,  352,  353,
   -1,   -1,   -1,  260,  358,   -1,   -1,  361,   -1,   -1,
  364,  365,  366,  367,   -1,  272,   -1,   -1,   -1,   -1,
  277,  278,  279,   -1,   -1,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,   -1,   -1,  294,  295,   -1,
   -1,   -1,   -1,   -1,  301,   -1,   -1,   -1,   -1,  306,
  307,  308,  309,  310,  311,  312,   -1,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  125,  126,
  337,  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,  349,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,  272,  363,   -1,  365,   -1,
  277,  278,  279,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,   -1,  294,  295,   -1,
   -1,   -1,   -1,   -1,  301,   -1,   -1,   -1,   -1,  306,
  307,  308,  309,  310,  311,  312,   -1,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  125,  126,
  337,  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,  349,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,  363,   -1,  365,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  260,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
  277,  278,  279,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,  290,  291,   -1,   -1,  294,  295,   -1,
   -1,   -1,   -1,   -1,  301,   -1,   -1,   -1,  125,  306,
  307,  308,  309,  310,  311,  312,   -1,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
  337,  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,  349,  260,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,  272,  363,   -1,  365,   -1,
  277,  278,  279,  125,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,  290,  291,   -1,   -1,  294,  295,   -1,
   -1,   -1,   -1,   -1,  301,   -1,   -1,   -1,   -1,  306,
  307,  308,  309,  310,  311,  312,   -1,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
  337,  338,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,  349,  260,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,  272,  363,   -1,  365,   -1,
  277,  278,  279,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,  290,  291,   -1,   -1,  294,  295,   -1,
   -1,   -1,   -1,   -1,  301,   -1,   -1,   -1,   -1,  306,
  307,  308,  309,  310,  311,  312,   -1,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
  337,  338,   -1,   -1,   -1,  277,  278,  279,   -1,   -1,
   -1,  348,  349,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,  363,   -1,  365,  301,
   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
  332,  333,  334,   -1,   -1,  337,  279,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,  349,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,
   -1,   -1,  364,  365,  307,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,   -1,   -1,
  333,  334,   -1,   -1,  337,   -1,  257,  258,  259,   -1,
  261,  262,  263,   -1,   -1,   -1,  267,  268,  269,  270,
  271,   -1,  273,  274,  275,  358,  277,  278,  279,   -1,
   -1,   -1,  365,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  315,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
   -1,  332,  333,  334,   -1,   -1,  337,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,  349,  350,
  351,  352,  353,   -1,   -1,  260,   -1,  358,   -1,   -1,
  361,   -1,   -1,  364,  365,  366,  367,  272,   -1,   -1,
   -1,   -1,  277,  278,  279,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,  290,  291,   -1,   -1,  294,
  295,   -1,   -1,   -1,   -1,   -1,  301,   -1,   -1,   -1,
   -1,  306,  307,  308,  309,  310,  311,  312,   -1,  314,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,   -1,  337,  338,   -1,   -1,   -1,  277,  278,  279,
   -1,   -1,   -1,  348,  349,   33,   -1,   -1,   -1,   37,
   38,   -1,   40,  358,   42,   43,  361,   45,  363,   47,
  365,  301,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,
   -1,   -1,   60,   61,   62,  315,  316,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,   -1,  332,  333,  334,   -1,   -1,  337,   -1,   -1,
   -1,   -1,   -1,   91,  279,   -1,   94,   -1,  348,  349,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,
   -1,  361,   -1,   -1,  364,  365,   -1,   -1,   -1,   -1,
   -1,   -1,  307,   -1,   -1,   -1,  124,   -1,  126,   -1,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,   -1,   -1,  333,  334,
   -1,  279,  337,  281,  339,  340,  341,  342,  343,  344,
  345,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,   -1,  307,
  365,   -1,   -1,   -1,   -1,   -1,   -1,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,   -1,  333,  334,  279,   -1,  281,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  346,  347,
   -1,   -1,   -1,   -1,   -1,   -1,  354,  355,  356,  357,
   -1,   -1,   -1,   -1,   -1,  307,   -1,  365,   -1,   -1,
   -1,   -1,   -1,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  279,
   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  346,  347,   -1,   -1,   -1,   -1,
   -1,   -1,  354,  355,  356,  357,   -1,  307,   -1,   -1,
   -1,   -1,   -1,  365,   -1,  315,  316,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  279,  333,  334,   -1,   -1,  337,  338,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,
  307,   -1,   -1,   -1,   -1,  365,   -1,   -1,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  279,  333,  334,   -1,   -1,
  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,  307,   -1,   -1,   -1,   -1,  365,   -1,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  279,   -1,  333,
  334,   -1,   -1,  337,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  279,   -1,   -1,  358,  307,   -1,   -1,   -1,   -1,
   -1,  365,   -1,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  307,
   -1,  333,  334,   -1,   -1,  337,   -1,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,   -1,  333,  334,   -1,   -1,   -1,
   -1,   -1,   -1,  365,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  365,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 367
#define YYUNDFTOKEN 519
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,
0,0,0,0,0,"':'","';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TK_API",
"TK_DEFENCODING","TK_PLUGIN","TK_DOCSTRING","TK_DOC","TK_EXPORTEDDOC",
"TK_MAKEFILE","TK_ACCESSCODE","TK_GETCODE","TK_SETCODE","TK_PREINITCODE",
"TK_INITCODE","TK_POSTINITCODE","TK_UNITCODE","TK_MODCODE","TK_TYPECODE",
"TK_PREPYCODE","TK_COPYING","TK_MAPPEDTYPE","TK_CODELINE","TK_IF","TK_END",
"TK_NAME","TK_PATHNAME","TK_STRING","TK_VIRTUALCATCHERCODE","TK_TRAVERSECODE",
"TK_CLEARCODE","TK_GETBUFFERCODE","TK_RELEASEBUFFERCODE","TK_READBUFFERCODE",
"TK_WRITEBUFFERCODE","TK_SEGCOUNTCODE","TK_CHARBUFFERCODE","TK_PICKLECODE",
"TK_METHODCODE","TK_FROMTYPE","TK_TOTYPE","TK_TOSUBCLASS","TK_INCLUDE",
"TK_OPTINCLUDE","TK_IMPORT","TK_EXPHEADERCODE","TK_MODHEADERCODE",
"TK_TYPEHEADERCODE","TK_MODULE","TK_CMODULE","TK_CONSMODULE","TK_COMPOMODULE",
"TK_CLASS","TK_STRUCT","TK_PUBLIC","TK_PROTECTED","TK_PRIVATE","TK_SIGNALS",
"TK_SIGNAL_METHOD","TK_SLOTS","TK_SLOT_METHOD","TK_BOOL","TK_SHORT","TK_INT",
"TK_LONG","TK_FLOAT","TK_DOUBLE","TK_CHAR","TK_WCHAR_T","TK_VOID","TK_PYOBJECT",
"TK_PYTUPLE","TK_PYLIST","TK_PYDICT","TK_PYCALLABLE","TK_PYSLICE","TK_PYTYPE",
"TK_VIRTUAL","TK_ENUM","TK_SIGNED","TK_UNSIGNED","TK_SCOPE","TK_LOGICAL_OR",
"TK_CONST","TK_STATIC","TK_SIPSIGNAL","TK_SIPSLOT","TK_SIPANYSLOT",
"TK_SIPRXCON","TK_SIPRXDIS","TK_SIPSLOTCON","TK_SIPSLOTDIS","TK_NUMBER",
"TK_REAL","TK_TYPEDEF","TK_NAMESPACE","TK_TIMELINE","TK_PLATFORMS","TK_FEATURE",
"TK_LICENSE","TK_TQCHAR","TK_TRUE","TK_FALSE","TK_NULL","TK_OPERATOR",
"TK_THROW","TK_TQOBJECT","TK_EXCEPTION","TK_RAISECODE","TK_EXPLICIT",
"TK_TEMPLATE","TK_ELLIPSIS","TK_DEFMETATYPE","TK_DEFSUPERTYPE",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : specification",
"specification : statement",
"specification : specification statement",
"$$1 :",
"statement : $$1 modstatement",
"modstatement : module",
"modstatement : consmodule",
"modstatement : compmodule",
"modstatement : plugin",
"modstatement : copying",
"modstatement : include",
"modstatement : optinclude",
"modstatement : import",
"modstatement : api",
"modstatement : timeline",
"modstatement : platforms",
"modstatement : feature",
"modstatement : license",
"modstatement : defencoding",
"modstatement : defmetatype",
"modstatement : defsupertype",
"modstatement : exphdrcode",
"modstatement : modhdrcode",
"modstatement : modcode",
"modstatement : preinitcode",
"modstatement : initcode",
"modstatement : postinitcode",
"modstatement : unitcode",
"modstatement : prepycode",
"modstatement : doc",
"modstatement : exporteddoc",
"modstatement : makefile",
"modstatement : mappedtype",
"modstatement : mappedtypetmpl",
"modstatement : nsstatement",
"nsstatement : ifstart",
"nsstatement : ifend",
"nsstatement : namespace",
"nsstatement : struct",
"nsstatement : class",
"nsstatement : classtmpl",
"nsstatement : exception",
"nsstatement : typedef",
"nsstatement : enum",
"nsstatement : function",
"nsstatement : variable",
"nsstatement : typehdrcode",
"defencoding : TK_DEFENCODING TK_STRING",
"plugin : TK_PLUGIN TK_NAME",
"api : TK_API TK_NAME TK_NUMBER",
"exception : TK_EXCEPTION scopedname baseexception optflags '{' opttypehdrcode raisecode '}' ';'",
"baseexception :",
"baseexception : '(' scopedname ')'",
"raisecode : TK_RAISECODE codeblock",
"$$2 :",
"mappedtype : TK_MAPPEDTYPE basetype optflags $$2 mtdefinition",
"$$3 :",
"mappedtypetmpl : template TK_MAPPEDTYPE basetype optflags $$3 mtdefinition",
"mtdefinition : '{' mtbody '}' ';'",
"mtbody : mtline",
"mtbody : mtbody mtline",
"mtline : typehdrcode",
"mtline : TK_FROMTYPE codeblock",
"mtline : TK_TOTYPE codeblock",
"mtline : enum",
"mtline : mtfunction",
"mtfunction : TK_STATIC cpptype TK_NAME '(' arglist ')' optconst optexceptions optflags optsig ';' optdocstring methodcode",
"$$4 :",
"namespace : TK_NAMESPACE TK_NAME $$4 '{' nsbody '}' ';'",
"nsbody : nsstatement",
"nsbody : nsbody nsstatement",
"$$5 :",
"platforms : TK_PLATFORMS $$5 '{' platformlist '}'",
"platformlist : platform",
"platformlist : platformlist platform",
"platform : TK_NAME",
"feature : TK_FEATURE TK_NAME",
"$$6 :",
"timeline : TK_TIMELINE $$6 '{' qualifierlist '}'",
"qualifierlist : qualifiername",
"qualifierlist : qualifierlist qualifiername",
"qualifiername : TK_NAME",
"ifstart : TK_IF '(' qualifiers ')'",
"oredqualifiers : TK_NAME",
"oredqualifiers : '!' TK_NAME",
"oredqualifiers : oredqualifiers TK_LOGICAL_OR TK_NAME",
"oredqualifiers : oredqualifiers TK_LOGICAL_OR '!' TK_NAME",
"qualifiers : oredqualifiers",
"qualifiers : optname '-' optname",
"ifend : TK_END",
"license : TK_LICENSE optflags",
"defmetatype : TK_DEFMETATYPE dottedname",
"defsupertype : TK_DEFSUPERTYPE dottedname",
"consmodule : TK_CONSMODULE dottedname",
"compmodule : TK_COMPOMODULE dottedname",
"module : modlang dottedname optnumber",
"modlang : TK_MODULE",
"modlang : TK_CMODULE",
"dottedname : TK_NAME",
"dottedname : TK_PATHNAME",
"optnumber :",
"optnumber : TK_NUMBER",
"include : TK_INCLUDE TK_PATHNAME",
"optinclude : TK_OPTINCLUDE TK_PATHNAME",
"import : TK_IMPORT TK_PATHNAME",
"optaccesscode :",
"optaccesscode : TK_ACCESSCODE codeblock",
"optgetcode :",
"optgetcode : TK_GETCODE codeblock",
"optsetcode :",
"optsetcode : TK_SETCODE codeblock",
"copying : TK_COPYING codeblock",
"exphdrcode : TK_EXPHEADERCODE codeblock",
"modhdrcode : TK_MODHEADERCODE codeblock",
"typehdrcode : TK_TYPEHEADERCODE codeblock",
"opttypehdrcode :",
"opttypehdrcode : typehdrcode",
"travcode : TK_TRAVERSECODE codeblock",
"clearcode : TK_CLEARCODE codeblock",
"getbufcode : TK_GETBUFFERCODE codeblock",
"releasebufcode : TK_RELEASEBUFFERCODE codeblock",
"readbufcode : TK_READBUFFERCODE codeblock",
"writebufcode : TK_WRITEBUFFERCODE codeblock",
"segcountcode : TK_SEGCOUNTCODE codeblock",
"charbufcode : TK_CHARBUFFERCODE codeblock",
"picklecode : TK_PICKLECODE codeblock",
"modcode : TK_MODCODE codeblock",
"typecode : TK_TYPECODE codeblock",
"preinitcode : TK_PREINITCODE codeblock",
"initcode : TK_INITCODE codeblock",
"postinitcode : TK_POSTINITCODE codeblock",
"unitcode : TK_UNITCODE codeblock",
"prepycode : TK_PREPYCODE codeblock",
"doc : TK_DOC codeblock",
"exporteddoc : TK_EXPORTEDDOC codeblock",
"makefile : TK_MAKEFILE TK_PATHNAME optfilename codeblock",
"codeblock : codelines TK_END",
"codelines : TK_CODELINE",
"codelines : codelines TK_CODELINE",
"$$7 :",
"enum : TK_ENUM optname optflags $$7 '{' optenumbody '}' ';'",
"optfilename :",
"optfilename : TK_PATHNAME",
"optname :",
"optname : TK_NAME",
"optenumbody :",
"optenumbody : enumbody",
"enumbody : enumline",
"enumbody : enumbody enumline",
"enumline : ifstart",
"enumline : ifend",
"enumline : TK_NAME optenumassign optflags optcomma",
"optcomma :",
"optcomma : ','",
"optenumassign :",
"optenumassign : '=' value",
"optassign :",
"optassign : '=' expr",
"expr : value",
"expr : expr binop value",
"binop : '-'",
"binop : '+'",
"binop : '*'",
"binop : '/'",
"binop : '&'",
"binop : '|'",
"optunop :",
"optunop : '!'",
"optunop : '~'",
"optunop : '-'",
"optunop : '+'",
"value : optunop simplevalue",
"scopedname : scopepart",
"scopedname : scopedname TK_SCOPE scopepart",
"scopepart : TK_NAME",
"simplevalue : scopedname",
"simplevalue : basetype '(' exprlist ')'",
"simplevalue : TK_REAL",
"simplevalue : TK_NUMBER",
"simplevalue : TK_TRUE",
"simplevalue : TK_FALSE",
"simplevalue : TK_NULL",
"simplevalue : TK_STRING",
"simplevalue : TK_TQCHAR",
"exprlist :",
"exprlist : expr",
"exprlist : exprlist ',' expr",
"typedef : TK_TYPEDEF cpptype TK_NAME optflags ';'",
"typedef : TK_TYPEDEF cpptype '(' deref TK_NAME ')' '(' cpptypelist ')' optflags ';'",
"$$8 :",
"$$9 :",
"struct : TK_STRUCT scopedname $$8 superclasses optflags $$9 optclassbody ';'",
"$$10 :",
"classtmpl : template $$10 class",
"template : TK_TEMPLATE '<' cpptypelist '>'",
"$$11 :",
"$$12 :",
"class : TK_CLASS scopedname $$11 superclasses optflags $$12 optclassbody ';'",
"superclasses :",
"superclasses : ':' superlist",
"superlist : superclass",
"superlist : superlist ',' superclass",
"superclass : scopedname",
"optclassbody :",
"optclassbody : '{' classbody '}'",
"classbody : classline",
"classbody : classbody classline",
"classline : ifstart",
"classline : ifend",
"classline : namespace",
"classline : struct",
"classline : class",
"classline : exception",
"classline : typedef",
"classline : enum",
"classline : docstring",
"classline : typecode",
"classline : typehdrcode",
"classline : travcode",
"classline : clearcode",
"classline : getbufcode",
"classline : releasebufcode",
"classline : readbufcode",
"classline : writebufcode",
"classline : segcountcode",
"classline : charbufcode",
"classline : picklecode",
"classline : ctor",
"classline : dtor",
"classline : varmember",
"classline : TK_TOSUBCLASS codeblock",
"classline : TK_TOTYPE codeblock",
"classline : TK_PUBLIC optslot ':'",
"classline : TK_PROTECTED optslot ':'",
"classline : TK_PRIVATE optslot ':'",
"classline : TK_SIGNALS ':'",
"optslot :",
"optslot : TK_SLOTS",
"dtor : optvirtual '~' TK_NAME '(' ')' optexceptions optabstract optflags ';' methodcode virtualcatchercode",
"$$13 :",
"ctor : TK_EXPLICIT $$13 simplector",
"ctor : simplector",
"simplector : TK_NAME '(' arglist ')' optexceptions optflags optctorsig ';' optdocstring methodcode",
"optctorsig :",
"optctorsig : '[' '(' arglist ')' ']'",
"optsig :",
"optsig : '[' cpptype '(' arglist ')' ']'",
"optvirtual :",
"optvirtual : TK_VIRTUAL",
"function : cpptype TK_NAME '(' arglist ')' optconst optexceptions optabstract optflags optsig ';' optdocstring methodcode virtualcatchercode",
"function : cpptype TK_OPERATOR '=' '(' cpptype ')' ';'",
"function : cpptype TK_OPERATOR operatorname '(' arglist ')' optconst optexceptions optabstract optflags optsig ';' methodcode virtualcatchercode",
"function : TK_OPERATOR cpptype '(' arglist ')' optconst optexceptions optabstract optflags optsig ';' methodcode virtualcatchercode",
"operatorname : '+'",
"operatorname : '-'",
"operatorname : '*'",
"operatorname : '/'",
"operatorname : '%'",
"operatorname : '&'",
"operatorname : '|'",
"operatorname : '^'",
"operatorname : '<' '<'",
"operatorname : '>' '>'",
"operatorname : '+' '='",
"operatorname : '-' '='",
"operatorname : '*' '='",
"operatorname : '/' '='",
"operatorname : '%' '='",
"operatorname : '&' '='",
"operatorname : '|' '='",
"operatorname : '^' '='",
"operatorname : '<' '<' '='",
"operatorname : '>' '>' '='",
"operatorname : '~'",
"operatorname : '(' ')'",
"operatorname : '[' ']'",
"operatorname : '<'",
"operatorname : '<' '='",
"operatorname : '=' '='",
"operatorname : '!' '='",
"operatorname : '>'",
"operatorname : '>' '='",
"optconst :",
"optconst : TK_CONST",
"optabstract :",
"optabstract : '=' TK_NUMBER",
"optflags :",
"optflags : '/' flaglist '/'",
"flaglist : flag",
"flaglist : flaglist ',' flag",
"flag : TK_NAME",
"flag : TK_NAME '=' flagvalue",
"flagvalue : dottedname",
"flagvalue : TK_NAME ':' optnumber '-' optnumber",
"flagvalue : TK_STRING",
"flagvalue : TK_NUMBER",
"docstring : TK_DOCSTRING codeblock",
"optdocstring :",
"optdocstring : docstring",
"methodcode :",
"methodcode : TK_METHODCODE codeblock",
"virtualcatchercode :",
"virtualcatchercode : TK_VIRTUALCATCHERCODE codeblock",
"arglist : rawarglist",
"rawarglist :",
"rawarglist : argvalue",
"rawarglist : rawarglist ',' argvalue",
"argvalue : TK_SIPSIGNAL optname optflags optassign",
"argvalue : TK_SIPSLOT optname optflags optassign",
"argvalue : TK_SIPANYSLOT optname optflags optassign",
"argvalue : TK_SIPRXCON optname optflags",
"argvalue : TK_SIPRXDIS optname optflags",
"argvalue : TK_SIPSLOTCON '(' arglist ')' optname optflags",
"argvalue : TK_SIPSLOTDIS '(' arglist ')' optname optflags",
"argvalue : TK_TQOBJECT optname optflags",
"argvalue : argtype optassign",
"$$14 :",
"varmember : TK_SIGNAL_METHOD $$14 simple_varmem",
"$$15 :",
"varmember : TK_SLOT_METHOD $$15 simple_varmem",
"varmember : simple_varmem",
"$$16 :",
"simple_varmem : TK_STATIC $$16 varmem",
"simple_varmem : varmem",
"varmem : member",
"varmem : variable",
"$$17 :",
"member : TK_VIRTUAL $$17 function",
"member : function",
"variable : cpptype TK_NAME optflags ';' optaccesscode optgetcode optsetcode",
"cpptype : TK_CONST basetype deref optref",
"cpptype : basetype deref optref",
"argtype : cpptype optname optflags",
"optref :",
"optref : '&'",
"deref :",
"deref : deref '*'",
"basetype : scopedname",
"basetype : scopedname '<' cpptypelist '>'",
"basetype : TK_STRUCT scopedname",
"basetype : TK_UNSIGNED TK_SHORT",
"basetype : TK_SHORT",
"basetype : TK_UNSIGNED",
"basetype : TK_UNSIGNED TK_INT",
"basetype : TK_INT",
"basetype : TK_LONG",
"basetype : TK_UNSIGNED TK_LONG",
"basetype : TK_LONG TK_LONG",
"basetype : TK_UNSIGNED TK_LONG TK_LONG",
"basetype : TK_FLOAT",
"basetype : TK_DOUBLE",
"basetype : TK_BOOL",
"basetype : TK_SIGNED TK_CHAR",
"basetype : TK_UNSIGNED TK_CHAR",
"basetype : TK_CHAR",
"basetype : TK_WCHAR_T",
"basetype : TK_VOID",
"basetype : TK_PYOBJECT",
"basetype : TK_PYTUPLE",
"basetype : TK_PYLIST",
"basetype : TK_PYDICT",
"basetype : TK_PYCALLABLE",
"basetype : TK_PYSLICE",
"basetype : TK_PYTYPE",
"basetype : TK_ELLIPSIS",
"cpptypelist : cpptype",
"cpptypelist : cpptypelist ',' cpptype",
"optexceptions :",
"optexceptions : TK_THROW '(' exceptionlist ')'",
"exceptionlist :",
"exceptionlist : scopedname",
"exceptionlist : exceptionlist ',' scopedname",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 2730 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"


/*
 * Parse the specification.
 */
void parse(sipSpec *spec, FILE *fp, char *filename, stringList *tsl,
        stringList *xfl, int kwdArgs, int protHack)
{
    classTmplDef *tcd;

    /* Initialise the spec. */
 
    spec->modules = NULL;
    spec->namecache = NULL;
    spec->ifacefiles = NULL;
    spec->classes = NULL;
    spec->classtemplates = NULL;
    spec->exceptions = NULL;
    spec->mappedtypes = NULL;
    spec->mappedtypetemplates = NULL;
    spec->enums = NULL;
    spec->vars = NULL;
    spec->typedefs = NULL;
    spec->exphdrcode = NULL;
    spec->docs = NULL;
    spec->sigslots = FALSE;
    spec->genc = -1;
    spec->plugins = NULL;

    currentSpec = spec;
    neededQualifiers = tsl;
    excludedQualifiers = xfl;
    currentModule = NULL;
    currentMappedType = NULL;
    currentOverIsVirt = FALSE;
    currentCtorIsExplicit = FALSE;
    currentIsStatic = FALSE;
    currentIsSignal = FALSE;
    currentIsSlot = FALSE;
    currentIsTemplate = FALSE;
    previousFile = NULL;
    skipStackPtr = 0;
    currentScopeIdx = 0;
    sectionFlags = 0;
    defaultKwdArgs = kwdArgs;
    makeProtPublic = protHack;

    newModule(fp, filename);
    spec->module = currentModule;

    yyparse();

    handleEOF();
    handleEOM();

    /*
     * Go through each template class and remove it from the list of classes.
     */
    for (tcd = spec->classtemplates; tcd != NULL; tcd = tcd->next)
    {
        classDef **cdp;

        for (cdp = &spec->classes; *cdp != NULL; cdp = &(*cdp)->next)
            if (*cdp == tcd->cd)
            {
                ifaceFileDef **ifdp;

                /* Remove the interface file as well. */
                for (ifdp = &spec->ifacefiles; *ifdp != NULL; ifdp = &(*ifdp)->next)
                    if (*ifdp == tcd->cd->iff)
                    {
                        *ifdp = (*ifdp)->next;
                        break;
                    }

                *cdp = (*cdp)->next;
                break;
            }
    }
}


/*
 * Tell the parser that a complete file has now been read.
 */
void parserEOF(char *name, parserContext *pc)
{
    previousFile = sipStrdup(name);
    currentContext = *pc;
}


/*
 * Append a class definition to a class list if it doesn't already appear.
 * Append is needed specifically for the list of super-classes because the
 * order is important to Python.
 */
void appendToClassList(classList **clp,classDef *cd)
{
    classList *new;

    /* Find the end of the list. */

    while (*clp != NULL)
    {
        if ((*clp) -> cd == cd)
            return;

        clp = &(*clp) -> next;
    }

    new = sipMalloc(sizeof (classList));

    new -> cd = cd;
    new -> next = NULL;

    *clp = new;
}


/*
 * Create a new module for the current specification and make it current.
 */
static void newModule(FILE *fp, char *filename)
{
    moduleDef *mod;

    parseFile(fp, filename, currentModule, FALSE);

    mod = allocModule();
    mod->file = filename;

    if (currentModule != NULL)
        mod->defexception = currentModule->defexception;

    currentModule = mod;
}


/*
 * Allocate and initialise the memory for a new module.
 */
static moduleDef *allocModule()
{
    moduleDef *newmod, **tailp;

    newmod = sipMalloc(sizeof (moduleDef));

    newmod->version = -1;
    newmod->encoding = no_type;
    newmod->tqobjclass = -1;
    newmod->nrvirthandlers = -1;
    newmod->next_key = 1;

    /*
     * The consolidated module support needs these to be in order that they
     * appeared.
     */
    for (tailp = &currentSpec->modules; *tailp != NULL; tailp = &(*tailp)->next)
        ;

    *tailp = newmod;

    return newmod;
}


/*
 * Switch to parsing a new file.
 */
static void parseFile(FILE *fp, char *name, moduleDef *prevmod, int optional)
{
    parserContext pc;

    pc.filename = name;
    pc.ifdepth = skipStackPtr;
    pc.prevmod = prevmod;

    if (setInputFile(fp, &pc, optional))
        currentContext = pc;
}


/*
 * Find an interface file, or create a new one.
 */
ifaceFileDef *findIfaceFile(sipSpec *pt, moduleDef *mod, scopedNameDef *fqname,
        ifaceFileType iftype, apiVersionRangeDef *api_range, argDef *ad)
{
    ifaceFileDef *iff, *first_alt = NULL;

    /* See if the name is already used. */

    for (iff = pt->ifacefiles; iff != NULL; iff = iff->next)
    {
        if (compareScopedNames(iff->fqcname, fqname) != 0)
            continue;

        /*
         * If they are both versioned then assume the user knows what they are
         * doing.
         */
        if (iff->api_range != NULL && api_range != NULL && iff->module == mod)
        {
            /* Remember the first of the alternate APIs. */
            if ((first_alt = iff->first_alt) == NULL)
                first_alt = iff;

            break;
        }

        /*
         * They must be the same type except that we allow a class if we want
         * an exception.  This is because we allow classes to be used before
         * they are defined.
         */
        if (iff->type != iftype)
            if (iftype != exception_iface || iff->type != class_iface)
                yyerror("A class, exception, namespace or mapped type has already been defined with the same name");

        /* Ignore an external class declared in another module. */
        if (iftype == class_iface && iff->module != mod)
        {
            classDef *cd;

            for (cd = pt->classes; cd != NULL; cd = cd->next)
                if (cd->iff == iff)
                    break;

            if (cd != NULL && iff->module != NULL && isExternal(cd))
                continue;
        }

        /*
         * If this is a mapped type with the same name defined in a different
         * module, then check that this type isn't the same as any of the
         * mapped types defined in that module.
         */
        if (iftype == mappedtype_iface && iff->module != mod)
        {
            mappedTypeDef *mtd;

            /*
             * This is a bit of a cheat.  With consolidated modules it's
             * possible to have two implementations of a mapped type in
             * different branches of the module hierarchy.  We assume that, if
             * there really are multiple implementations in the same branch,
             * then it will be picked up in a non-consolidated build.
             */
            if (isConsolidated(pt->module))
                continue;

            for (mtd = pt->mappedtypes; mtd != NULL; mtd = mtd->next)
            {
                if (mtd->iff != iff)
                    continue;

                if (ad->atype != template_type ||
                    mtd->type.atype != template_type ||
                    sameBaseType(ad, &mtd->type))
                    yyerror("Mapped type has already been defined in another module");
            }

            /*
             * If we got here then we have a mapped type based on an existing
             * template, but with unique parameters.  We don't want to use
             * interface files from other modules, so skip this one.
             */

            continue;
        }

        /* Ignore a namespace defined in another module. */
        if (iftype == namespace_iface && iff->module != mod)
            continue;

        return iff;
    }

    iff = sipMalloc(sizeof (ifaceFileDef));

    iff->name = cacheName(pt, scopedNameToString(fqname));
    iff->api_range = api_range;

    if (first_alt != NULL)
    {
        iff->first_alt = first_alt;
        iff->next_alt = first_alt->next_alt;

        first_alt->next_alt = iff;
    }
    else
    {
        /* This is the first alternate so point to itself. */
        iff->first_alt = iff;
    }

    iff->type = iftype;
    iff->ifacenr = -1;
    iff->fqcname = fqname;
    iff->module = NULL;
    iff->hdrcode = NULL;
    iff->used = NULL;
    iff->next = pt->ifacefiles;

    pt->ifacefiles = iff;

    return iff;
}


/*
 * Find a class definition in a parse tree.
 */
static classDef *findClass(sipSpec *pt, ifaceFileType iftype,
        apiVersionRangeDef *api_range, scopedNameDef *fqname)
{
    return findClassWithInterface(pt, findIfaceFile(pt, currentModule, fqname, iftype, api_range, NULL));
}


/*
 * Find a class definition given an existing interface file.
 */
static classDef *findClassWithInterface(sipSpec *pt, ifaceFileDef *iff)
{
    classDef *cd;

    for (cd = pt -> classes; cd != NULL; cd = cd -> next)
        if (cd -> iff == iff)
            return cd;

    /* Create a new one. */
    cd = sipMalloc(sizeof (classDef));

    cd->iff = iff;
    cd->pyname = cacheName(pt, classBaseName(cd));
    cd->next = pt->classes;

    pt->classes = cd;

    return cd;
}


/*
 * Add an interface file to an interface file list if it isn't already there.
 */
void addToUsedList(ifaceFileList **ifflp, ifaceFileDef *iff)
{
    /* Make sure we don't try to add an interface file to its own list. */
    if (&iff->used != ifflp)
    {
        ifaceFileList *iffl;

        while ((iffl = *ifflp) != NULL)
        {
            /* Don't bother if it is already there. */
            if (iffl->iff == iff)
                return;

            ifflp = &iffl -> next;
        }

        iffl = sipMalloc(sizeof (ifaceFileList));

        iffl->iff = iff;
        iffl->next = NULL;

        *ifflp = iffl;
    }
}


/*
 * Find an undefined (or create a new) exception definition in a parse tree.
 */
static exceptionDef *findException(sipSpec *pt, scopedNameDef *fqname, int new)
{
    exceptionDef *xd, **tail;
    ifaceFileDef *iff;
    classDef *cd;

    iff = findIfaceFile(pt, currentModule, fqname, exception_iface, NULL, NULL);

    /* See if it is an existing one. */
    for (xd = pt->exceptions; xd != NULL; xd = xd->next)
        if (xd->iff == iff)
            return xd;

    /*
     * If it is an exception interface file then we have never seen this
     * name before.  We require that exceptions are defined before being
     * used, but don't make the same requirement of classes (for reasons of
     * backwards compatibility).  Therefore the name must be reinterpreted
     * as a (as yet undefined) class.
     */
    if (new)
    {
        if (iff->type == exception_iface)
            cd = NULL;
        else
            yyerror("There is already a class with the same name or the exception has been used before being defined");
    }
    else
    {
        if (iff->type == exception_iface)
            iff->type = class_iface;

        cd = findClassWithInterface(pt, iff);
    }

    /* Create a new one. */
    xd = sipMalloc(sizeof (exceptionDef));

    xd->exceptionnr = -1;
    xd->iff = iff;
    xd->pyname = NULL;
    xd->cd = cd;
    xd->bibase = NULL;
    xd->base = NULL;
    xd->raisecode = NULL;
    xd->next = NULL;

    /* Append it to the list. */
    for (tail = &pt->exceptions; *tail != NULL; tail = &(*tail)->next)
        ;

    *tail = xd;

    return xd;
}


/*
 * Find an undefined (or create a new) class definition in a parse tree.
 */
static classDef *newClass(sipSpec *pt, ifaceFileType iftype,
        apiVersionRangeDef *api_range, scopedNameDef *fqname)
{
    int flags;
    classDef *cd, *scope;
    codeBlock *hdrcode;

    if (sectionFlags & SECT_IS_PRIVATE)
        yyerror("Classes, structs and namespaces must be in the public or protected sections");

    flags = 0;

    if ((scope = currentScope()) != NULL)
    {
        if (sectionFlags & SECT_IS_PROT && !makeProtPublic)
        {
            flags = CLASS_IS_PROTECTED;

            if (scope->iff->type == class_iface)
                setHasShadow(scope);
        }

        /* Header code from outer scopes is also included. */
        hdrcode = scope->iff->hdrcode;
    }
    else
        hdrcode = NULL;

    if (pt -> genc)
    {
        /* C structs are always global types. */
        while (fqname -> next != NULL)
            fqname = fqname -> next;

        scope = NULL;
    }

    cd = findClass(pt, iftype, api_range, fqname);

    /* Check it hasn't already been defined. */
    if (iftype != namespace_iface && cd->iff->module != NULL)
        yyerror("The struct/class has already been defined");

    /* Complete the initialisation. */
    cd->classflags |= flags;
    cd->ecd = scope;
    cd->iff->module = currentModule;

    if (currentIsTemplate)
        setIsTemplateClass(cd);

    appendCodeBlock(&cd->iff->hdrcode, hdrcode);

    /* See if it is a namespace extender. */
    if (iftype == namespace_iface)
    {
        classDef *ns;

        for (ns = pt->classes; ns != NULL; ns = ns->next)
        {
            if (ns == cd)
                continue;

            if (ns->iff->type != namespace_iface)
                continue;

            if (compareScopedNames(ns->iff->fqcname, fqname) != 0)
                continue;

            cd->real = ns;
            break;
        }
    }

    return cd;
}


/*
 * Tidy up after finishing a class definition.
 */
static void finishClass(sipSpec *pt, moduleDef *mod, classDef *cd,
        optFlags *of)
{
    const char *pyname;
    optFlag *flg;

    /* Get the Python name and see if it is different to the C++ name. */
    pyname = getPythonName(of, classBaseName(cd));

    cd->pyname = NULL;
    checkAttributes(pt, mod, cd->ecd, NULL, pyname, FALSE);
    cd->pyname = cacheName(pt, pyname);

    if ((flg = findOptFlag(of, "Metatype", dotted_name_flag)) != NULL)
        cd->metatype = cacheName(pt, flg->fvalue.sval);

    if ((flg = findOptFlag(of, "Supertype", dotted_name_flag)) != NULL)
        cd->supertype = cacheName(pt, flg->fvalue.sval);

    if (isOpaque(cd))
    {
        if (findOptFlag(of, "External", bool_flag) != NULL)
            setIsExternal(cd);
    }
    else
    {
        int seq_might, seq_not;
        memberDef *md;

        if (findOptFlag(of, "NoDefaultCtors", bool_flag) != NULL)
            setNoDefaultCtors(cd);

        if (cd -> ctors == NULL)
        {
            if (!noDefaultCtors(cd))
            {
                /* Provide a default ctor. */

                cd->ctors = sipMalloc(sizeof (ctorDef));
 
                cd->ctors->ctorflags = SECT_IS_PUBLIC;
                cd->ctors->pysig.result.atype = void_type;
                cd->ctors->cppsig = &cd->ctors->pysig;

                cd->defctor = cd->ctors;

                setCanCreate(cd);
            }
        }
        else if (cd -> defctor == NULL)
        {
            ctorDef *ct, *last = NULL;

            for (ct = cd -> ctors; ct != NULL; ct = ct -> next)
            {
                if (!isPublicCtor(ct))
                    continue;

                if (ct -> pysig.nrArgs == 0 || ct -> pysig.args[0].defval != NULL)
                {
                    cd -> defctor = ct;
                    break;
                }

                if (last == NULL)
                    last = ct;
            }

            /* The last resort is the first public ctor. */
            if (cd->defctor == NULL)
                cd->defctor = last;
        }

        if (getDeprecated(of))
            setIsDeprecatedClass(cd);

        if (cd->convtocode != NULL && getAllowNone(of))
            setClassHandlesNone(cd);

        if (findOptFlag(of,"Abstract",bool_flag) != NULL)
        {
            setIsAbstractClass(cd);
            setIsIncomplete(cd);
            resetCanCreate(cd);
        }

        /* We assume a public dtor if nothing specific was provided. */
        if (!isDtor(cd))
            setIsPublicDtor(cd);

        if (findOptFlag(of, "DelayDtor", bool_flag) != NULL)
        {
            setIsDelayedDtor(cd);
            setHasDelayedDtors(mod);
        }

        /*
         * There are subtle differences between the add and concat methods and
         * the multiply and repeat methods.  The number versions can have their
         * operands swapped and may return NotImplemented.  If the user has
         * used the /Numeric/ annotation or there are other numeric operators
         * then we use add/multiply.  Otherwise, if there are indexing
         * operators then we use concat/repeat.
         */
        seq_might = seq_not = FALSE;

        for (md = cd -> members; md != NULL; md = md -> next)
            switch (md -> slot)
            {
            case getitem_slot:
            case setitem_slot:
            case delitem_slot:
                /* This might be a sequence. */
                seq_might = TRUE;
                break;

            case sub_slot:
            case isub_slot:
            case div_slot:
            case idiv_slot:
            case mod_slot:
            case imod_slot:
            case floordiv_slot:
            case ifloordiv_slot:
            case truediv_slot:
            case itruediv_slot:
            case pos_slot:
            case neg_slot:
                /* This is definately not a sequence. */
                seq_not = TRUE;
                break;
            }

        if (!seq_not && seq_might)
            for (md = cd -> members; md != NULL; md = md -> next)
            {
                /* Ignore if the user has been explicit. */
                if (isNumeric(md))
                    continue;

                switch (md -> slot)
                {
                case add_slot:
                    md -> slot = concat_slot;
                    break;

                case iadd_slot:
                    md -> slot = iconcat_slot;
                    break;

                case mul_slot:
                    md -> slot = repeat_slot;
                    break;

                case imul_slot:
                    md -> slot = irepeat_slot;
                    break;
                }
            }
    }

    if (inMainModule())
    {
        setIsUsedName(cd->iff->name);
        setIsUsedName(cd->pyname);
    }
}


/*
 * Return the encoded name of a template (ie. including its argument types) as
 * a scoped name.
 */
scopedNameDef *encodedTemplateName(templateDef *td)
{
    int a;
    scopedNameDef *snd;

    snd = copyScopedName(td->fqname);

    for (a = 0; a < td->types.nrArgs; ++a)
    {
        char buf[50];
        int flgs;
        scopedNameDef *arg_snd;
        argDef *ad = &td->types.args[a];

        flgs = 0;

        if (isConstArg(ad))
            flgs += 1;

        if (isReference(ad))
            flgs += 2;

        /* We use numbers so they don't conflict with names. */
        sprintf(buf, "%02d%d%d", ad->atype, flgs, ad->nrderefs);

        switch (ad->atype)
        {
        case defined_type:
            arg_snd = copyScopedName(ad->u.snd);
            break;

        case template_type:
            arg_snd = encodedTemplateName(ad->u.td);
            break;

        case struct_type:
            arg_snd = copyScopedName(ad->u.sname);
            break;

        default:
            arg_snd = NULL;
        }

        /*
         * Replace the first element of the argument name with a copy with the
         * encoding prepended.
         */
        if (arg_snd != NULL)
            arg_snd->name = concat(buf, arg_snd->name, NULL);
        else
            arg_snd = text2scopePart(sipStrdup(buf));

        appendScopedName(&snd, arg_snd);
    }

    return snd;
}


/*
 * Create a new mapped type.
 */
static mappedTypeDef *newMappedType(sipSpec *pt, argDef *ad, optFlags *of)
{
    mappedTypeDef *mtd;
    scopedNameDef *snd;
    ifaceFileDef *iff;
    const char *cname;

    /* Check that the type is one we want to map. */
    switch (ad->atype)
    {
    case defined_type:
        snd = ad->u.snd;
        cname = scopedNameTail(snd);
        break;

    case template_type:
        snd = encodedTemplateName(ad->u.td);
        cname = NULL;
        break;

    case struct_type:
        snd = ad->u.sname;
        cname = scopedNameTail(snd);
        break;

    default:
        yyerror("Invalid type for %MappedType");
    }

    iff = findIfaceFile(pt, currentModule, snd, mappedtype_iface,
            getAPIRange(of), ad);

    /* Check it hasn't already been defined. */
    for (mtd = pt->mappedtypes; mtd != NULL; mtd = mtd->next)
        if (mtd->iff == iff)
        {
            /*
             * We allow types based on the same template but with different
             * arguments.
             */
            if (ad->atype != template_type || sameBaseType(ad, &mtd->type))
                yyerror("Mapped type has already been defined in this module");
        }

    /* The module may not have been set yet. */
    iff->module = currentModule;

    /* Create a new mapped type. */
    mtd = allocMappedType(pt, ad);

    if (cname != NULL)
        mtd->pyname = cacheName(pt, getPythonName(of, cname));

    if (findOptFlag(of, "NoRelease", bool_flag) != NULL)
        setNoRelease(mtd);

    if (getAllowNone(of))
        setHandlesNone(mtd);

    mtd->doctype = getDocType(of);

    mtd->iff = iff;
    mtd->next = pt->mappedtypes;

    pt->mappedtypes = mtd;

    if (inMainModule())
    {
        setIsUsedName(mtd->cname);

        if (mtd->pyname)
            setIsUsedName(mtd->pyname);
    }

    return mtd;
}


/*
 * Allocate, intialise and return a mapped type structure.
 */
mappedTypeDef *allocMappedType(sipSpec *pt, argDef *type)
{
    mappedTypeDef *mtd;

    mtd = sipMalloc(sizeof (mappedTypeDef));

    mtd->type = *type;
    mtd->type.argflags = 0;
    mtd->type.nrderefs = 0;

    mtd->cname = cacheName(pt, type2string(&mtd->type));

    return mtd;
}


/*
 * Create a new enum.
 */
static enumDef *newEnum(sipSpec *pt, moduleDef *mod, mappedTypeDef *mt_scope,
        char *name, optFlags *of, int flags)
{
    enumDef *ed, *first_alt, *next_alt;
    classDef *c_scope;
    ifaceFileDef *scope;

    if (mt_scope != NULL)
    {
        scope = mt_scope->iff;
        c_scope = NULL;
    }
    else
    {
        if ((c_scope = currentScope()) != NULL)
            scope = c_scope->iff;
        else
            scope = NULL;
    }

    ed = sipMalloc(sizeof (enumDef));

    /* Assume the enum isn't versioned. */
    first_alt = ed;
    next_alt = NULL;

    if (name != NULL)
    {
        ed->pyname = cacheName(pt, getPythonName(of, name));
        checkAttributes(pt, mod, c_scope, mt_scope, ed->pyname->text, FALSE);

        ed->fqcname = text2scopedName(scope, name);
        ed->cname = cacheName(pt, scopedNameToString(ed->fqcname));

        if (inMainModule())
        {
            setIsUsedName(ed->pyname);
            setIsUsedName(ed->cname);
        }

        /* If the scope is versioned then look for any alternate. */
        if (scope != NULL && scope->api_range != NULL)
        {
            enumDef *alt;

            for (alt = pt->enums; alt != NULL; alt = alt->next)
            {
                if (alt->module != mod || alt->fqcname == NULL)
                    continue;

                if (compareScopedNames(alt->fqcname, ed->fqcname) == 0)
                {
                    first_alt = alt->first_alt;
                    next_alt = first_alt->next_alt;
                    first_alt->next_alt = ed;

                    break;
                }
            }
        }
    }
    else
    {
        ed->pyname = NULL;
        ed->fqcname = NULL;
        ed->cname = NULL;
    }

    if (flags & SECT_IS_PROT && makeProtPublic)
    {
        flags &= ~SECT_IS_PROT;
        flags |= SECT_IS_PUBLIC;
    }

    ed->enumflags = flags;
    ed->enumnr = -1;
    ed->ecd = c_scope;
    ed->emtd = mt_scope;
    ed->first_alt = first_alt;
    ed->next_alt = next_alt;
    ed->module = mod;
    ed->members = NULL;
    ed->slots = NULL;
    ed->overs = NULL;
    ed->next = pt -> enums;

    pt->enums = ed;

    return ed;
}


/*
 * Get the type values and (optionally) the type names for substitution in
 * handwritten code.
 */
void appendTypeStrings(scopedNameDef *ename, signatureDef *patt, signatureDef *src, signatureDef *known, scopedNameDef **names, scopedNameDef **values)
{
    int a;

    for (a = 0; a < patt->nrArgs; ++a)
    {
        argDef *pad = &patt->args[a];

        if (pad->atype == defined_type)
        {
            char *nam = NULL, *val;
            argDef *sad;

            /*
             * If the type names are already known then check that this is one
             * of them.
             */
            if (known == NULL)
                nam = scopedNameTail(pad->u.snd);
            else if (pad->u.snd->next == NULL)
            {
                int k;

                for (k = 0; k < known->nrArgs; ++k)
                {
                    /* Skip base types. */
                    if (known->args[k].atype != defined_type)
                        continue;

                    if (strcmp(pad->u.snd->name, known->args[k].u.snd->name) == 0)
                    {
                        nam = pad->u.snd->name;
                        break;
                    }
                }
            }

            if (nam == NULL)
                continue;

            /* Add the name. */
            appendScopedName(names, text2scopePart(nam));

            /*
             * Add the corresponding value.  For defined types we don't want 
             * any indirection or references.
             */
            sad = &src->args[a];

            if (sad->atype == defined_type)
                val = scopedNameToString(sad->u.snd);
            else
                val = type2string(sad);

            appendScopedName(values, text2scopePart(val));
        }
        else if (pad->atype == template_type)
        {
            argDef *sad = &src->args[a];

            /* These checks shouldn't be necessary, but... */
            if (sad->atype == template_type && pad->u.td->types.nrArgs == sad->u.td->types.nrArgs)
                appendTypeStrings(ename, &pad->u.td->types, &sad->u.td->types, known, names, values);
        }
    }
}


/*
 * Convert a type to a string on the heap.  The string will use the minimum
 * whitespace while still remaining valid C++.
 */
static char *type2string(argDef *ad)
{
    int i, on_heap = FALSE;
    int nr_derefs = ad->nrderefs;
    int is_reference = isReference(ad);
    char *s;

    /* Use the original type if possible. */
    if (ad->original_type != NULL && !noTypeName(ad->original_type))
    {
        s = scopedNameToString(ad->original_type->fqname);
        on_heap = TRUE;

        nr_derefs -= ad->original_type->type.nrderefs;

        if (isReference(&ad->original_type->type))
            is_reference = FALSE;
    }
    else
        switch (ad->atype)
        {
        case template_type:
            {
                templateDef *td = ad->u.td;

                s = scopedNameToString(td->fqname);
                append(&s, "<");

                for (i = 0; i < td->types.nrArgs; ++i)
                {
                    char *sub_type = type2string(&td->types.args[i]);

                    if (i > 0)
                        append(&s, ",");

                    append(&s, sub_type);
                    free(sub_type);
                }

                if (s[strlen(s) - 1] == '>')
                    append(&s, " >");
                else
                    append(&s, ">");

                on_heap = TRUE;
                break;
            }

        case struct_type:
            s = scopedNameToString(ad->u.sname);
            on_heap = TRUE;
            break;

        case defined_type:
            s = scopedNameToString(ad->u.snd);
            on_heap = TRUE;
            break;

        case ustring_type:
            s = "unsigned char";
            break;

        case ascii_string_type:
        case latin1_string_type:
        case utf8_string_type:
        case string_type:
            s = "char";
            break;

        case sstring_type:
            s = "signed char";
            break;

        case wstring_type:
            s = "wchar_t";
            break;

        case ushort_type:
            s = "unsigned short";
            break;

        case short_type:
            s = "short";
            break;

        case uint_type:
            s = "unsigned int";
            break;

        case int_type:
        case cint_type:
            s = "int";
            break;

        case ulong_type:
            s = "unsigned long";
            break;

        case long_type:
            s = "long";
            break;

        case ulonglong_type:
            s = "unsigned long long";
            break;

        case longlong_type:
            s = "long long";
            break;

        case float_type:
        case cfloat_type:
            s = "float";
            break;

        case double_type:
        case cdouble_type:
            s = "double";
            break;

        case bool_type:
        case cbool_type:
            s = "bool";
            break;

        default:
            fatal("Unsupported type argument to type2string(): %d\n", ad->atype);
        }

    /* Make sure the string is on the heap. */
    if (!on_heap)
        s = sipStrdup(s);

    while (nr_derefs-- > 0)
        append(&s, "*");

    if (is_reference)
        append(&s, "&");

    return s;
}


/*
 * Convert a scoped name to a string on the heap.
 */
static char *scopedNameToString(scopedNameDef *name)
{
    static const char scope_string[] = "::";
    size_t len;
    scopedNameDef *snd;
    char *s, *dp;

    /* Work out the length of buffer needed. */
    len = 0;

    for (snd = name; snd != NULL; snd = snd->next)
    {
        len += strlen(snd->name);

        if (snd->next != NULL)
        {
            /* Ignore the encoded part of template names. */
            if (isdigit(snd->next->name[0]))
                break;

            len += strlen(scope_string);
        }
    }

    /* Allocate and populate the buffer. */
    dp = s = sipMalloc(len + 1);

    for (snd = name; snd != NULL; snd = snd->next)
    {
        strcpy(dp, snd->name);
        dp += strlen(snd->name);

        if (snd->next != NULL)
        {
            /* Ignore the encoded part of template names. */
            if (isdigit(snd->next->name[0]))
                break;

            strcpy(dp, scope_string);
            dp += strlen(scope_string);
        }
    }

    return s;
}


/*
 * Instantiate a class template.
 */
static void instantiateClassTemplate(sipSpec *pt, moduleDef *mod,
        classDef *scope, scopedNameDef *fqname, classTmplDef *tcd,
        templateDef *td)
{
    scopedNameDef *type_names, *type_values;
    classDef *cd;
    ctorDef *oct, **cttail;
    argDef *ad;
    ifaceFileList *iffl, **used;

    type_names = type_values = NULL;
    appendTypeStrings(classFTQCName(tcd->cd), &tcd->sig, &td->types, NULL, &type_names, &type_values);

    /*
     * Add a mapping from the template name to the instantiated name.  If we
     * have got this far we know there is room for it.
     */
    ad = &tcd->sig.args[tcd->sig.nrArgs++];
    memset(ad, 0, sizeof (argDef));
    ad->atype = defined_type;
    ad->u.snd = classFTQCName(tcd->cd);

    appendScopedName(&type_names, text2scopePart(scopedNameTail(classFTQCName(tcd->cd))));
    appendScopedName(&type_values, text2scopePart(scopedNameToString(fqname)));

    /* Create the new class. */
    cd = sipMalloc(sizeof (classDef));

    /* Start with a shallow copy. */
    *cd = *tcd->cd;

    resetIsTemplateClass(cd);
    cd->pyname = cacheName(pt, scopedNameTail(fqname));
    cd->td = td;

    /* Handle the interface file. */
    cd->iff = findIfaceFile(pt, mod, fqname, class_iface,
            (scope != NULL ? scope->iff->api_range : NULL), NULL);
    cd->iff->module = mod;

    /* Make a copy of the used list and add the enclosing scope. */
    used = &cd->iff->used;

    for (iffl = tcd->cd->iff->used; iffl != NULL; iffl = iffl->next)
        addToUsedList(used, iffl->iff);

    /* Include any scope header code. */
    if (scope != NULL)
        appendCodeBlock(&cd->iff->hdrcode, scope->iff->hdrcode);

    if (inMainModule())
    {
        setIsUsedName(cd->iff->name);
        setIsUsedName(cd->pyname);
    }

    cd->ecd = currentScope();

    /* Handle the enums. */
    instantiateTemplateEnums(pt, tcd, td, cd, used, type_names, type_values);

    /* Handle the variables. */
    instantiateTemplateVars(pt, tcd, td, cd, used, type_names, type_values);

    /* Handle the ctors. */
    cd->ctors = NULL;
    cttail = &cd->ctors;

    for (oct = tcd->cd->ctors; oct != NULL; oct = oct->next)
    {
        ctorDef *nct = sipMalloc(sizeof (ctorDef));

        /* Start with a shallow copy. */
        *nct = *oct;

        templateSignature(&nct->pysig, FALSE, tcd, td, cd);

        if (oct->cppsig == NULL)
            nct->cppsig = NULL;
        else if (oct->cppsig == &oct->pysig)
            nct->cppsig = &nct->pysig;
        else
        {
            nct->cppsig = sipMalloc(sizeof (signatureDef));

            *nct->cppsig = *oct->cppsig;

            templateSignature(nct->cppsig, FALSE, tcd, td, cd);
        }

        nct->methodcode = templateCode(pt, used, nct->methodcode, type_names, type_values);

        nct->next = NULL;
        *cttail = nct;
        cttail = &nct->next;

        /* Handle the default ctor. */
        if (tcd->cd->defctor == oct)
            cd->defctor = nct;
    }

    cd->dealloccode = templateCode(pt, used, cd->dealloccode, type_names, type_values);
    cd->dtorcode = templateCode(pt, used, cd->dtorcode, type_names, type_values);

    /* Handle the methods. */
    cd->members = instantiateTemplateMethods(tcd->cd->members, mod);
    cd->overs = instantiateTemplateOverloads(pt, tcd->cd->overs,
            tcd->cd->members, cd->members, tcd, td, cd, used, type_names,
            type_values);

    cd->cppcode = templateCode(pt, used, cd->cppcode, type_names, type_values);
    cd->iff->hdrcode = templateCode(pt, used, cd->iff->hdrcode, type_names, type_values);
    cd->convtosubcode = templateCode(pt, used, cd->convtosubcode, type_names, type_values);
    cd->convtocode = templateCode(pt, used, cd->convtocode, type_names, type_values);
    cd->travcode = templateCode(pt, used, cd->travcode, type_names, type_values);
    cd->clearcode = templateCode(pt, used, cd->clearcode, type_names, type_values);
    cd->getbufcode = templateCode(pt, used, cd->getbufcode, type_names, type_values);
    cd->releasebufcode = templateCode(pt, used, cd->releasebufcode, type_names, type_values);
    cd->readbufcode = templateCode(pt, used, cd->readbufcode, type_names, type_values);
    cd->writebufcode = templateCode(pt, used, cd->writebufcode, type_names, type_values);
    cd->segcountcode = templateCode(pt, used, cd->segcountcode, type_names, type_values);
    cd->charbufcode = templateCode(pt, used, cd->charbufcode, type_names, type_values);
    cd->picklecode = templateCode(pt, used, cd->picklecode, type_names, type_values);
    cd->next = pt->classes;

    pt->classes = cd;

    tcd->sig.nrArgs--;

    freeScopedName(type_names);
    freeScopedName(type_values);
}


/*
 * Instantiate the methods of a template class.
 */
static memberDef *instantiateTemplateMethods(memberDef *tmd, moduleDef *mod)
{
    memberDef *md, *methods, **mdtail;

    methods = NULL;
    mdtail = &methods;

    for (md = tmd; md != NULL; md = md->next)
    {
        memberDef *nmd = sipMalloc(sizeof (memberDef));

        /* Start with a shallow copy. */
        *nmd = *md;

        nmd->module = mod;

        if (inMainModule())
            setIsUsedName(nmd->pyname);

        nmd->next = NULL;
        *mdtail = nmd;
        mdtail = &nmd->next;
    }

    return methods;
}


/*
 * Instantiate the overloads of a template class.
 */
static overDef *instantiateTemplateOverloads(sipSpec *pt, overDef *tod,
        memberDef *tmethods, memberDef *methods, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values)
{
    overDef *od, *overloads, **odtail;

    overloads = NULL;
    odtail = &overloads;

    for (od = tod; od != NULL; od = od->next)
    {
        overDef *nod = sipMalloc(sizeof (overDef));
        memberDef *nmd, *omd;

        /* Start with a shallow copy. */
        *nod = *od;

        for (nmd = methods, omd = tmethods; omd != NULL; omd = omd->next, nmd = nmd->next)
            if (omd == od->common)
            {
                nod->common = nmd;
                break;
            }

        templateSignature(&nod->pysig, TRUE, tcd, td, cd);

        if (od->cppsig == &od->pysig)
            nod->cppsig = &nod->pysig;
        else
        {
            nod->cppsig = sipMalloc(sizeof (signatureDef));

            *nod->cppsig = *od->cppsig;

            templateSignature(nod->cppsig, TRUE, tcd, td, cd);
        }

        nod->methodcode = templateCode(pt, used, nod->methodcode, type_names, type_values);

        /* Handle any virtual handler. */
        if (od->virthandler != NULL)
        {
            moduleDef *mod = cd->iff->module;

            nod->virthandler = sipMalloc(sizeof (virtHandlerDef));

            /* Start with a shallow copy. */
            *nod->virthandler = *od->virthandler;

            if (od->virthandler->cppsig == &od->pysig)
                nod->virthandler->cppsig = &nod->pysig;
            else
            {
                nod->virthandler->cppsig = sipMalloc(sizeof (signatureDef));

                *nod->virthandler->cppsig = *od->virthandler->cppsig;

                templateSignature(nod->virthandler->cppsig, TRUE, tcd, td, cd);
            }

            nod->virthandler->module = mod;
            nod->virthandler->virtcode = templateCode(pt, used, nod->virthandler->virtcode, type_names, type_values);
            nod->virthandler->next = mod->virthandlers;

            mod->virthandlers = nod->virthandler;
        }

        nod->next = NULL;
        *odtail = nod;
        odtail = &nod->next;
    }

    return overloads;
}


/*
 * Instantiate the enums of a template class.
 */
static void instantiateTemplateEnums(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values)
{
    enumDef *ted;
    moduleDef *mod = cd->iff->module;

    for (ted = pt->enums; ted != NULL; ted = ted->next)
        if (ted->ecd == tcd->cd)
        {
            enumDef *ed;
            enumMemberDef *temd;

            ed = sipMalloc(sizeof (enumDef));

            /* Start with a shallow copy. */
            *ed = *ted;

            if (ed->fqcname != NULL)
            {
                ed->fqcname = text2scopedName(cd->iff,
                        scopedNameTail(ed->fqcname));
                ed->cname = cacheName(pt, scopedNameToString(ed->fqcname));
            }

            if (inMainModule())
            {
                if (ed->pyname != NULL)
                    setIsUsedName(ed->pyname);

                if (ed->cname != NULL)
                    setIsUsedName(ed->cname);
            }

            ed->ecd = cd;
            ed->first_alt = ed;
            ed->module = mod;
            ed->members = NULL;

            for (temd = ted->members; temd != NULL; temd = temd->next)
            {
                enumMemberDef *emd;

                emd = sipMalloc(sizeof (enumMemberDef));

                /* Start with a shallow copy. */
                *emd = *temd;
                emd->ed = ed;

                emd->next = ed->members;
                ed->members = emd;
            }

            ed->slots = instantiateTemplateMethods(ted->slots, mod);
            ed->overs = instantiateTemplateOverloads(pt, ted->overs,
                    ted->slots, ed->slots, tcd, td, cd, used, type_names,
                    type_values);

            ed->next = pt->enums;
            pt->enums = ed;
        }
}


/*
 * Instantiate the variables of a template class.
 */
static void instantiateTemplateVars(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values)
{
    varDef *tvd;

    for (tvd = pt->vars; tvd != NULL; tvd = tvd->next)
        if (tvd->ecd == tcd->cd)
        {
            varDef *vd;

            vd = sipMalloc(sizeof (varDef));

            /* Start with a shallow copy. */
            *vd = *tvd;

            if (inMainModule())
                setIsUsedName(vd->pyname);

            vd->fqcname = text2scopedName(cd->iff,
                    scopedNameTail(vd->fqcname));
            vd->ecd = cd;
            vd->module = cd->iff->module;

            templateType(&vd->type, tcd, td, cd);

            vd->accessfunc = templateCode(pt, used, vd->accessfunc, type_names, type_values);
            vd->getcode = templateCode(pt, used, vd->getcode, type_names, type_values);
            vd->setcode = templateCode(pt, used, vd->setcode, type_names, type_values);

            addVariable(pt, vd);
        }
}


/*
 * Replace any template arguments in a signature.
 */
static void templateSignature(signatureDef *sd, int result, classTmplDef *tcd, templateDef *td, classDef *ncd)
{
    int a;

    if (result)
        templateType(&sd->result, tcd, td, ncd);

    for (a = 0; a < sd->nrArgs; ++a)
        templateType(&sd->args[a], tcd, td, ncd);
}


/*
 * Replace any template arguments in a type.
 */
static void templateType(argDef *ad, classTmplDef *tcd, templateDef *td, classDef *ncd)
{
    int a;
    char *name;

    /* Descend into any sub-templates. */
    if (ad->atype == template_type)
    {
        templateDef *new_td = sipMalloc(sizeof (templateDef));

        /* Make a deep copy of the template definition. */
        *new_td = *ad->u.td;
        ad->u.td = new_td;

        templateSignature(&ad->u.td->types, FALSE, tcd, td, ncd);

        return;
    }

    /* Ignore if it isn't an unscoped name. */
    if (ad->atype != defined_type || ad->u.snd->next != NULL)
        return;

    name = ad->u.snd->name;

    for (a = 0; a < tcd->sig.nrArgs - 1; ++a)
        if (strcmp(name, scopedNameTail(tcd->sig.args[a].u.snd)) == 0)
        {
            argDef *tad = &td->types.args[a];

            ad->atype = tad->atype;

            /* We take the constrained flag from the real type. */
            resetIsConstrained(ad);

            if (isConstrained(tad))
                setIsConstrained(ad);

            ad->u = tad->u;

            return;
        }

    /* Handle the class name itself. */
    if (strcmp(name, scopedNameTail(classFTQCName(tcd->cd))) == 0)
    {
        ad->atype = class_type;
        ad->u.cd = ncd;
        ad->original_type = NULL;
    }
}


/*
 * Replace any template arguments in a literal code block.
 */
codeBlock *templateCode(sipSpec *pt, ifaceFileList **used, codeBlock *ocb,
        scopedNameDef *names, scopedNameDef *values)
{
    codeBlock *ncb = NULL, **tail = &ncb;

    while (ocb != NULL)
    {
        char *at = ocb->frag;

        do
        {
            char *first = NULL;
            codeBlock *cb;
            scopedNameDef *nam, *val, *nam_first, *val_first;

            /*
             * Go through the rest of this fragment looking for each of the
             * types and the name of the class itself.
             */
            nam = names;
            val = values;

            while (nam != NULL && val != NULL)
            {
                char *cp;

                if ((cp = strstr(at, nam->name)) != NULL)
                    if (first == NULL || first > cp)
                    {
                        nam_first = nam;
                        val_first = val;
                        first = cp;
                    }

                nam = nam->next;
                val = val->next;
            }

            /* Create the new fragment. */
            cb = sipMalloc(sizeof (codeBlock));

            if (at == ocb->frag)
            {
                cb->filename = ocb->filename;
                cb->linenr = ocb->linenr;
            }
            else
                cb->filename = NULL;

            cb->next = NULL;
            *tail = cb;
            tail = &cb->next;

            /* See if anything was found. */
            if (first == NULL)
            {
                /* We can just point to this. */
                cb->frag = at;

                /* All done with this one. */
                at = NULL;
            }
            else
            {
                static char *gen_names[] = {
                    "sipType_",
                    "sipClass_",
                    "sipEnum_",
                    "sipException_",
                    NULL
                };

                char *dp, *sp, **gn;
                int genname = FALSE;

                /*
                 * If the context in which the text is used is in the name of a
                 * SIP-TQt generated object then translate any "::" scoping to "_".
                 */
                for (gn = gen_names; *gn != NULL; ++gn)
                    if (search_back(first, at, *gn))
                    {
                        addUsedFromCode(pt, used, val_first->name);
                        genname = TRUE;
                        break;
                    }

                /* Fragment the fragment. */
                cb->frag = sipMalloc(first - at + strlen(val_first->name) + 1);

                strncpy(cb->frag, at, first - at);

                dp = &cb->frag[first - at];
                sp = val_first->name;

                if (genname)
                {
                    char gch;

                    while ((gch = *sp++) != '\0')
                        if (gch == ':' && *sp == ':')
                        {
                            *dp++ = '_';
                            ++sp;
                        }
                        else
                            *dp++ = gch;

                    *dp = '\0';
                }
                else
                    strcpy(dp, sp);

                /* Move past the replaced text. */
                at = first + strlen(nam_first->name);
            }
        }
        while (at != NULL && *at != '\0');

        ocb = ocb->next;
    }

    return ncb;
}


/*
 * Return TRUE if the text at the end of a string matches the target string.
 */
static int search_back(const char *end, const char *start, const char *target)
{
    size_t tlen = strlen(target);

    if (start + tlen >= end)
        return FALSE;

    return (strncmp(end - tlen, target, tlen) == 0);
}


/*
 * Add any needed interface files based on handwritten code.
 */
static void addUsedFromCode(sipSpec *pt, ifaceFileList **used, const char *sname)
{
    ifaceFileDef *iff;
    enumDef *ed;

    for (iff = pt->ifacefiles; iff != NULL; iff = iff->next)
    {
        if (iff->type != class_iface && iff->type != exception_iface)
            continue;

        if (sameName(iff->fqcname, sname))
        {
            addToUsedList(used, iff);
            return;
        }
    }

    for (ed = pt->enums; ed != NULL; ed = ed->next)
    {
        if (ed->ecd == NULL)
            continue;

        if (sameName(ed->fqcname, sname))
        {
            addToUsedList(used, ed->ecd->iff);
            return;
        }
    }
}


/*
 * Compare a scoped name with its string equivalent.
 */
static int sameName(scopedNameDef *snd, const char *sname)
{
    while (snd != NULL && *sname != '\0')
    {
        const char *sp = snd->name;

        while (*sp != '\0' && *sname != ':' && *sname != '\0')
            if (*sp++ != *sname++)
                return FALSE;

        if (*sp != '\0' || (*sname != ':' && *sname != '\0'))
            return FALSE;

        snd = snd->next;

        if (*sname == ':')
            sname += 2;
    }

    return (snd == NULL && *sname == '\0');
}


/*
 * Compare a (possibly) relative scoped name with a fully qualified scoped name
 * while taking the current scope into account.
 */
static int foundInScope(scopedNameDef *fq_name, scopedNameDef *rel_name)
{
    classDef *scope;

    for (scope = currentScope(); scope != NULL; scope = scope->ecd)
    {
        scopedNameDef *snd;
        int found;

        snd = copyScopedName(classFTQCName(scope));
        appendScopedName(&snd, copyScopedName(rel_name));

        found = (compareScopedNames(fq_name, snd) == 0);

        freeScopedName(snd);

        if (found)
            return TRUE;
    }

    return compareScopedNames(fq_name, rel_name) == 0;
}


/*
 * Create a new typedef.
 */
static void newTypedef(sipSpec *pt, moduleDef *mod, char *name, argDef *type,
        optFlags *optflgs)
{
    typedefDef *td, **tdp;
    scopedNameDef *fqname;
    classDef *scope;

    scope = currentScope();
    fqname = text2scopedName((scope != NULL ? scope->iff : NULL), name);

    /* See if we are instantiating a template class. */
    if (type->atype == template_type)
    {
        classTmplDef *tcd;
        templateDef *td = type->u.td;

        for (tcd = pt->classtemplates; tcd != NULL; tcd = tcd->next)
            if (foundInScope(tcd->cd->iff->fqcname, td->fqname) &&
                sameTemplateSignature(&tcd->sig, &td->types, FALSE))
            {
                instantiateClassTemplate(pt, mod, scope, fqname, tcd, td);

                /* All done. */
                return;
            }
    }

    /*
     * Check it doesn't already exist and find the position in the sorted list
     * where it should be put.
     */
    for (tdp = &pt->typedefs; *tdp != NULL; tdp = &(*tdp)->next)
    {
        int res = compareScopedNames((*tdp)->fqname, fqname);

        if (res == 0)
        {
            fatalScopedName(fqname);
            fatal(" already defined\n");
        }

        if (res > 0)
            break;
    }

    td = sipMalloc(sizeof (typedefDef));

    td->tdflags = 0;
    td->fqname = fqname;
    td->ecd = scope;
    td->module = mod;
    td->type = *type;

    td->next = *tdp;
    *tdp = td;

    if (findOptFlag(optflgs, "NoTypeName", bool_flag) != NULL)
        setNoTypeName(td);

    mod->nrtypedefs++;
}


/*
 * Speculatively try and resolve any typedefs.  In some cases (eg. when
 * comparing template signatures) it helps to use the real type if it is known.
 * Note that this wouldn't be necessary if we required that all types be known
 * before they are used.
 */
static void resolveAnyTypedef(sipSpec *pt, argDef *ad)
{
    argDef orig = *ad;

    while (ad->atype == defined_type)
    {
        ad->atype = no_type;
        searchTypedefs(pt, ad->u.snd, ad);

        /*
         * Don't resolve to a template type as it may be superceded later on
         * by a more specific mapped type.
         */
        if (ad->atype == no_type || ad->atype == template_type)
        {
            *ad = orig;
            break;
        }
    }
}


/*
 * Return TRUE if the template signatures are the same.  A deep comparison is
 * used for mapped type templates where we want to recurse into any nested
 * templates.
 */
int sameTemplateSignature(signatureDef *tmpl_sd, signatureDef *args_sd,
        int deep)
{
    int a;

    if (tmpl_sd->nrArgs != args_sd->nrArgs)
        return FALSE;

    for (a = 0; a < tmpl_sd->nrArgs; ++a)
    {
        argDef *tmpl_ad = &tmpl_sd->args[a];
        argDef *args_ad = &args_sd->args[a];

        /*
         * If we are doing a shallow comparision (ie. for class templates) then
         * a type name in the template signature matches anything in the
         * argument signature.
         */
        if (tmpl_ad->atype == defined_type && !deep)
            continue;

        /*
         * For type names only compare the references and pointers, and do the
         * same for any nested templates.
         */
        if (tmpl_ad->atype == defined_type && args_ad->atype == defined_type)
        {
            if (isReference(tmpl_ad) != isReference(args_ad) || tmpl_ad->nrderefs != args_ad->nrderefs)
                return FALSE;
        }
        else if (tmpl_ad->atype == template_type && args_ad->atype == template_type)
        {
            if (!sameTemplateSignature(&tmpl_ad->u.td->types, &args_ad->u.td->types, deep))
                return FALSE;
        }
        else if (!sameBaseType(tmpl_ad, args_ad))
            return FALSE;
    }

    return TRUE;
}


/*
 * Create a new variable.
 */
static void newVar(sipSpec *pt,moduleDef *mod,char *name,int isstatic,
           argDef *type,optFlags *of,codeBlock *acode,codeBlock *gcode,
           codeBlock *scode)
{
    varDef *var;
    classDef *escope = currentScope();
    nameDef *nd = cacheName(pt,getPythonName(of,name));

    if (inMainModule())
        setIsUsedName(nd);

    checkAttributes(pt, mod, escope, NULL, nd->text, FALSE);

    var = sipMalloc(sizeof (varDef));

    var->pyname = nd;
    var->fqcname = text2scopedName((escope != NULL ? escope->iff : NULL),
            name);
    var->ecd = escope;
    var->module = mod;
    var->varflags = 0;
    var->type = *type;
    var->accessfunc = acode;
    var->getcode = gcode;
    var->setcode = scode;

    if (isstatic || (escope != NULL && escope->iff->type == namespace_iface))
        setIsStaticVar(var);

    addVariable(pt, var);
}


/*
 * Create a new ctor.
 */
static void newCtor(char *name, int sectFlags, signatureDef *args,
        optFlags *optflgs, codeBlock *methodcode, throwArgs *exceptions,
        signatureDef *cppsig, int explicit, codeBlock *docstring)
{
    ctorDef *ct, **ctp;
    classDef *cd = currentScope();

    /* Check the name of the constructor. */
    if (strcmp(classBaseName(cd), name) != 0)
        yyerror("Constructor doesn't have the same name as its class");

    if (docstring != NULL)
        appendCodeBlock(&cd->docstring, docstring);

    /* Add to the list of constructors. */
    ct = sipMalloc(sizeof (ctorDef));

    if (sectFlags & SECT_IS_PROT && makeProtPublic)
    {
        sectFlags &= ~SECT_IS_PROT;
        sectFlags |= SECT_IS_PUBLIC;
    }

    /* Allow the signature to be used like an function signature. */
    memset(&args->result, 0, sizeof (argDef));
    args->result.atype = void_type;

    ct->ctorflags = sectFlags;
    ct->api_range = getAPIRange(optflgs);
    ct->pysig = *args;
    ct->cppsig = (cppsig != NULL ? cppsig : &ct->pysig);
    ct->exceptions = exceptions;
    ct->methodcode = methodcode;

    if (!isPrivateCtor(ct))
        setCanCreate(cd);

    if (isProtectedCtor(ct))
        setHasShadow(cd);

    if (explicit)
        setIsExplicitCtor(ct);

    getHooks(optflgs, &ct->prehook, &ct->posthook);

    if (getReleaseGIL(optflgs))
        setIsReleaseGILCtor(ct);
    else if (getHoldGIL(optflgs))
        setIsHoldGILCtor(ct);

    if (getTransfer(optflgs))
        setIsResultTransferredCtor(ct);

    if (getDeprecated(optflgs))
        setIsDeprecatedCtor(ct);

    if (!isPrivateCtor(ct) && usesKeywordArgs(optflgs, &ct->pysig))
        setUseKeywordArgsCtor(ct);

    if (findOptFlag(optflgs, "NoDerived", bool_flag) != NULL)
    {
        if (cppsig != NULL)
            yyerror("The /NoDerived/ annotation cannot be used with a C++ signature");

        if (methodcode == NULL)
            yyerror("The /NoDerived/ annotation must be used with %MethodCode");

        ct->cppsig = NULL;
    }

    if (findOptFlag(optflgs, "Default", bool_flag) != NULL)
    {
        if (cd->defctor != NULL)
            yyerror("A constructor with the /Default/ annotation has already been defined");

        cd->defctor = ct;
    }

    /* Append to the list. */
    for (ctp = &cd->ctors; *ctp != NULL; ctp = &(*ctp)->next)
        ;

    *ctp = ct;
}


/*
 * Create a new function.
 */
static void newFunction(sipSpec *pt, moduleDef *mod, classDef *c_scope,
        mappedTypeDef *mt_scope, int sflags, int isstatic, int issignal,
        int isslot, int isvirt, char *name, signatureDef *sig, int isconst,
        int isabstract, optFlags *optflgs, codeBlock *methodcode,
        codeBlock *vcode, throwArgs *exceptions, signatureDef *cppsig,
        codeBlock *docstring)
{
    int factory, xferback, no_arg_parser;
    overDef *od, **odp, **headp;
    optFlag *of;
    virtHandlerDef *vhd;

    /* Extra checks for a C module. */
    if (pt->genc)
    {
        if (c_scope != NULL)
            yyerror("Function declaration not allowed in a struct in a C module");

        if (isstatic)
            yyerror("Static functions not allowed in a C module");

        if (exceptions != NULL)
            yyerror("Exceptions not allowed in a C module");
    }

    if (mt_scope != NULL)
        headp = &mt_scope->overs;
    else if (c_scope != NULL)
        headp = &c_scope->overs;
    else
        headp = &mod->overs;

    /* See if it is a factory method. */
    if (findOptFlag(optflgs, "Factory", bool_flag) != NULL)
        factory = TRUE;
    else
    {
        int a;

        factory = FALSE;

        /* Check /TransferThis/ wasn't specified. */
        if (c_scope == NULL || isstatic)
            for (a = 0; a < sig->nrArgs; ++a)
                if (isThisTransferred(&sig->args[a]))
                    yyerror("/TransferThis/ may only be specified in constructors and class methods");
    }

    /* See if the result is to be returned to Python ownership. */
    xferback = (findOptFlag(optflgs, "TransferBack", bool_flag) != NULL);

    if (factory && xferback)
        yyerror("/TransferBack/ and /Factory/ cannot both be specified");

    /* Create a new overload definition. */

    od = sipMalloc(sizeof (overDef));

    /* Set the overload flags. */

    if ((sflags & SECT_IS_PROT) && makeProtPublic)
    {
        sflags &= ~SECT_IS_PROT;
        sflags |= SECT_IS_PUBLIC | OVER_REALLY_PROT;
    }

    od->overflags = sflags;

    if (issignal)
    {
        resetIsSlot(od);
        setIsSignal(od);
    }
    else if (isslot)
    {
        resetIsSignal(od);
        setIsSlot(od);
    }

    if (factory)
        setIsFactory(od);

    if (xferback)
        setIsResultTransferredBack(od);

    if (getTransfer(optflgs))
        setIsResultTransferred(od);

    if (findOptFlag(optflgs, "TransferThis", bool_flag) != NULL)
        setIsThisTransferredMeth(od);

    if (isProtected(od))
        setHasShadow(c_scope);

    if ((isSlot(od) || isSignal(od)) && !isPrivate(od))
    {
        if (isSignal(od))
            setHasShadow(c_scope);

        pt->sigslots = TRUE;
    }

    if (isSignal(od) && (methodcode != NULL || vcode != NULL))
        yyerror("Cannot provide code for signals");

    if (isstatic)
    {
        if (isSignal(od))
            yyerror("Static functions cannot be signals");

        if (isvirt)
            yyerror("Static functions cannot be virtual");

        setIsStatic(od);
    }

    if (isconst)
        setIsConst(od);

    if (isabstract)
    {
        if (sflags == 0)
            yyerror("Non-class function specified as abstract");

        setIsAbstract(od);
    }

    if ((of = findOptFlag(optflgs, "AutoGen", opt_name_flag)) != NULL)
    {
        if (of->fvalue.sval == NULL || isEnabledFeature(of->fvalue.sval))
            setIsAutoGen(od);
    }

    if (isvirt)
    {
        if (isSignal(od) && pluginPyTQt(pt))
            yyerror("Virtual signals aren't supported");

        setIsVirtual(od);
        setHasShadow(c_scope);

        vhd = sipMalloc(sizeof (virtHandlerDef));

        vhd->virthandlernr = -1;
        vhd->vhflags = 0;
        vhd->pysig = &od->pysig;
        vhd->cppsig = (cppsig != NULL ? cppsig : &od->pysig);
        vhd->virtcode = vcode;

        if (factory || xferback)
            setIsTransferVH(vhd);

        /*
         * Only add it to the module's virtual handlers if we are not in a
         * class template.
         */
        if (!currentIsTemplate)
        {
            vhd->module = mod;

            vhd->next = mod->virthandlers;
            mod->virthandlers = vhd;
        }
    }
    else
    {
        if (vcode != NULL)
            yyerror("%VirtualCatcherCode provided for non-virtual function");

        vhd = NULL;
    }

    od->cppname = name;
    od->pysig = *sig;
    od->cppsig = (cppsig != NULL ? cppsig : &od->pysig);
    od->exceptions = exceptions;
    od->methodcode = methodcode;
    od->virthandler = vhd;

    no_arg_parser = (findOptFlag(optflgs, "NoArgParser", bool_flag) != NULL);

    if (no_arg_parser)
    {
        if (methodcode == NULL)
            yyerror("%MethodCode must be supplied if /NoArgParser/ is specified");
    }

    if (findOptFlag(optflgs, "NoCopy", bool_flag) != NULL)
        setNoCopy(&od->pysig.result);

    od->common = findFunction(pt, mod, c_scope, mt_scope,
            getPythonName(optflgs, name), (methodcode != NULL), sig->nrArgs,
            no_arg_parser);

    if (docstring != NULL)
        appendCodeBlock(&od->common->docstring, docstring);

    od->api_range = getAPIRange(optflgs);

    if (od->api_range == NULL)
        setNotVersioned(od->common);

    if (findOptFlag(optflgs, "Numeric", bool_flag) != NULL)
        setIsNumeric(od->common);

    /* Methods that run in new threads must be virtual. */
    if (findOptFlag(optflgs, "NewThread", bool_flag) != NULL)
    {
        argDef *res;

        if (!isvirt)
            yyerror("/NewThread/ may only be specified for virtual functions");

        /*
         * This is an arbitary limitation to make the code generator slightly
         * easier - laziness on my part.
         */
        res = &od->cppsig->result;

        if (res->atype != void_type || res->nrderefs != 0)
            yyerror("/NewThread/ may only be specified for void functions");

        setIsNewThread(od);
    }

    getHooks(optflgs, &od->prehook, &od->posthook);

    if (getReleaseGIL(optflgs))
        setIsReleaseGIL(od);
    else if (getHoldGIL(optflgs))
        setIsHoldGIL(od);

    if (getDeprecated(optflgs))
        setIsDeprecated(od);

    if (!isPrivate(od) && !isSignal(od) && od->common->slot == no_slot && usesKeywordArgs(optflgs, &od->pysig))
    {
        setUseKeywordArgs(od);
        setUseKeywordArgsFunction(od->common);
    }

    /* See if we want to auto-generate a __len__() method. */
    if (findOptFlag(optflgs, "__len__", bool_flag) != NULL)
    {
        overDef *len;

        len = sipMalloc(sizeof (overDef));

        len->cppname = "__len__";
        len->overflags = SECT_IS_PUBLIC;
        len->pysig.result.atype = ssize_type;
        len->pysig.nrArgs = 0;
        len->cppsig = &len->pysig;

        len->common = findFunction(pt, mod, c_scope, mt_scope, len->cppname,
                TRUE, 0, FALSE);

        if ((len->methodcode = od->methodcode) == NULL)
        {
            char *buf = sipStrdup("            sipRes = (SIP_SSIZE_T)sipCpp->");
            codeBlock *code;

            append(&buf, od->cppname);
            append(&buf, "();\n");

            code = sipMalloc(sizeof (codeBlock));

            code->frag = buf;
            code->filename = "Auto-generated";
            code->linenr = 0;
            code->next = NULL;

            len->methodcode = code;
        }

        len->next = NULL;

        od->next = len;
    }
    else
    {
        od->next = NULL;
    }

    /* Append to the list. */
    for (odp = headp; *odp != NULL; odp = &(*odp)->next)
        ;

    *odp = od;
}


/*
 * Return the Python name based on the C/C++ name and any /PyName/ annotation.
 */
static const char *getPythonName(optFlags *optflgs, const char *cname)
{
    const char *pname;
    optFlag *of;

    if ((of = findOptFlag(optflgs, "PyName", name_flag)) != NULL)
        pname = of->fvalue.sval;
    else
        pname = cname;

    return pname;
}


/*
 * Cache a name in a module.  Entries in the cache are stored in order of
 * decreasing length.
 */
nameDef *cacheName(sipSpec *pt, const char *name)
{
    nameDef *nd, **ndp;
    size_t len;

    /* Allow callers to be lazy about checking if there is really a name. */
    if (name == NULL)
        return NULL;

    /* Skip entries that are too large. */
    ndp = &pt->namecache;
    len = strlen(name);

    while (*ndp != NULL && (*ndp)->len > len)
        ndp = &(*ndp)->next;

    /* Check entries that are the right length. */
    for (nd = *ndp; nd != NULL && nd->len == len; nd = nd->next)
        if (memcmp(nd->text, name, len) == 0)
            return nd;

    /* Create a new one. */
    nd = sipMalloc(sizeof (nameDef));

    nd->nameflags = 0;
    nd->text = name;
    nd->len = len;
    nd->next = *ndp;

    *ndp = nd;

    return nd;
}


/*
 * Find (or create) an overloaded function name.
 */
static memberDef *findFunction(sipSpec *pt, moduleDef *mod, classDef *c_scope,
        mappedTypeDef *mt_scope, const char *pname, int hwcode, int nrargs,
        int no_arg_parser)
{
    static struct slot_map {
        const char *name;   /* The slot name. */
        slotType type;      /* The corresponding type. */
        int needs_hwcode;   /* Set if handwritten code is required. */
        int nrargs;         /* Nr. of arguments. */
    } slot_table[] = {
        {"__str__", str_slot, TRUE, 0},
        {"__unicode__", unicode_slot, TRUE, 0},
        {"__int__", int_slot, FALSE, 0},
        {"__long__", long_slot, FALSE, 0},
        {"__float__", float_slot, FALSE, 0},
        {"__len__", len_slot, TRUE, 0},
        {"__contains__", contains_slot, TRUE, 1},
        {"__add__", add_slot, FALSE, 1},
        {"__sub__", sub_slot, FALSE, 1},
        {"__mul__", mul_slot, FALSE, 1},
        {"__div__", div_slot, FALSE, 1},
        {"__mod__", mod_slot, FALSE, 1},
        {"__floordiv__", floordiv_slot, TRUE, 1},
        {"__truediv__", truediv_slot, FALSE, 1},
        {"__and__", and_slot, FALSE, 1},
        {"__or__", or_slot, FALSE, 1},
        {"__xor__", xor_slot, FALSE, 1},
        {"__lshift__", lshift_slot, FALSE, 1},
        {"__rshift__", rshift_slot, FALSE, 1},
        {"__iadd__", iadd_slot, FALSE, 1},
        {"__isub__", isub_slot, FALSE, 1},
        {"__imul__", imul_slot, FALSE, 1},
        {"__idiv__", idiv_slot, FALSE, 1},
        {"__imod__", imod_slot, FALSE, 1},
        {"__ifloordiv__", ifloordiv_slot, TRUE, 1},
        {"__itruediv__", itruediv_slot, FALSE, 1},
        {"__iand__", iand_slot, FALSE, 1},
        {"__ior__", ior_slot, FALSE, 1},
        {"__ixor__", ixor_slot, FALSE, 1},
        {"__ilshift__", ilshift_slot, FALSE, 1},
        {"__irshift__", irshift_slot, FALSE, 1},
        {"__invert__", invert_slot, FALSE, 0},
        {"__call__", call_slot, FALSE, -1},
        {"__getitem__", getitem_slot, FALSE, 1},
        {"__setitem__", setitem_slot, TRUE, 2},
        {"__delitem__", delitem_slot, TRUE, 1},
        {"__lt__", lt_slot, FALSE, 1},
        {"__le__", le_slot, FALSE, 1},
        {"__eq__", eq_slot, FALSE, 1},
        {"__ne__", ne_slot, FALSE, 1},
        {"__gt__", gt_slot, FALSE, 1},
        {"__ge__", ge_slot, FALSE, 1},
        {"__cmp__", cmp_slot, FALSE, 1},
        {"__bool__", bool_slot, TRUE, 0},
        {"__nonzero__", bool_slot, TRUE, 0},
        {"__neg__", neg_slot, FALSE, 0},
        {"__pos__", pos_slot, FALSE, 0},
        {"__abs__", abs_slot, TRUE, 0},
        {"__repr__", repr_slot, TRUE, 0},
        {"__hash__", hash_slot, TRUE, 0},
        {"__index__", index_slot, TRUE, 0},
        {"__iter__", iter_slot, TRUE, 0},
        {"__next__", next_slot, TRUE, 0},
        {NULL}
    };

    memberDef *md, **flist;
    struct slot_map *sm;
    slotType st;

    /* Get the slot type. */
    st = no_slot;

    for (sm = slot_table; sm->name != NULL; ++sm)
        if (strcmp(sm->name, pname) == 0)
        {
            if (sm->needs_hwcode && !hwcode)
                yyerror("This Python slot requires %MethodCode");

            if (sm->nrargs >= 0)
            {
                if (mt_scope == NULL && c_scope == NULL)
                {
                    /* Global operators need one extra argument. */
                    if (sm -> nrargs + 1 != nrargs)
                        yyerror("Incorrect number of arguments to global operator");
                }
                else if (sm->nrargs != nrargs)
                    yyerror("Incorrect number of arguments to Python slot");
            }

            st = sm->type;

            break;
        }

    /* Check there is no name clash. */
    checkAttributes(pt, mod, c_scope, mt_scope, pname, TRUE);

    /* See if it already exists. */
    if (mt_scope != NULL)
        flist = &mt_scope->members;
    else if (c_scope != NULL)
        flist = &c_scope->members;
    else
        flist = &mod->othfuncs;

    for (md = *flist; md != NULL; md = md->next)
        if (strcmp(md->pyname->text, pname) == 0 && md->module == mod)
            break;

    if (md == NULL)
    {
        /* Create a new one. */
        md = sipMalloc(sizeof (memberDef));

        md->pyname = cacheName(pt, pname);
        md->memberflags = 0;
        md->slot = st;
        md->module = mod;
        md->next = *flist;

        *flist = md;

        if (inMainModule())
            setIsUsedName(md->pyname);

        if (no_arg_parser)
            setNoArgParser(md);
    }
    else if (noArgParser(md))
        yyerror("Another overload has already been defined that is annotated as /NoArgParser/");

    /* Global operators are a subset. */
    if (mt_scope == NULL && c_scope == NULL && st != no_slot && st != neg_slot && st != pos_slot && !isNumberSlot(md) && !isRichCompareSlot(md))
        yyerror("Global operators must be either numeric or comparison operators");

    return md;
}


/*
 * Search a set of flags for a particular one and check its type.
 */
static optFlag *findOptFlag(optFlags *flgs,char *name,flagType ft)
{
    int f;

    for (f = 0; f < flgs -> nrFlags; ++f)
    {
        optFlag *of = &flgs -> flags[f];

        if (strcmp(of -> fname,name) == 0)
        {
            /*
             * An optional name can look like a boolean or a name.
             */

            if (ft == opt_name_flag)
            {
                if (of -> ftype == bool_flag)
                {
                    of -> ftype = opt_name_flag;
                    of -> fvalue.sval = NULL;
                }
                else if (of -> ftype == name_flag)
                    of -> ftype = opt_name_flag;
            }

            if (ft != of -> ftype)
                yyerror("Optional flag has a value of the wrong type");

            return of;
        }
    }

    return NULL;
}


/*
 * A name is going to be used as a Python attribute name within a Python scope
 * (ie. a Python dictionary), so check against what we already know is going in
 * the same scope in case there is a clash.
 */
static void checkAttributes(sipSpec *pt, moduleDef *mod, classDef *py_c_scope,
        mappedTypeDef *py_mt_scope, const char *attr, int isfunc)
{
    enumDef *ed;
    varDef *vd;
    classDef *cd;

    /* Check the enums. */

    for (ed = pt->enums; ed != NULL; ed = ed->next)
    {
        enumMemberDef *emd;

        if (ed->pyname == NULL)
            continue;

        if (py_c_scope != NULL)
        {
            if (ed->ecd != py_c_scope)
                continue;
        }
        else if (py_mt_scope != NULL)
        {
            if (ed->emtd != py_mt_scope)
                continue;
        }
        else if (ed->ecd != NULL || ed->emtd != NULL)
        {
            continue;
        }

        if (strcmp(ed->pyname->text, attr) == 0)
            yyerror("There is already an enum in scope with the same Python name");

        for (emd = ed->members; emd != NULL; emd = emd->next)
            if (strcmp(emd->pyname->text, attr) == 0)
                yyerror("There is already an enum member in scope with the same Python name");
    }

    /*
     * Only check the members if this attribute isn't a member because we
     * can handle members with the same name in the same scope.
     */
    if (!isfunc)
    {
        memberDef *md, *membs;
        overDef *overs;

        if (py_mt_scope != NULL)
        {
            membs = py_mt_scope->members;
            overs = py_mt_scope->overs;
        }
        else if (py_c_scope != NULL)
        {
            membs = py_c_scope->members;
            overs = py_c_scope->overs;
        }
        else
        {
            membs = mod->othfuncs;
            overs = mod->overs;
        }

        for (md = membs; md != NULL; md = md->next)
        {
            overDef *od;

            if (strcmp(md->pyname->text, attr) != 0)
                continue;

            /* Check for a conflict with all overloads. */
            for (od = overs; od != NULL; od = od->next)
            {
                if (od->common != md)
                    continue;

                yyerror("There is already a function in scope with the same Python name");
            }
        }
    }

    /* If the scope was a mapped type then that's all we have to check. */
    if (py_mt_scope != NULL)
        return;

    /* Check the variables. */
    for (vd = pt->vars; vd != NULL; vd = vd->next)
    {
        if (vd->ecd != py_c_scope)
            continue;

        if (strcmp(vd->pyname->text,attr) == 0)
            yyerror("There is already a variable in scope with the same Python name");
    }

    /* Check the classes. */
    for (cd = pt->classes; cd != NULL; cd = cd->next)
    {
        if (cd->ecd != py_c_scope || cd->pyname == NULL)
            continue;

        if (strcmp(cd->pyname->text, attr) == 0 && !isExternal(cd))
            yyerror("There is already a class or namespace in scope with the same Python name");
    }

    /* Check the exceptions. */
    if (py_c_scope == NULL)
    {
        exceptionDef *xd;

        for (xd = pt->exceptions; xd != NULL; xd = xd->next)
            if (xd->pyname != NULL && strcmp(xd->pyname, attr) == 0)
                yyerror("There is already an exception with the same Python name");
    }
}


/*
 * Append a code block to a list of them.  Append is needed to give the
 * specifier easy control over the order of the documentation.
 */
void appendCodeBlock(codeBlock **headp, codeBlock *new)
{
    while (*headp != NULL)
        headp = &(*headp)->next;

    *headp = new;
}


/*
 * Handle the end of a fully parsed a file.
 */
static void handleEOF()
{
    /*
     * Check that the number of nested if's is the same as when we started
     * the file.
     */

    if (skipStackPtr > currentContext.ifdepth)
        fatal("Too many %%If statements in %s\n", previousFile);

    if (skipStackPtr < currentContext.ifdepth)
        fatal("Too many %%End statements in %s\n", previousFile);
}


/*
 * Handle the end of a fully parsed a module.
 */
static void handleEOM()
{
    moduleDef *from;

    /* Check it has been named. */
    if (currentModule->name == NULL)
        fatal("No %%Module has been specified for module defined in %s\n",
                previousFile);

    from = currentContext.prevmod;

    if (from != NULL && from->encoding == no_type)
        from->encoding = currentModule->encoding;

    /* The previous module is now current. */
    currentModule = from;
}


/*
 * Find an existing qualifier.
 */
static qualDef *findQualifier(const char *name)
{
    moduleDef *mod;

    for (mod = currentSpec->modules; mod != NULL; mod = mod->next)
    {
        qualDef *qd;

        for (qd = mod->qualifiers; qd != NULL; qd = qd->next)
            if (strcmp(qd->name, name) == 0)
                return qd;
    }

    return NULL;
}


/*
 * Find an existing API.
 */
apiVersionRangeDef *findAPI(sipSpec *pt, const char *name)
{
    moduleDef *mod;

    for (mod = pt->modules; mod != NULL; mod = mod->next)
    {
        apiVersionRangeDef *avd;

        for (avd = mod->api_versions; avd != NULL; avd = avd->next)
            if (strcmp(avd->api_name->text, name) == 0)
                return avd;
    }

    return NULL;
}


/*
 * Return a copy of a scoped name.
 */
scopedNameDef *copyScopedName(scopedNameDef *snd)
{
    scopedNameDef *head;

    head = NULL;

    while (snd != NULL)
    {
        appendScopedName(&head,text2scopePart(snd -> name));
        snd = snd -> next;
    }

    return head;
}


/*
 * Append a name to a list of scopes.
 */
void appendScopedName(scopedNameDef **headp,scopedNameDef *newsnd)
{
    while (*headp != NULL)
        headp = &(*headp) -> next;

    *headp = newsnd;
}


/*
 * Free a scoped name - but not the text itself.
 */
void freeScopedName(scopedNameDef *snd)
{
    while (snd != NULL)
    {
        scopedNameDef *next = snd -> next;

        free(snd);

        snd = next;
    }
}


/*
 * Convert a text string to a scope part structure.
 */
static scopedNameDef *text2scopePart(char *text)
{
    scopedNameDef *snd;

    snd = sipMalloc(sizeof (scopedNameDef));

    snd->name = text;
    snd->next = NULL;

    return snd;
}


/*
 * Convert a text string to a fully scoped name.
 */
static scopedNameDef *text2scopedName(ifaceFileDef *scope, char *text)
{
    return scopeScopedName(scope, text2scopePart(text));
}


/*
 * Prepend any current scope to a scoped name.
 */
static scopedNameDef *scopeScopedName(ifaceFileDef *scope, scopedNameDef *name)
{
    scopedNameDef *snd;

    snd = (scope != NULL ? copyScopedName(scope->fqcname) : NULL);

    appendScopedName(&snd, name);

    return snd;
}


/*
 * Return a pointer to the tail part of a scoped name.
 */
char *scopedNameTail(scopedNameDef *snd)
{
    if (snd == NULL)
        return NULL;

    while (snd -> next != NULL)
        snd = snd -> next;

    return snd -> name;
}


/*
 * Push the given scope onto the scope stack.
 */
static void pushScope(classDef *scope)
{
    if (currentScopeIdx >= MAX_NESTED_SCOPE)
        fatal("Internal error: increase the value of MAX_NESTED_SCOPE\n");

    scopeStack[currentScopeIdx] = scope;
    sectFlagsStack[currentScopeIdx] = sectionFlags;

    ++currentScopeIdx;
}


/*
 * Pop the scope stack.
 */
static void popScope(void)
{
    if (currentScopeIdx > 0)
        sectionFlags = sectFlagsStack[--currentScopeIdx];
}


/*
 * Return non-zero if the current input should be parsed rather than be
 * skipped.
 */
static int notSkipping()
{
    return (skipStackPtr == 0 ? TRUE : skipStack[skipStackPtr - 1]);
}


/*
 * Return the value of an expression involving a time period.
 */
static int timePeriod(char *lname,char *uname)
{
    int this, line;
    qualDef *qd, *lower, *upper;
    moduleDef *mod;

    if (lname == NULL)
        lower = NULL;
    else if ((lower = findQualifier(lname)) == NULL || lower -> qtype != time_qualifier)
        yyerror("Lower bound is not a time version");

    if (uname == NULL)
        upper = NULL;
    else if ((upper = findQualifier(uname)) == NULL || upper -> qtype != time_qualifier)
        yyerror("Upper bound is not a time version");

    /* Sanity checks on the bounds. */

    if (lower == NULL && upper == NULL)
        yyerror("Lower and upper bounds cannot both be omitted");

    if (lower != NULL && upper != NULL)
    {
        if (lower -> module != upper -> module || lower -> line != upper -> line)
            yyerror("Lower and upper bounds are from different timelines");

        if (lower == upper)
            yyerror("Lower and upper bounds must be different");

        if (lower -> order > upper -> order)
            yyerror("Later version specified as lower bound");
    }

    /* Go through each slot in the relevant timeline. */

    if (lower != NULL)
    {
        mod = lower -> module;
        line = lower -> line;
    }
    else
    {
        mod = upper -> module;
        line = upper -> line;
    }

    this = FALSE;

    for (qd = mod -> qualifiers; qd != NULL; qd = qd -> next)
    {
        if (qd -> qtype != time_qualifier || qd -> line != line)
            continue;

        if (lower != NULL && qd -> order < lower -> order)
            continue;

        if (upper != NULL && qd -> order >= upper -> order)
            continue;

        /*
         * This is within the required range so if it is also needed
         * then the expression is true.
         */

        if (isNeeded(qd))
        {
            this = TRUE;
            break;
        }
    }

    return this;
}


/*
 * Return the value of an expression involving a single platform or feature.
 */
static int platOrFeature(char *name,int optnot)
{
    int this;
    qualDef *qd;

    if ((qd = findQualifier(name)) == NULL || qd -> qtype == time_qualifier)
        yyerror("No such platform or feature");

    /* Assume this sub-expression is false. */

    this = FALSE;

    if (qd -> qtype == feature_qualifier)
    {
        if (!excludedFeature(excludedQualifiers,qd))
            this = TRUE;
    }
    else if (isNeeded(qd))
        this = TRUE;

    if (optnot)
        this = !this;

    return this;
}


/*
 * Return TRUE if the given qualifier is excluded.
 */
int excludedFeature(stringList *xsl,qualDef *qd)
{
    while (xsl != NULL)
    {
        if (strcmp(qd -> name,xsl -> s) == 0)
            return TRUE;

        xsl = xsl -> next;
    }

    return FALSE;
}


/*
 * Return TRUE if the given qualifier is needed.
 */
static int isNeeded(qualDef *qd)
{
    stringList *sl;

    for (sl = neededQualifiers; sl != NULL; sl = sl -> next)
        if (strcmp(qd -> name,sl -> s) == 0)
            return TRUE;

    return FALSE;
}


/*
 * Return the current scope.  currentScope() is only valid if notSkipping()
 * returns non-zero.
 */
static classDef *currentScope(void)
{
    return (currentScopeIdx > 0 ? scopeStack[currentScopeIdx - 1] : NULL);
}


/*
 * Create a new qualifier.
 */
static void newQualifier(moduleDef *mod, int line, int order, char *name,
        qualType qt)
{
    qualDef *qd;

    /* Check it doesn't already exist. */

    if (findQualifier(name) != NULL)
        yyerror("Version is already defined");

    qd = sipMalloc(sizeof (qualDef));
    qd->name = name;
    qd->qtype = qt;
    qd->module = mod;
    qd->line = line;
    qd->order = order;
    qd->next = mod -> qualifiers;
    mod->qualifiers = qd;
}


/*
 * Create a new imported module.
 */
static void newImport(char *filename)
{
    moduleDef *from, *mod;
    moduleListDef *mld;

    /* Create a new module if it has not already been defined. */
    for (mod = currentSpec->modules; mod != NULL; mod = mod->next)
        if (strcmp(mod->file, filename) == 0)
            break;

    from = currentModule;

    if (mod == NULL)
    {
        newModule(NULL, filename);
        mod = currentModule;
    }
    else if (from->encoding == no_type)
    {
        /* Import any defaults from the already parsed module. */
        from->encoding = mod->encoding;
    }

    /* Add the new import unless it has already been imported. */
    for (mld = from->imports; mld != NULL; mld = mld->next)
        if (mld->module == mod)
            return;

    mld = sipMalloc(sizeof (moduleListDef));
    mld->module = mod;
    mld->next = from->imports;

    from->imports = mld;
}


/*
 * Set up pointers to hook names.
 */
static void getHooks(optFlags *optflgs,char **pre,char **post)
{
    optFlag *of;

    if ((of = findOptFlag(optflgs,"PreHook",name_flag)) != NULL)
        *pre = of -> fvalue.sval;
    else
        *pre = NULL;

    if ((of = findOptFlag(optflgs,"PostHook",name_flag)) != NULL)
        *post = of -> fvalue.sval;
    else
        *post = NULL;
}


/*
 * Get the /Transfer/ option flag.
 */
static int getTransfer(optFlags *optflgs)
{
    return (findOptFlag(optflgs, "Transfer", bool_flag) != NULL);
}


/*
 * Get the /ReleaseGIL/ option flag.
 */
static int getReleaseGIL(optFlags *optflgs)
{
    return (findOptFlag(optflgs, "ReleaseGIL", bool_flag) != NULL);
}


/*
 * Get the /HoldGIL/ option flag.
 */
static int getHoldGIL(optFlags *optflgs)
{
    return (findOptFlag(optflgs, "HoldGIL", bool_flag) != NULL);
}


/*
 * Get the /Deprecated/ option flag.
 */
static int getDeprecated(optFlags *optflgs)
{
    return (findOptFlag(optflgs, "Deprecated", bool_flag) != NULL);
}


/*
 * Get the /AllowNone/ option flag.
 */
static int getAllowNone(optFlags *optflgs)
{
    return (findOptFlag(optflgs, "AllowNone", bool_flag) != NULL);
}


/*
 * Get the /DocType/ option flag.
 */
static const char *getDocType(optFlags *optflgs)
{
    optFlag *of = findOptFlag(optflgs, "DocType", string_flag);

    if (of == NULL)
        return NULL;

    return of->fvalue.sval;
}


/*
 * Get the /DocValue/ option flag.
 */
static const char *getDocValue(optFlags *optflgs)
{
    optFlag *of = findOptFlag(optflgs, "DocValue", string_flag);

    if (of == NULL)
        return NULL;

    return of->fvalue.sval;
}


/*
 * Return TRUE if the PyTQt plugin was specified.
 */
int pluginPyTQt(sipSpec *pt)
{
    return stringFind(pt->plugins, "PyTQt");
}


/*
 * Return TRUE if a list of strings contains a given entry.
 */
static int stringFind(stringList *sl, const char *s)
{
    while (sl != NULL)
    {
        if (strcmp(sl->s, s) == 0)
            return TRUE;

        sl = sl->next;
    }

    return FALSE;
}


/*
 * Set the name of a module.
 */
static void setModuleName(sipSpec *pt, moduleDef *mod, const char *fullname)
{
    mod->fullname = cacheName(pt, fullname);

    if (inMainModule())
        setIsUsedName(mod->fullname);

    if ((mod->name = strrchr(fullname, '.')) != NULL)
        mod->name++;
    else
        mod->name = fullname;
}


/*
 * Define a new class and set its name.
 */
static void defineClass(scopedNameDef *snd, classList *supers, optFlags *of)
{
    classDef *cd, *c_scope = currentScope();

    cd = newClass(currentSpec, class_iface, getAPIRange(of),
            scopeScopedName((c_scope != NULL ? c_scope->iff : NULL), snd));
    cd->supers = supers;

    pushScope(cd);
}


/*
 * Complete the definition of a class.
 */
static classDef *completeClass(scopedNameDef *snd, optFlags *of, int has_def)
{
    classDef *cd = currentScope();

    /* See if the class was defined or just declared. */
    if (has_def)
    {
        if (snd->next != NULL)
            yyerror("A scoped name cannot be given in a class/struct definition");

    }
    else if (cd->supers != NULL)
        yyerror("Class/struct has super-classes but no definition");
    else
        setIsOpaque(cd);

    finishClass(currentSpec, currentModule, cd, of);
    popScope();

    /*
     * Check that external classes have only been declared at the global scope.
     */
    if (isExternal(cd) && currentScope() != NULL)
        yyerror("External classes/structs can only be declared in the global scope");

    return cd;
}


/*
 * Add a variable to the list so that the list remains sorted.
 */
static void addVariable(sipSpec *pt, varDef *vd)
{
    varDef **at = &pt->vars;

    while (*at != NULL)
    {
        if (strcmp(vd->pyname->text, (*at)->pyname->text) < 0)
            break;

        at = &(*at)->next;
    }

    vd->next = *at;
    *at = vd;
}


/*
 * Update a type according to optional flags.
 */
static void applyTypeFlags(moduleDef *mod, argDef *ad, optFlags *flags)
{
    ad->doctype = getDocType(flags);

    if (ad->atype == string_type && !isArray(ad) && !isReference(ad))
    {
        optFlag *of;

        if ((of = findOptFlag(flags, "Encoding", string_flag)) == NULL)
        {
            if (mod->encoding != no_type)
                ad->atype = mod->encoding;
            else
                ad->atype = string_type;
        }
        else if ((ad->atype = convertEncoding(of->fvalue.sval)) == no_type)
            yyerror("The value of the /Encoding/ annotation must be one of \"ASCII\", \"Latin-1\", \"UTF-8\" or \"None\"");
    }
}


/*
 * Return the argument type for a string with the given encoding or no_type if
 * the encoding was invalid.
 */
static argType convertEncoding(const char *encoding)
{
    if (strcmp(encoding, "ASCII") == 0)
        return ascii_string_type;

    if (strcmp(encoding, "Latin-1") == 0)
        return latin1_string_type;

    if (strcmp(encoding, "UTF-8") == 0)
        return utf8_string_type;

    if (strcmp(encoding, "None") == 0)
        return string_type;

    return no_type;
}


/*
 * Get the /API/ option flag.
 */
static apiVersionRangeDef *getAPIRange(optFlags *optflgs)
{
    optFlag *of;

    if ((of = findOptFlag(optflgs, "API", api_range_flag)) == NULL)
        return NULL;

    return of->fvalue.aval;
}


/*
 * Return the API range structure and version number corresponding to the
 * given API range.
 */
static apiVersionRangeDef *convertAPIRange(moduleDef *mod, nameDef *name,
        int from, int to)
{
    int index;
    apiVersionRangeDef *avd, **avdp;

    /* Handle the trivial case. */
    if (from == 0 && to == 0)
        return NULL;

    for (index = 0, avdp = &mod->api_ranges; (*avdp) != NULL; avdp = &(*avdp)->next, ++index)
    {
        avd = *avdp;

        if (avd->api_name == name && avd->from == from && avd->to == to)
            return avd;
    }

    /* The new one must be appended so that version numbers remain valid. */
    avd = sipMalloc(sizeof (apiVersionRangeDef));

    avd->api_name = name;
    avd->from = from;
    avd->to = to;
    avd->index = index;

    avd->next = NULL;
    *avdp = avd;

    return avd;
}


/*
 * Return TRUE if a signature with annotations uses keyword arguments.
 */
static int usesKeywordArgs(optFlags *optflgs, signatureDef *sd)
{
    int kwd_args_anno, no_kwd_args_anno;

    kwd_args_anno = (findOptFlag(optflgs, "KeywordArgs", bool_flag) != NULL);
    no_kwd_args_anno = (findOptFlag(optflgs, "NoKeywordArgs", bool_flag) != NULL);

    /*
     * An ellipsis cannot be used with keyword arguments.  Only complain if it
     * has been explicitly requested.
     */
    if (kwd_args_anno && sd->nrArgs > 0 && sd->args[sd->nrArgs - 1].atype == ellipsis_type)
        yyerror("/KeywordArgs/ cannot be specified for calls with a variable number of arguments");

    if ((defaultKwdArgs || kwd_args_anno) && !no_kwd_args_anno)
    {
        int a, is_name = FALSE;

        /*
         * Mark argument names as being used and check there is at least one.
         */
        for (a = 0; a < sd->nrArgs; ++a)
        {
            nameDef *nd = sd->args[a].name;

            if (sd->args[a].name != NULL)
            {
                setIsUsedName(nd);
                is_name = TRUE;
            }
        }

        return is_name;
    }

    return FALSE;
}


/*
 * Extract the version of a string value optionally associated with a
 * particular feature.
 */
static char *convertFeaturedString(char *fs)
{
    while (fs != NULL)
    {
        char *next, *value;

        /* Individual values are ';' separated. */
        if ((next = strchr(fs, ';')) != NULL)
            *next++ = '\0';

        /* Features and values are ':' separated. */
        if ((value = strchr(fs, ':')) == NULL)
        {
            /* This is an unconditional value so just return it. */
            return strip(fs);
        }

        *value++ = '\0';

        if (isEnabledFeature(strip(fs)))
            return strip(value);

        fs = next;
    }

    /* No value was enabled. */
    return NULL;
}


/*
 * Return the stripped version of a string.
 */
static char *strip(char *s)
{
    while (*s == ' ')
        ++s;

    if (*s != '\0')
    {
        char *cp = &s[strlen(s) - 1];

        while (*cp == ' ')
            *cp-- = '\0';
    }

    return s;
}


/*
 * Return TRUE if the given feature is enabled.
 */
static int isEnabledFeature(const char *name)
{
    qualDef *qd;

    if ((qd = findQualifier(name)) == NULL || qd->qtype != feature_qualifier)
        yyerror("No such feature");

    return !excludedFeature(excludedQualifiers, qd);
}
#line 5292 "parser.c"

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 3:
#line 356 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /*
             * We don't do these in parserEOF() because the parser is reading
             * ahead and that would be too early.
             */

            if (previousFile != NULL)
            {
                handleEOF();

                if (currentContext.prevmod != NULL)
                    handleEOM();

                free(previousFile);
                previousFile = NULL;
            }
    }
break;
case 21:
#line 391 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentSpec->exphdrcode, yystack.l_mark[0].codeb);
        }
break;
case 22:
#line 395 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentModule->hdrcode, yystack.l_mark[0].codeb);
        }
break;
case 23:
#line 399 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentModule->cppcode, yystack.l_mark[0].codeb);
        }
break;
case 46:
#line 427 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope == NULL)
                    yyerror("%TypeHeaderCode can only be used in a namespace, class or mapped type");

                appendCodeBlock(&scope->iff->hdrcode, yystack.l_mark[0].codeb);
            }
        }
break;
case 47:
#line 440 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if ((currentModule->encoding = convertEncoding(yystack.l_mark[0].text)) == no_type)
                    yyerror("The value of %DefaultEncoding must be one of \"ASCII\", \"Latin-1\", \"UTF-8\" or \"None\"");
            }
        }
break;
case 48:
#line 449 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            appendString(&currentSpec->plugins, yystack.l_mark[0].text);
        }
break;
case 49:
#line 454 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                apiVersionRangeDef *avd;

                if (findAPI(currentSpec, yystack.l_mark[-1].text) != NULL)
                    yyerror("The API name in the %API directive has already been defined");

                if (yystack.l_mark[0].number < 1)
                    yyerror("The version number in the %API directive must be greater than or equal to 1");

                avd = sipMalloc(sizeof (apiVersionRangeDef));

                avd->api_name = cacheName(currentSpec, yystack.l_mark[-1].text);
                avd->from = yystack.l_mark[0].number;
                avd->to = -1;

                avd->next = currentModule->api_versions;
                currentModule->api_versions = avd;

                if (inMainModule())
                    setIsUsedName(avd->api_name);
            }
        }
break;
case 50:
#line 480 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                exceptionDef *xd;
                const char *pyname;

                if (currentSpec->genc)
                    yyerror("%Exception not allowed in a C module");

                pyname = getPythonName(&yystack.l_mark[-5].optflags, scopedNameTail(yystack.l_mark[-7].scpvalp));

                checkAttributes(currentSpec, currentModule, NULL, NULL,
                        pyname, FALSE);

                xd = findException(currentSpec, yystack.l_mark[-7].scpvalp, TRUE);

                if (xd->cd != NULL)
                    yyerror("%Exception name has already been seen as a class name - it must be defined before being used");

                if (xd->iff->module != NULL)
                    yyerror("The %Exception has already been defined");

                /* Complete the definition. */
                xd->iff->module = currentModule;
                xd->iff->hdrcode = yystack.l_mark[-3].codeb;
                xd->pyname = pyname;
                xd->bibase = yystack.l_mark[-6].exceptionbase.bibase;
                xd->base = yystack.l_mark[-6].exceptionbase.base;
                xd->raisecode = yystack.l_mark[-2].codeb;

                if (findOptFlag(&yystack.l_mark[-5].optflags, "Default", bool_flag) != NULL)
                    currentModule->defexception = xd;

                if (xd->bibase != NULL || xd->base != NULL)
                    xd->exceptionnr = currentModule->nrexceptions++;
            }
        }
break;
case 51:
#line 519 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.exceptionbase.bibase = NULL;
            yyval.exceptionbase.base = NULL;
        }
break;
case 52:
#line 523 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            exceptionDef *xd;

            yyval.exceptionbase.bibase = NULL;
            yyval.exceptionbase.base = NULL;

            /* See if it is a defined exception. */
            for (xd = currentSpec->exceptions; xd != NULL; xd = xd->next)
                if (compareScopedNames(xd->iff->fqcname, yystack.l_mark[-1].scpvalp) == 0)
                {
                    yyval.exceptionbase.base = xd;
                    break;
                }

            if (xd == NULL && yystack.l_mark[-1].scpvalp->next == NULL && strncmp(yystack.l_mark[-1].scpvalp->name, "SIP_", 4) == 0)
            {
                /* See if it is a builtin exception. */

                static char *builtins[] = {
                    "Exception",
                    "StopIteration",
                    "StandardError",
                    "ArithmeticError",
                    "LookupError",
                    "AssertionError",
                    "AttributeError",
                    "EOFError",
                    "FloatingPointError",
                    "EnvironmentError",
                    "IOError",
                    "OSError",
                    "ImportError",
                    "IndexError",
                    "KeyError",
                    "KeyboardInterrupt",
                    "MemoryError",
                    "NameError",
                    "OverflowError",
                    "RuntimeError",
                    "NotImplementedError",
                    "SyntaxError",
                    "IndentationError",
                    "TabError",
                    "ReferenceError",
                    "SystemError",
                    "SystemExit",
                    "TypeError",
                    "UnboundLocalError",
                    "UnicodeError",
                    "UnicodeEncodeError",
                    "UnicodeDecodeError",
                    "UnicodeTranslateError",
                    "ValueError",
                    "ZeroDivisionError",
                    "WindowsError",
                    "VMSError",
                    NULL
                };

                char **cp;

                for (cp = builtins; *cp != NULL; ++cp)
                    if (strcmp(yystack.l_mark[-1].scpvalp->name + 4, *cp) == 0)
                    {
                        yyval.exceptionbase.bibase = *cp;
                        break;
                    }
            }

            if (yyval.exceptionbase.bibase == NULL && yyval.exceptionbase.base == NULL)
                yyerror("Unknown exception base type");
        }
break;
case 53:
#line 597 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 54:
#line 602 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                currentMappedType = newMappedType(currentSpec, &yystack.l_mark[-1].memArg, &yystack.l_mark[0].optflags);
        }
break;
case 56:
#line 608 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            int a;

            if (currentSpec->genc)
                yyerror("%MappedType templates not allowed in a C module");

            /* Check the template arguments are basic types or simple names. */
            for (a = 0; a < yystack.l_mark[-3].signature.nrArgs; ++a)
            {
                argDef *ad = &yystack.l_mark[-3].signature.args[a];

                if (ad->atype == defined_type && ad->u.snd->next != NULL)
                    yyerror("%MappedType template arguments must be simple names");
            }

            if (yystack.l_mark[-1].memArg.atype != template_type)
                yyerror("%MappedType template must map a template type");

            if (notSkipping())
            {
                mappedTypeTmplDef *mtt;
                ifaceFileDef *iff;

                /* Check a template hasn't already been provided. */
                for (mtt = currentSpec->mappedtypetemplates; mtt != NULL; mtt = mtt->next)
                    if (compareScopedNames(mtt->mt->type.u.td->fqname, yystack.l_mark[-1].memArg.u.td->fqname) == 0 && sameTemplateSignature(&mtt->mt->type.u.td->types, &yystack.l_mark[-1].memArg.u.td->types, TRUE))
                        yyerror("%MappedType template for this type has already been defined");

                yystack.l_mark[-1].memArg.nrderefs = 0;
                yystack.l_mark[-1].memArg.argflags = 0;

                mtt = sipMalloc(sizeof (mappedTypeTmplDef));

                mtt->sig = yystack.l_mark[-3].signature;
                mtt->mt = allocMappedType(currentSpec, &yystack.l_mark[-1].memArg);
                mtt->mt->doctype = getDocType(&yystack.l_mark[0].optflags);
                mtt->next = currentSpec->mappedtypetemplates;

                currentSpec->mappedtypetemplates = mtt;

                currentMappedType = mtt->mt;

                /* Create a dummy interface file. */
                iff = sipMalloc(sizeof (ifaceFileDef));
                iff->hdrcode = NULL;
                mtt->mt->iff = iff;
            }
        }
break;
case 58:
#line 658 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if (currentMappedType->convfromcode == NULL)
                    yyerror("%MappedType must have a %ConvertFromTypeCode directive");

                if (currentMappedType->convtocode == NULL)
                    yyerror("%MappedType must have a %ConvertToTypeCode directive");

                currentMappedType = NULL;
            }
        }
break;
case 61:
#line 676 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentMappedType->iff->hdrcode, yystack.l_mark[0].codeb);
        }
break;
case 62:
#line 680 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if (currentMappedType -> convfromcode != NULL)
                    yyerror("%MappedType has more than one %ConvertFromTypeCode directive");

                currentMappedType -> convfromcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 63:
#line 689 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if (currentMappedType -> convtocode != NULL)
                    yyerror("%MappedType has more than one %ConvertToTypeCode directive");

                currentMappedType -> convtocode = yystack.l_mark[0].codeb;
            }
        }
break;
case 66:
#line 702 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                applyTypeFlags(currentModule, &yystack.l_mark[-11].memArg, &yystack.l_mark[-4].optflags);

                yystack.l_mark[-8].signature.result = yystack.l_mark[-11].memArg;

                newFunction(currentSpec, currentModule, NULL,
                        currentMappedType, 0, TRUE, FALSE, FALSE, FALSE, yystack.l_mark[-10].text,
                        &yystack.l_mark[-8].signature, yystack.l_mark[-6].number, FALSE, &yystack.l_mark[-4].optflags, yystack.l_mark[0].codeb, NULL, yystack.l_mark[-5].throwlist, yystack.l_mark[-3].optsignature, yystack.l_mark[-1].codeb);
            }
        }
break;
case 67:
#line 716 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec -> genc)
                yyerror("namespace definition not allowed in a C module");

            if (notSkipping())
            {
                classDef *ns, *c_scope;
                ifaceFileDef *scope;

                if ((c_scope = currentScope()) != NULL)
                    scope = c_scope->iff;
                else
                    scope = NULL;

                ns = newClass(currentSpec, namespace_iface, NULL,
                        text2scopedName(scope, yystack.l_mark[0].text));

                pushScope(ns);

                sectionFlags = 0;
            }
        }
break;
case 68:
#line 737 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if (inMainModule())
                {
                    classDef *ns = currentScope();

                    setIsUsedName(ns->iff->name);
                    setIsUsedName(ns->pyname);
                }

                popScope();
            }
        }
break;
case 71:
#line 757 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            qualDef *qd;

            for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
                if (qd -> qtype == platform_qualifier)
                    yyerror("%Platforms has already been defined for this module");
        }
break;
case 72:
#line 764 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            qualDef *qd;
            int nrneeded;

            /*
             * Check that exactly one platform in the set was
             * requested.
             */

            nrneeded = 0;

            for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
                if (qd -> qtype == platform_qualifier && isNeeded(qd))
                    ++nrneeded;

            if (nrneeded > 1)
                yyerror("No more than one of these %Platforms must be specified with the -t flag");
        }
break;
case 75:
#line 788 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            newQualifier(currentModule,-1,-1,yystack.l_mark[0].text,platform_qualifier);
        }
break;
case 76:
#line 793 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            newQualifier(currentModule,-1,-1,yystack.l_mark[0].text,feature_qualifier);
        }
break;
case 77:
#line 798 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            currentTimelineOrder = 0;
        }
break;
case 78:
#line 801 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            qualDef *qd;
            int nrneeded;

            /*
             * Check that exactly one time slot in the set was
             * requested.
             */

            nrneeded = 0;

            for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
                if (qd -> qtype == time_qualifier && isNeeded(qd))
                    ++nrneeded;

            if (nrneeded > 1)
                yyerror("At most one of this %Timeline must be specified with the -t flag");

            currentModule -> nrtimelines++;
        }
break;
case 81:
#line 827 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            newQualifier(currentModule,currentModule -> nrtimelines,currentTimelineOrder++,yystack.l_mark[0].text,time_qualifier);
        }
break;
case 82:
#line 832 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (skipStackPtr >= MAX_NESTED_IF)
                yyerror("Internal error: increase the value of MAX_NESTED_IF");

            /* Nested %Ifs are implicit logical ands. */

            if (skipStackPtr > 0)
                yystack.l_mark[-1].boolean = (yystack.l_mark[-1].boolean && skipStack[skipStackPtr - 1]);

            skipStack[skipStackPtr++] = yystack.l_mark[-1].boolean;
        }
break;
case 83:
#line 845 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = platOrFeature(yystack.l_mark[0].text,FALSE);
        }
break;
case 84:
#line 848 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = platOrFeature(yystack.l_mark[0].text,TRUE);
        }
break;
case 85:
#line 851 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = (platOrFeature(yystack.l_mark[0].text,FALSE) || yystack.l_mark[-2].boolean);
        }
break;
case 86:
#line 854 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = (platOrFeature(yystack.l_mark[0].text,TRUE) || yystack.l_mark[-3].boolean);
        }
break;
case 88:
#line 860 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = timePeriod(yystack.l_mark[-2].text,yystack.l_mark[0].text);
        }
break;
case 89:
#line 865 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (skipStackPtr-- <= 0)
                yyerror("Too many %End directives");
        }
break;
case 90:
#line 871 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            optFlag *of;

            if (yystack.l_mark[0].optflags.nrFlags == 0)
                yyerror("%License details not specified");

            if ((of = findOptFlag(&yystack.l_mark[0].optflags,"Type",string_flag)) == NULL)
                yyerror("%License type not specified");

            currentModule -> license = sipMalloc(sizeof (licenseDef));

            currentModule -> license -> type = of -> fvalue.sval;

            currentModule -> license -> licensee = 
                ((of = findOptFlag(&yystack.l_mark[0].optflags,"Licensee",string_flag)) != NULL)
                    ? of -> fvalue.sval : NULL;

            currentModule -> license -> timestamp = 
                ((of = findOptFlag(&yystack.l_mark[0].optflags,"Timestamp",string_flag)) != NULL)
                    ? of -> fvalue.sval : NULL;

            currentModule -> license -> sig = 
                ((of = findOptFlag(&yystack.l_mark[0].optflags,"Signature",string_flag)) != NULL)
                    ? of -> fvalue.sval : NULL;
        }
break;
case 91:
#line 898 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if (currentModule->defmetatype != NULL)
                    yyerror("%DefaultMetatype has already been defined for this module");

                currentModule->defmetatype = cacheName(currentSpec, yystack.l_mark[0].text);
            }
        }
break;
case 92:
#line 909 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if (currentModule->defsupertype != NULL)
                    yyerror("%DefaultSupertype has already been defined for this module");

                currentModule->defsupertype = cacheName(currentSpec, yystack.l_mark[0].text);
            }
        }
break;
case 93:
#line 920 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Make sure this is the first mention of a module. */
            if (currentSpec->module != currentModule)
                yyerror("A %ConsolidatedModule cannot be %Imported");

            if (currentModule->fullname != NULL)
                yyerror("%ConsolidatedModule must appear before any %Module or %CModule directive");

            setModuleName(currentSpec, currentModule, yystack.l_mark[0].text);
            setIsConsolidated(currentModule);
        }
break;
case 94:
#line 933 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Make sure this is the first mention of a module. */
            if (currentSpec->module != currentModule)
                yyerror("A %CompositeModule cannot be %Imported");

            if (currentModule->fullname != NULL)
                yyerror("%CompositeModule must appear before any %Module or %CModule directive");

            setModuleName(currentSpec, currentModule, yystack.l_mark[0].text);
            setIsComposite(currentModule);
        }
break;
case 95:
#line 946 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Check the module hasn't already been defined. */

            moduleDef *mod;

            for (mod = currentSpec->modules; mod != NULL; mod = mod->next)
                if (mod->fullname != NULL && strcmp(mod->fullname->text, yystack.l_mark[-1].text) == 0)
                    yyerror("Module is already defined");

            /*
             * If we are in a container module then create a component module
             * and make it current.
             */
            if (isContainer(currentModule) || currentModule->container != NULL)
            {
                mod = allocModule();

                mod->file = currentContext.filename;
                mod->container = (isContainer(currentModule) ? currentModule : currentModule->container);

                currentModule = mod;
            }

            setModuleName(currentSpec, currentModule, yystack.l_mark[-1].text);
            currentModule->version = yystack.l_mark[0].number;

            if (currentSpec->genc < 0)
                currentSpec->genc = yystack.l_mark[-2].boolean;
            else if (currentSpec->genc != yystack.l_mark[-2].boolean)
                yyerror("Cannot mix C and C++ modules");
        }
break;
case 96:
#line 979 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = FALSE;
        }
break;
case 97:
#line 982 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = TRUE;
        }
break;
case 99:
#line 988 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /*
             * The grammar design is a bit broken and this is the easiest way
             * to allow periods in names.
             */

            char *cp;

            for (cp = yystack.l_mark[0].text; *cp != '\0'; ++cp)
                if (*cp != '.' && *cp != '_' && !isalnum(*cp))
                    yyerror("Invalid character in name");

            yyval.text = yystack.l_mark[0].text;
        }
break;
case 100:
#line 1004 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = -1;
        }
break;
case 102:
#line 1010 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            parseFile(NULL, yystack.l_mark[0].text, NULL, FALSE);
        }
break;
case 103:
#line 1015 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            parseFile(NULL, yystack.l_mark[0].text, NULL, TRUE);
        }
break;
case 104:
#line 1020 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            newImport(yystack.l_mark[0].text);
        }
break;
case 105:
#line 1025 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = NULL;
        }
break;
case 106:
#line 1028 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 107:
#line 1033 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = NULL;
        }
break;
case 108:
#line 1036 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 109:
#line 1041 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = NULL;
        }
break;
case 110:
#line 1044 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 111:
#line 1049 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            appendCodeBlock(&currentModule->copying, yystack.l_mark[0].codeb);
        }
break;
case 112:
#line 1054 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 113:
#line 1059 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 114:
#line 1064 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 115:
#line 1069 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = NULL;
        }
break;
case 117:
#line 1075 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 118:
#line 1080 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 119:
#line 1085 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 120:
#line 1090 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 121:
#line 1095 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 122:
#line 1100 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 123:
#line 1105 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 124:
#line 1110 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 125:
#line 1115 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 126:
#line 1120 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 127:
#line 1125 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 128:
#line 1130 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentModule->preinitcode, yystack.l_mark[0].codeb);
        }
break;
case 129:
#line 1136 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentModule->initcode, yystack.l_mark[0].codeb);
        }
break;
case 130:
#line 1142 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentModule->postinitcode, yystack.l_mark[0].codeb);
        }
break;
case 131:
#line 1148 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentModule->unitcode, yystack.l_mark[0].codeb);
        }
break;
case 132:
#line 1154 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /*
             * This is a no-op and is retained for compatibility
             * until the last use of it (by SIP-TQt v3) can be removed
             * from PyTQt.
             */
        }
break;
case 133:
#line 1163 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (inMainModule())
                appendCodeBlock(&currentSpec -> docs,yystack.l_mark[0].codeb);
        }
break;
case 134:
#line 1169 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            appendCodeBlock(&currentSpec -> docs,yystack.l_mark[0].codeb);
        }
break;
case 135:
#line 1174 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (inMainModule())
                yywarning("%Makefile is ignored, please use the -b flag instead");
        }
break;
case 138:
#line 1184 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[-1].codeb;

            append(&yyval.codeb->frag, yystack.l_mark[0].codeb->frag);

            free(yystack.l_mark[0].codeb->frag);
            free((char *)yystack.l_mark[0].codeb->filename);
            free(yystack.l_mark[0].codeb);
        }
break;
case 139:
#line 1195 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if (sectionFlags != 0 && (sectionFlags & ~(SECT_IS_PUBLIC | SECT_IS_PROT)) != 0)
                    yyerror("Class enums must be in the public or protected sections");

                currentEnum = newEnum(currentSpec, currentModule,
                        currentMappedType, yystack.l_mark[-1].text, &yystack.l_mark[0].optflags, sectionFlags);
            }
        }
break;
case 141:
#line 1207 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.text = NULL;
        }
break;
case 142:
#line 1210 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.text = yystack.l_mark[0].text;
        }
break;
case 143:
#line 1215 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.text = NULL;
        }
break;
case 144:
#line 1218 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.text = yystack.l_mark[0].text;
        }
break;
case 151:
#line 1233 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                enumMemberDef *emd, **tail;

                /* Note that we don't use the assigned value. */
                emd = sipMalloc(sizeof (enumMemberDef));

                emd -> pyname = cacheName(currentSpec, getPythonName(&yystack.l_mark[-1].optflags, yystack.l_mark[-3].text));
                emd -> cname = yystack.l_mark[-3].text;
                emd -> ed = currentEnum;
                emd -> next = NULL;

                checkAttributes(currentSpec, currentModule, emd->ed->ecd,
                        emd->ed->emtd, emd->pyname->text, FALSE);

                /* Append to preserve the order. */
                for (tail = &currentEnum->members; *tail != NULL; tail = &(*tail)->next)
                    ;

                *tail = emd;

                if (inMainModule())
                    setIsUsedName(emd -> pyname);
            }
        }
break;
case 156:
#line 1269 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.valp = NULL;
        }
break;
case 157:
#line 1272 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.valp = yystack.l_mark[0].valp;
        }
break;
case 159:
#line 1278 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            valueDef *vd;
 
            if (yystack.l_mark[-2].valp -> vtype == string_value || yystack.l_mark[0].valp -> vtype == string_value)
                yyerror("Invalid binary operator for string");
 
            /* Find the last value in the existing expression. */
 
            for (vd = yystack.l_mark[-2].valp; vd -> next != NULL; vd = vd -> next)
                ;
 
            vd -> vbinop = yystack.l_mark[-1].qchar;
            vd -> next = yystack.l_mark[0].valp;

            yyval.valp = yystack.l_mark[-2].valp;
        }
break;
case 160:
#line 1296 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '-';
        }
break;
case 161:
#line 1299 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '+';
        }
break;
case 162:
#line 1302 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '*';
        }
break;
case 163:
#line 1305 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '/';
        }
break;
case 164:
#line 1308 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '&';
        }
break;
case 165:
#line 1311 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '|';
        }
break;
case 166:
#line 1316 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '\0';
        }
break;
case 167:
#line 1319 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '!';
        }
break;
case 168:
#line 1322 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '~';
        }
break;
case 169:
#line 1325 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '-';
        }
break;
case 170:
#line 1328 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.qchar = '+';
        }
break;
case 171:
#line 1333 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (yystack.l_mark[-1].qchar != '\0' && yystack.l_mark[0].value.vtype == string_value)
                yyerror("Invalid unary operator for string");
 
            /*
             * Convert the value to a simple expression on the
             * heap.
             */
 
            yyval.valp = sipMalloc(sizeof (valueDef));
 
            *yyval.valp = yystack.l_mark[0].value;
            yyval.valp -> vunop = yystack.l_mark[-1].qchar;
            yyval.valp -> vbinop = '\0';
            yyval.valp -> next = NULL;
        }
break;
case 173:
#line 1352 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec -> genc)
                yyerror("Scoped names are not allowed in a C module");

            appendScopedName(&yystack.l_mark[-2].scpvalp,yystack.l_mark[0].scpvalp);
        }
break;
case 174:
#line 1360 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.scpvalp = text2scopePart(yystack.l_mark[0].text);
        }
break;
case 175:
#line 1365 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /*
             * We let the C++ compiler decide if the value is a valid one - no
             * point in building a full C++ parser here.
             */

            yyval.value.vtype = scoped_value;
            yyval.value.u.vscp = yystack.l_mark[0].scpvalp;
        }
break;
case 176:
#line 1374 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            fcallDef *fcd;

            fcd = sipMalloc(sizeof (fcallDef));
            *fcd = yystack.l_mark[-1].fcall;
            fcd -> type = yystack.l_mark[-3].memArg;

            yyval.value.vtype = fcall_value;
            yyval.value.u.fcd = fcd;
        }
break;
case 177:
#line 1384 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.value.vtype = real_value;
            yyval.value.u.vreal = yystack.l_mark[0].real;
        }
break;
case 178:
#line 1388 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.value.vtype = numeric_value;
            yyval.value.u.vnum = yystack.l_mark[0].number;
        }
break;
case 179:
#line 1392 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.value.vtype = numeric_value;
            yyval.value.u.vnum = 1;
        }
break;
case 180:
#line 1396 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.value.vtype = numeric_value;
            yyval.value.u.vnum = 0;
        }
break;
case 181:
#line 1400 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.value.vtype = numeric_value;
            yyval.value.u.vnum = 0;
        }
break;
case 182:
#line 1404 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.value.vtype = string_value;
            yyval.value.u.vstr = yystack.l_mark[0].text;
        }
break;
case 183:
#line 1408 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.value.vtype = qchar_value;
            yyval.value.u.vqchar = yystack.l_mark[0].qchar;
        }
break;
case 184:
#line 1414 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* No values. */

            yyval.fcall.nrArgs = 0;
        }
break;
case 185:
#line 1419 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* The single or first expression. */

            yyval.fcall.args[0] = yystack.l_mark[0].valp;
            yyval.fcall.nrArgs = 1;
        }
break;
case 186:
#line 1425 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Check that it wasn't ...(,expression...). */

            if (yyval.fcall.nrArgs == 0)
                yyerror("First argument to function call is missing");

            /* Check there is room. */

            if (yystack.l_mark[-2].fcall.nrArgs == MAX_NR_ARGS)
                yyerror("Too many arguments to function call");

            yyval.fcall = yystack.l_mark[-2].fcall;

            yyval.fcall.args[yyval.fcall.nrArgs] = yystack.l_mark[0].valp;
            yyval.fcall.nrArgs++;
        }
break;
case 187:
#line 1443 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                applyTypeFlags(currentModule, &yystack.l_mark[-3].memArg, &yystack.l_mark[-1].optflags);
                newTypedef(currentSpec, currentModule, yystack.l_mark[-2].text, &yystack.l_mark[-3].memArg, &yystack.l_mark[-1].optflags);
            }
        }
break;
case 188:
#line 1450 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                signatureDef *sig;
                argDef ftype;

                applyTypeFlags(currentModule, &yystack.l_mark[-9].memArg, &yystack.l_mark[-1].optflags);

                memset(&ftype, 0, sizeof (argDef));

                /* Create the full signature on the heap. */
                sig = sipMalloc(sizeof (signatureDef));
                *sig = yystack.l_mark[-3].signature;
                sig->result = yystack.l_mark[-9].memArg;

                /* Create the full type. */
                ftype.atype = function_type;
                ftype.nrderefs = yystack.l_mark[-7].number;
                ftype.u.sa = sig;

                newTypedef(currentSpec, currentModule, yystack.l_mark[-6].text, &ftype, &yystack.l_mark[-1].optflags);
            }
        }
break;
case 189:
#line 1475 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec -> genc && yystack.l_mark[0].scpvalp->next != NULL)
                yyerror("Namespaces not allowed in a C module");

            if (notSkipping())
                currentSupers = NULL;
        }
break;
case 190:
#line 1481 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                if (currentSpec->genc && currentSupers != NULL)
                    yyerror("Super-classes not allowed in a C module struct");

                defineClass(yystack.l_mark[-3].scpvalp, currentSupers, &yystack.l_mark[0].optflags);
                sectionFlags = SECT_IS_PUBLIC;
            }
        }
break;
case 191:
#line 1490 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                completeClass(yystack.l_mark[-6].scpvalp, &yystack.l_mark[-3].optflags, yystack.l_mark[-1].boolean);
        }
break;
case 192:
#line 1496 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{currentIsTemplate = TRUE;}
break;
case 193:
#line 1496 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec->genc)
                yyerror("Class templates not allowed in a C module");

            if (notSkipping())
            {
                classTmplDef *tcd;

                /*
                 * Make sure there is room for the extra class name argument.
                 */
                if (yystack.l_mark[-2].signature.nrArgs == MAX_NR_ARGS)
                    yyerror("Internal error - increase the value of MAX_NR_ARGS");

                tcd = sipMalloc(sizeof (classTmplDef));
                tcd->sig = yystack.l_mark[-2].signature;
                tcd->cd = yystack.l_mark[0].klass;
                tcd->next = currentSpec->classtemplates;

                currentSpec->classtemplates = tcd;
            }

            currentIsTemplate = FALSE;
        }
break;
case 194:
#line 1522 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.signature = yystack.l_mark[-1].signature;
        }
break;
case 195:
#line 1527 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec->genc)
                yyerror("Class definition not allowed in a C module");

            if (notSkipping())
                currentSupers = NULL;
        }
break;
case 196:
#line 1533 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                defineClass(yystack.l_mark[-3].scpvalp, currentSupers, &yystack.l_mark[0].optflags);
                sectionFlags = SECT_IS_PRIVATE;
            }
        }
break;
case 197:
#line 1539 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                yyval.klass = completeClass(yystack.l_mark[-6].scpvalp, &yystack.l_mark[-3].optflags, yystack.l_mark[-1].boolean);
        }
break;
case 202:
#line 1553 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                argDef ad;
                classDef *super;
                scopedNameDef *snd = yystack.l_mark[0].scpvalp;

                /*
                 * This is a hack to allow typedef'ed classes to be used before
                 * we have resolved the typedef definitions.  Unlike elsewhere,
                 * we require that the typedef is defined before being used.
                 */
                for (;;)
                {
                    ad.atype = no_type;
                    ad.argflags = 0;
                    ad.nrderefs = 0;
                    ad.original_type = NULL;

                    searchTypedefs(currentSpec, snd, &ad);

                    if (ad.atype != defined_type)
                        break;

                    if (ad.nrderefs != 0 || isConstArg(&ad) || isReference(&ad))
                        break;

                    snd = ad.u.snd;
                }

                if (ad.atype != no_type)
                    yyerror("Super-class list contains an invalid type");

                super = findClass(currentSpec, class_iface, NULL, snd);
                appendToClassList(&currentSupers, super);
            }
        }
break;
case 203:
#line 1592 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = FALSE;
        }
break;
case 204:
#line 1595 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.boolean = TRUE;
        }
break;
case 215:
#line 1612 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                /* Make sure this is before any ctor docstrings. */
                yystack.l_mark[0].codeb->next = scope->docstring;
                scope->docstring = yystack.l_mark[0].codeb;
            }
        }
break;
case 216:
#line 1622 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentScope()->cppcode, yystack.l_mark[0].codeb);
        }
break;
case 217:
#line 1626 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
                appendCodeBlock(&currentScope()->iff->hdrcode, yystack.l_mark[0].codeb);
        }
break;
case 218:
#line 1630 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->travcode != NULL)
                    yyerror("%GCTraverseCode already given for class");

                scope->travcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 219:
#line 1641 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->clearcode != NULL)
                    yyerror("%GCClearCode already given for class");

                scope->clearcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 220:
#line 1652 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->getbufcode != NULL)
                    yyerror("%BIGetBufferCode already given for class");

                scope->getbufcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 221:
#line 1663 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->releasebufcode != NULL)
                    yyerror("%BIReleaseBufferCode already given for class");

                scope->releasebufcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 222:
#line 1674 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->readbufcode != NULL)
                    yyerror("%BIGetReadBufferCode already given for class");

                scope->readbufcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 223:
#line 1685 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->writebufcode != NULL)
                    yyerror("%BIGetWriteBufferCode already given for class");

                scope->writebufcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 224:
#line 1696 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->segcountcode != NULL)
                    yyerror("%BIGetSegCountCode already given for class");

                scope->segcountcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 225:
#line 1707 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->charbufcode != NULL)
                    yyerror("%BIGetCharBufferCode already given for class");

                scope->charbufcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 226:
#line 1718 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->picklecode != NULL)
                    yyerror("%PickleCode already given for class");

                scope->picklecode = yystack.l_mark[0].codeb;
            }
        }
break;
case 230:
#line 1732 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->convtosubcode != NULL)
                    yyerror("Class has more than one %ConvertToSubClassCode directive");

                scope->convtosubcode = yystack.l_mark[0].codeb;
            }
        }
break;
case 231:
#line 1743 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->convtocode != NULL)
                    yyerror("Class has more than one %ConvertToTypeCode directive");

                scope->convtocode = yystack.l_mark[0].codeb;
            }
        }
break;
case 232:
#line 1754 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec -> genc)
                yyerror("public section not allowed in a C module");

            if (notSkipping())
                sectionFlags = SECT_IS_PUBLIC | yystack.l_mark[-1].number;
        }
break;
case 233:
#line 1761 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec -> genc)
                yyerror("protected section not allowed in a C module");

            if (notSkipping())
                sectionFlags = SECT_IS_PROT | yystack.l_mark[-1].number;
        }
break;
case 234:
#line 1768 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec -> genc)
                yyerror("private section not allowed in a C module");

            if (notSkipping())
                sectionFlags = SECT_IS_PRIVATE | yystack.l_mark[-1].number;
        }
break;
case 235:
#line 1775 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec -> genc)
                yyerror("signals section not allowed in a C module");

            if (notSkipping())
                sectionFlags = SECT_IS_SIGNAL;
        }
break;
case 236:
#line 1784 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = 0;
        }
break;
case 237:
#line 1787 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = SECT_IS_SLOT;
        }
break;
case 238:
#line 1792 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Note that we allow non-virtual dtors in C modules. */

            if (notSkipping())
            {
                classDef *cd = currentScope();

                if (strcmp(classBaseName(cd),yystack.l_mark[-8].text) != 0)
                    yyerror("Destructor doesn't have the same name as its class");

                if (isDtor(cd))
                    yyerror("Destructor has already been defined");

                if (currentSpec -> genc && yystack.l_mark[-1].codeb == NULL)
                    yyerror("Destructor in C modules must include %MethodCode");

                cd -> dealloccode = yystack.l_mark[-1].codeb;
                cd -> dtorcode = yystack.l_mark[0].codeb;
                cd -> dtorexceptions = yystack.l_mark[-5].throwlist;

                /*
                 * Note that we don't apply the protected/public hack to dtors
                 * as it (I think) may change the behaviour of the wrapped API.
                 */
                cd->classflags |= sectionFlags;

                if (yystack.l_mark[-4].number)
                {
                    if (!yystack.l_mark[-10].number)
                        yyerror("Abstract destructor must be virtual");

                    setIsAbstractClass(cd);
                }

                /*
                 * The class has a shadow if we have a virtual dtor or some
                 * dtor code.
                 */
                if (yystack.l_mark[-10].number || yystack.l_mark[0].codeb != NULL)
                {
                    if (currentSpec -> genc)
                        yyerror("Virtual destructor or %VirtualCatcherCode not allowed in a C module");

                    setHasShadow(cd);
                }

                if (getReleaseGIL(&yystack.l_mark[-3].optflags))
                    setIsReleaseGILDtor(cd);
                else if (getHoldGIL(&yystack.l_mark[-3].optflags))
                    setIsHoldGILDtor(cd);
            }
        }
break;
case 239:
#line 1846 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{currentCtorIsExplicit = TRUE;}
break;
case 242:
#line 1850 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Note that we allow ctors in C modules. */

            if (notSkipping())
            {
                if (currentSpec -> genc)
                {
                    if (yystack.l_mark[0].codeb == NULL && yystack.l_mark[-7].signature.nrArgs != 0)
                        yyerror("Constructors with arguments in C modules must include %MethodCode");

                    if (currentCtorIsExplicit)
                        yyerror("Explicit constructors not allowed in a C module");
                }

                if ((sectionFlags & (SECT_IS_PUBLIC | SECT_IS_PROT | SECT_IS_PRIVATE)) == 0)
                    yyerror("Constructor must be in the public, private or protected sections");

                newCtor(yystack.l_mark[-9].text, sectionFlags, &yystack.l_mark[-7].signature, &yystack.l_mark[-4].optflags, yystack.l_mark[0].codeb, yystack.l_mark[-5].throwlist, yystack.l_mark[-3].optsignature,
                        currentCtorIsExplicit, yystack.l_mark[-1].codeb);
            }

            free(yystack.l_mark[-9].text);

            currentCtorIsExplicit = FALSE;
        }
break;
case 243:
#line 1877 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.optsignature = NULL;
        }
break;
case 244:
#line 1880 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.optsignature = sipMalloc(sizeof (signatureDef));

            *yyval.optsignature = yystack.l_mark[-2].signature;
        }
break;
case 245:
#line 1887 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.optsignature = NULL;
        }
break;
case 246:
#line 1890 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.optsignature = sipMalloc(sizeof (signatureDef));

            *yyval.optsignature = yystack.l_mark[-2].signature;
            yyval.optsignature -> result = yystack.l_mark[-4].memArg;
        }
break;
case 247:
#line 1898 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = FALSE;
        }
break;
case 248:
#line 1901 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = TRUE;
        }
break;
case 249:
#line 1906 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                applyTypeFlags(currentModule, &yystack.l_mark[-13].memArg, &yystack.l_mark[-5].optflags);

                yystack.l_mark[-10].signature.result = yystack.l_mark[-13].memArg;

                newFunction(currentSpec, currentModule, currentScope(), NULL,
                        sectionFlags, currentIsStatic, currentIsSignal,
                        currentIsSlot, currentOverIsVirt, yystack.l_mark[-12].text, &yystack.l_mark[-10].signature, yystack.l_mark[-8].number, yystack.l_mark[-6].number, &yystack.l_mark[-5].optflags,
                        yystack.l_mark[-1].codeb, yystack.l_mark[0].codeb, yystack.l_mark[-7].throwlist, yystack.l_mark[-4].optsignature, yystack.l_mark[-2].codeb);
            }

            currentIsStatic = FALSE;
            currentIsSignal = FALSE;
            currentIsSlot = FALSE;
            currentOverIsVirt = FALSE;
        }
break;
case 250:
#line 1924 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /*
             * It looks like an assignment operator (though we don't bother to
             * check the types) so make sure it is private.
             */
            if (notSkipping())
            {
                classDef *cd = currentScope();

                if (cd == NULL || !(sectionFlags & SECT_IS_PRIVATE))
                    yyerror("Assignment operators may only be defined as private");

                setCannotAssign(cd);
            }

            currentIsStatic = FALSE;
            currentIsSignal = FALSE;
            currentIsSlot = FALSE;
            currentOverIsVirt = FALSE;
        }
break;
case 251:
#line 1944 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                classDef *cd = currentScope();

                applyTypeFlags(currentModule, &yystack.l_mark[-13].memArg, &yystack.l_mark[-4].optflags);

                /* Handle the unary '+' and '-' operators. */
                if ((cd != NULL && yystack.l_mark[-9].signature.nrArgs == 0) || (cd == NULL && yystack.l_mark[-9].signature.nrArgs == 1))
                {
                    if (strcmp(yystack.l_mark[-11].text, "__add__") == 0)
                        yystack.l_mark[-11].text = "__pos__";
                    else if (strcmp(yystack.l_mark[-11].text, "__sub__") == 0)
                        yystack.l_mark[-11].text = "__neg__";
                }

                yystack.l_mark[-9].signature.result = yystack.l_mark[-13].memArg;

                newFunction(currentSpec, currentModule, cd, NULL,
                        sectionFlags, currentIsStatic, currentIsSignal,
                        currentIsSlot, currentOverIsVirt, yystack.l_mark[-11].text, &yystack.l_mark[-9].signature, yystack.l_mark[-7].number, yystack.l_mark[-5].number,
                        &yystack.l_mark[-4].optflags, yystack.l_mark[-1].codeb, yystack.l_mark[0].codeb, yystack.l_mark[-6].throwlist, yystack.l_mark[-3].optsignature, NULL);
            }

            currentIsStatic = FALSE;
            currentIsSignal = FALSE;
            currentIsSlot = FALSE;
            currentOverIsVirt = FALSE;
        }
break;
case 252:
#line 1973 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                char *sname;
                classDef *scope = currentScope();

                if (scope == NULL || yystack.l_mark[-9].signature.nrArgs != 0)
                    yyerror("Operator casts must be specified in a class and have no arguments");

                applyTypeFlags(currentModule, &yystack.l_mark[-11].memArg, &yystack.l_mark[-4].optflags);

                switch (yystack.l_mark[-11].memArg.atype)
                {
                case defined_type:
                    sname = NULL;
                    break;

                case bool_type:
                case cbool_type:
                case short_type:
                case ushort_type:
                case int_type:
                case cint_type:
                case uint_type:
                    sname = "__int__";
                    break;

                case long_type:
                case ulong_type:
                case longlong_type:
                case ulonglong_type:
                    sname = "__long__";
                    break;

                case float_type:
                case cfloat_type:
                case double_type:
                case cdouble_type:
                    sname = "__float__";
                    break;

                default:
                    yyerror("Unsupported operator cast");
                }

                if (sname != NULL)
                {
                    yystack.l_mark[-9].signature.result = yystack.l_mark[-11].memArg;

                    newFunction(currentSpec, currentModule, scope, NULL,
                            sectionFlags, currentIsStatic, currentIsSignal,
                            currentIsSlot, currentOverIsVirt, sname, &yystack.l_mark[-9].signature, yystack.l_mark[-7].number,
                            yystack.l_mark[-5].number, &yystack.l_mark[-4].optflags, yystack.l_mark[-1].codeb, yystack.l_mark[0].codeb, yystack.l_mark[-6].throwlist, yystack.l_mark[-3].optsignature, NULL);
                }
                else
                {
                    argList *al;

                    /* Check it doesn't already exist. */
                    for (al = scope->casts; al != NULL; al = al->next)
                        if (compareScopedNames(yystack.l_mark[-11].memArg.u.snd, al->arg.u.snd) == 0)
                            yyerror("This operator cast has already been specified in this class");

                    al = sipMalloc(sizeof (argList));
                    al->arg = yystack.l_mark[-11].memArg;
                    al->next = scope->casts;

                    scope->casts = al;
                }
            }

            currentIsStatic = FALSE;
            currentIsSignal = FALSE;
            currentIsSlot = FALSE;
            currentOverIsVirt = FALSE;
        }
break;
case 253:
#line 2051 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__add__";}
break;
case 254:
#line 2052 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__sub__";}
break;
case 255:
#line 2053 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__mul__";}
break;
case 256:
#line 2054 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__div__";}
break;
case 257:
#line 2055 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__mod__";}
break;
case 258:
#line 2056 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__and__";}
break;
case 259:
#line 2057 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__or__";}
break;
case 260:
#line 2058 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__xor__";}
break;
case 261:
#line 2059 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__lshift__";}
break;
case 262:
#line 2060 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__rshift__";}
break;
case 263:
#line 2061 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__iadd__";}
break;
case 264:
#line 2062 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__isub__";}
break;
case 265:
#line 2063 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__imul__";}
break;
case 266:
#line 2064 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__idiv__";}
break;
case 267:
#line 2065 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__imod__";}
break;
case 268:
#line 2066 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__iand__";}
break;
case 269:
#line 2067 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__ior__";}
break;
case 270:
#line 2068 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__ixor__";}
break;
case 271:
#line 2069 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__ilshift__";}
break;
case 272:
#line 2070 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__irshift__";}
break;
case 273:
#line 2071 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__invert__";}
break;
case 274:
#line 2072 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__call__";}
break;
case 275:
#line 2073 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__getitem__";}
break;
case 276:
#line 2074 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__lt__";}
break;
case 277:
#line 2075 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__le__";}
break;
case 278:
#line 2076 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__eq__";}
break;
case 279:
#line 2077 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__ne__";}
break;
case 280:
#line 2078 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__gt__";}
break;
case 281:
#line 2079 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{yyval.text = "__ge__";}
break;
case 282:
#line 2082 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = FALSE;
        }
break;
case 283:
#line 2085 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = TRUE;
        }
break;
case 284:
#line 2090 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = 0;
        }
break;
case 285:
#line 2093 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (yystack.l_mark[0].number != 0)
                yyerror("Abstract virtual function '= 0' expected");

            yyval.number = TRUE;
        }
break;
case 286:
#line 2101 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.optflags.nrFlags = 0;
        }
break;
case 287:
#line 2104 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.optflags = yystack.l_mark[-1].optflags;
        }
break;
case 288:
#line 2110 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.optflags.flags[0] = yystack.l_mark[0].flag;
            yyval.optflags.nrFlags = 1;
        }
break;
case 289:
#line 2114 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Check there is room. */

            if (yystack.l_mark[-2].optflags.nrFlags == MAX_NR_FLAGS)
                yyerror("Too many optional flags");

            yyval.optflags = yystack.l_mark[-2].optflags;

            yyval.optflags.flags[yyval.optflags.nrFlags++] = yystack.l_mark[0].flag;
        }
break;
case 290:
#line 2126 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.flag.ftype = bool_flag;
            yyval.flag.fname = yystack.l_mark[0].text;
        }
break;
case 291:
#line 2130 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.flag = yystack.l_mark[0].flag;
            yyval.flag.fname = yystack.l_mark[-2].text;
        }
break;
case 292:
#line 2136 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.flag.ftype = (strchr(yystack.l_mark[0].text, '.') != NULL) ? dotted_name_flag : name_flag;
            yyval.flag.fvalue.sval = yystack.l_mark[0].text;
        }
break;
case 293:
#line 2140 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            apiVersionRangeDef *avd;
            int from, to;

            yyval.flag.ftype = api_range_flag;

            /* Check that the API is known. */
            if ((avd = findAPI(currentSpec, yystack.l_mark[-4].text)) == NULL)
                yyerror("unknown API name in API annotation");

            if (inMainModule())
                setIsUsedName(avd->api_name);

            /* Unbounded values are represented by 0. */
            if ((from = yystack.l_mark[-2].number) < 0)
                from = 0;

            if ((to = yystack.l_mark[0].number) < 0)
                to = 0;

            yyval.flag.fvalue.aval = convertAPIRange(currentModule, avd->api_name,
                    from, to);
        }
break;
case 294:
#line 2163 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.flag.ftype = string_flag;
            yyval.flag.fvalue.sval = convertFeaturedString(yystack.l_mark[0].text);
        }
break;
case 295:
#line 2167 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.flag.ftype = integer_flag;
            yyval.flag.fvalue.ival = yystack.l_mark[0].number;
        }
break;
case 296:
#line 2173 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 297:
#line 2178 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = NULL;
        }
break;
case 299:
#line 2184 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = NULL;
        }
break;
case 300:
#line 2187 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 301:
#line 2192 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = NULL;
        }
break;
case 302:
#line 2195 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.codeb = yystack.l_mark[0].codeb;
        }
break;
case 303:
#line 2200 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            int a, nrrxcon, nrrxdis, nrslotcon, nrslotdis, nrarray, nrarraysize;

            nrrxcon = nrrxdis = nrslotcon = nrslotdis = nrarray = nrarraysize = 0;

            for (a = 0; a < yystack.l_mark[0].signature.nrArgs; ++a)
            {
                argDef *ad = &yystack.l_mark[0].signature.args[a];

                switch (ad -> atype)
                {
                case rxcon_type:
                    ++nrrxcon;
                    break;

                case rxdis_type:
                    ++nrrxdis;
                    break;

                case slotcon_type:
                    ++nrslotcon;
                    break;

                case slotdis_type:
                    ++nrslotdis;
                    break;
                }

                if (isArray(ad))
                    ++nrarray;

                if (isArraySize(ad))
                    ++nrarraysize;
            }

            if (nrrxcon != nrslotcon || nrrxcon > 1)
                yyerror("SIP_RXOBJ_CON and SIP_SLOT_CON must both be given and at most once");

            if (nrrxdis != nrslotdis || nrrxdis > 1)
                yyerror("SIP_RXOBJ_DIS and SIP_SLOT_DIS must both be given and at most once");

            if (nrarray != nrarraysize || nrarray > 1)
                yyerror("/Array/ and /ArraySize/ must both be given and at most once");

            yyval.signature = yystack.l_mark[0].signature;
        }
break;
case 304:
#line 2248 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* No arguments. */

            yyval.signature.nrArgs = 0;
        }
break;
case 305:
#line 2253 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* The single or first argument. */

            yyval.signature.args[0] = yystack.l_mark[0].memArg;
            yyval.signature.nrArgs = 1;
        }
break;
case 306:
#line 2259 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Check that it wasn't ...(,arg...). */
            if (yystack.l_mark[-2].signature.nrArgs == 0)
                yyerror("First argument of the list is missing");

            /* Check there is nothing after an ellipsis. */
            if (yystack.l_mark[-2].signature.args[yystack.l_mark[-2].signature.nrArgs - 1].atype == ellipsis_type)
                yyerror("An ellipsis must be at the end of the argument list");

            /*
             * If this argument has no default value, then the
             * previous one mustn't either.
             */
            if (yystack.l_mark[0].memArg.defval == NULL && yystack.l_mark[-2].signature.args[yystack.l_mark[-2].signature.nrArgs - 1].defval != NULL)
                yyerror("Compulsory argument given after optional argument");

            /* Check there is room. */
            if (yystack.l_mark[-2].signature.nrArgs == MAX_NR_ARGS)
                yyerror("Internal error - increase the value of MAX_NR_ARGS");

            yyval.signature = yystack.l_mark[-2].signature;

            yyval.signature.args[yyval.signature.nrArgs] = yystack.l_mark[0].memArg;
            yyval.signature.nrArgs++;
        }
break;
case 307:
#line 2286 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg.atype = signal_type;
            yyval.memArg.argflags = ARG_IS_CONST;
            yyval.memArg.nrderefs = 0;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-2].text);
            yyval.memArg.defval = yystack.l_mark[0].valp;

            currentSpec -> sigslots = TRUE;
        }
break;
case 308:
#line 2295 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg.atype = slot_type;
            yyval.memArg.argflags = ARG_IS_CONST;
            yyval.memArg.nrderefs = 0;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-2].text);
            yyval.memArg.defval = yystack.l_mark[0].valp;

            currentSpec -> sigslots = TRUE;
        }
break;
case 309:
#line 2304 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg.atype = anyslot_type;
            yyval.memArg.argflags = ARG_IS_CONST;
            yyval.memArg.nrderefs = 0;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-2].text);
            yyval.memArg.defval = yystack.l_mark[0].valp;

            currentSpec -> sigslots = TRUE;
        }
break;
case 310:
#line 2313 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg.atype = rxcon_type;
            yyval.memArg.argflags = 0;
            yyval.memArg.nrderefs = 0;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-1].text);

            if (findOptFlag(&yystack.l_mark[0].optflags, "SingleShot", bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_SINGLE_SHOT;

            currentSpec -> sigslots = TRUE;
        }
break;
case 311:
#line 2324 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg.atype = rxdis_type;
            yyval.memArg.argflags = 0;
            yyval.memArg.nrderefs = 0;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-1].text);

            currentSpec -> sigslots = TRUE;
        }
break;
case 312:
#line 2332 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg.atype = slotcon_type;
            yyval.memArg.argflags = ARG_IS_CONST;
            yyval.memArg.nrderefs = 0;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-1].text);

            memset(&yystack.l_mark[-3].signature.result, 0, sizeof (argDef));
            yystack.l_mark[-3].signature.result.atype = void_type;

            yyval.memArg.u.sa = sipMalloc(sizeof (signatureDef));
            *yyval.memArg.u.sa = yystack.l_mark[-3].signature;

            currentSpec -> sigslots = TRUE;
        }
break;
case 313:
#line 2346 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg.atype = slotdis_type;
            yyval.memArg.argflags = ARG_IS_CONST;
            yyval.memArg.nrderefs = 0;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-1].text);

            memset(&yystack.l_mark[-3].signature.result, 0, sizeof (argDef));
            yystack.l_mark[-3].signature.result.atype = void_type;

            yyval.memArg.u.sa = sipMalloc(sizeof (signatureDef));
            *yyval.memArg.u.sa = yystack.l_mark[-3].signature;

            currentSpec -> sigslots = TRUE;
        }
break;
case 314:
#line 2360 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg.atype = tqobject_type;
            yyval.memArg.argflags = 0;
            yyval.memArg.nrderefs = 0;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-1].text);
        }
break;
case 315:
#line 2366 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg = yystack.l_mark[-1].memArg;
            yyval.memArg.defval = yystack.l_mark[0].valp;
        }
break;
case 316:
#line 2373 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{currentIsSignal = TRUE;}
break;
case 318:
#line 2374 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{currentIsSlot = TRUE;}
break;
case 321:
#line 2379 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{currentIsStatic = TRUE;}
break;
case 326:
#line 2389 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{currentOverIsVirt = TRUE;}
break;
case 329:
#line 2393 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (notSkipping())
            {
                /* Check the section. */

                if (sectionFlags != 0)
                {
                    if ((sectionFlags & SECT_IS_PUBLIC) == 0)
                        yyerror("Class variables must be in the public section");

                    if (!currentIsStatic && yystack.l_mark[-2].codeb != NULL)
                        yyerror("%AccessCode cannot be specified for non-static class variables");
                }

                if (currentIsStatic && currentSpec -> genc)
                    yyerror("Cannot have static members in a C structure");

                applyTypeFlags(currentModule, &yystack.l_mark[-6].memArg, &yystack.l_mark[-4].optflags);

                if (yystack.l_mark[-1].codeb != NULL || yystack.l_mark[0].codeb != NULL)
                {
                    if (yystack.l_mark[-2].codeb != NULL)
                        yyerror("Cannot mix %AccessCode and %GetCode or %SetCode");

                    if (currentScope() == NULL)
                        yyerror("Cannot specify %GetCode or %SetCode for global variables");
                }

                newVar(currentSpec,currentModule,yystack.l_mark[-5].text,currentIsStatic,&yystack.l_mark[-6].memArg,&yystack.l_mark[-4].optflags,yystack.l_mark[-2].codeb,yystack.l_mark[-1].codeb,yystack.l_mark[0].codeb);
            }

            currentIsStatic = FALSE;
        }
break;
case 330:
#line 2428 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg = yystack.l_mark[-2].memArg;
            yyval.memArg.nrderefs += yystack.l_mark[-1].number;
            yyval.memArg.argflags |= ARG_IS_CONST | yystack.l_mark[0].number;
        }
break;
case 331:
#line 2433 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg = yystack.l_mark[-2].memArg;
            yyval.memArg.nrderefs += yystack.l_mark[-1].number;
            yyval.memArg.argflags |= yystack.l_mark[0].number;
        }
break;
case 332:
#line 2440 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.memArg = yystack.l_mark[-2].memArg;
            yyval.memArg.name = cacheName(currentSpec, yystack.l_mark[-1].text);

            if (getAllowNone(&yystack.l_mark[0].optflags))
                yyval.memArg.argflags |= ARG_ALLOW_NONE;

            if (findOptFlag(&yystack.l_mark[0].optflags,"GetWrapper",bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_GET_WRAPPER;

            if (findOptFlag(&yystack.l_mark[0].optflags,"Array",bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_ARRAY;

            if (findOptFlag(&yystack.l_mark[0].optflags,"ArraySize",bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_ARRAY_SIZE;

            if (getTransfer(&yystack.l_mark[0].optflags))
                yyval.memArg.argflags |= ARG_XFERRED;

            if (findOptFlag(&yystack.l_mark[0].optflags,"TransferThis",bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_THIS_XFERRED;

            if (findOptFlag(&yystack.l_mark[0].optflags,"TransferBack",bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_XFERRED_BACK;

            if (findOptFlag(&yystack.l_mark[0].optflags, "KeepReference", bool_flag) != NULL)
            {
                yyval.memArg.argflags |= ARG_KEEP_REF;
                yyval.memArg.key = currentModule->next_key++;
            }

            if (findOptFlag(&yystack.l_mark[0].optflags,"In",bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_IN;

            if (findOptFlag(&yystack.l_mark[0].optflags,"Out",bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_OUT;

            if (findOptFlag(&yystack.l_mark[0].optflags, "ResultSize", bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_RESULT_SIZE;

            if (findOptFlag(&yystack.l_mark[0].optflags, "NoCopy", bool_flag) != NULL)
                yyval.memArg.argflags |= ARG_NO_COPY;

            if (findOptFlag(&yystack.l_mark[0].optflags,"Constrained",bool_flag) != NULL)
            {
                yyval.memArg.argflags |= ARG_CONSTRAINED;

                switch (yyval.memArg.atype)
                {
                case bool_type:
                    yyval.memArg.atype = cbool_type;
                    break;

                case int_type:
                    yyval.memArg.atype = cint_type;
                    break;

                case float_type:
                    yyval.memArg.atype = cfloat_type;
                    break;

                case double_type:
                    yyval.memArg.atype = cdouble_type;
                    break;
                }
            }

            applyTypeFlags(currentModule, &yyval.memArg, &yystack.l_mark[0].optflags);
            yyval.memArg.docval = getDocValue(&yystack.l_mark[0].optflags);
        }
break;
case 333:
#line 2512 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = 0;
        }
break;
case 334:
#line 2515 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec -> genc)
                yyerror("References not allowed in a C module");

            yyval.number = ARG_IS_REF;
        }
break;
case 335:
#line 2523 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = 0;
        }
break;
case 336:
#line 2526 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.number = yystack.l_mark[-1].number + 1;
        }
break;
case 337:
#line 2531 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = defined_type;
            yyval.memArg.u.snd = yystack.l_mark[0].scpvalp;

            /* Try and resolve typedefs as early as possible. */
            resolveAnyTypedef(currentSpec, &yyval.memArg);
        }
break;
case 338:
#line 2539 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            templateDef *td;

            td = sipMalloc(sizeof(templateDef));
            td->fqname = yystack.l_mark[-3].scpvalp;
            td->types = yystack.l_mark[-1].signature;

            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = template_type;
            yyval.memArg.u.td = td;
        }
break;
case 339:
#line 2550 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));

            /* In a C module all structures must be defined. */
            if (currentSpec -> genc)
            {
                yyval.memArg.atype = defined_type;
                yyval.memArg.u.snd = yystack.l_mark[0].scpvalp;
            }
            else
            {
                yyval.memArg.atype = struct_type;
                yyval.memArg.u.sname = yystack.l_mark[0].scpvalp;
            }
        }
break;
case 340:
#line 2565 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = ushort_type;
        }
break;
case 341:
#line 2569 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = short_type;
        }
break;
case 342:
#line 2573 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = uint_type;
        }
break;
case 343:
#line 2577 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = uint_type;
        }
break;
case 344:
#line 2581 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = int_type;
        }
break;
case 345:
#line 2585 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = long_type;
        }
break;
case 346:
#line 2589 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = ulong_type;
        }
break;
case 347:
#line 2593 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = longlong_type;
        }
break;
case 348:
#line 2597 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = ulonglong_type;
        }
break;
case 349:
#line 2601 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = float_type;
        }
break;
case 350:
#line 2605 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = double_type;
        }
break;
case 351:
#line 2609 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = bool_type;
        }
break;
case 352:
#line 2613 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = sstring_type;
        }
break;
case 353:
#line 2617 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = ustring_type;
        }
break;
case 354:
#line 2621 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = string_type;
        }
break;
case 355:
#line 2625 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = wstring_type;
        }
break;
case 356:
#line 2629 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = void_type;
        }
break;
case 357:
#line 2633 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = pyobject_type;
        }
break;
case 358:
#line 2637 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = pytuple_type;
        }
break;
case 359:
#line 2641 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = pylist_type;
        }
break;
case 360:
#line 2645 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = pydict_type;
        }
break;
case 361:
#line 2649 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = pycallable_type;
        }
break;
case 362:
#line 2653 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = pyslice_type;
        }
break;
case 363:
#line 2657 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = pytype_type;
        }
break;
case 364:
#line 2661 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            memset(&yyval.memArg, 0, sizeof (argDef));
            yyval.memArg.atype = ellipsis_type;
        }
break;
case 365:
#line 2667 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* The single or first type. */

            yyval.signature.args[0] = yystack.l_mark[0].memArg;
            yyval.signature.nrArgs = 1;
        }
break;
case 366:
#line 2673 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Check there is nothing after an ellipsis. */
            if (yystack.l_mark[-2].signature.args[yystack.l_mark[-2].signature.nrArgs - 1].atype == ellipsis_type)
                yyerror("An ellipsis must be at the end of the argument list");

            /* Check there is room. */
            if (yystack.l_mark[-2].signature.nrArgs == MAX_NR_ARGS)
                yyerror("Internal error - increase the value of MAX_NR_ARGS");

            yyval.signature = yystack.l_mark[-2].signature;

            yyval.signature.args[yyval.signature.nrArgs] = yystack.l_mark[0].memArg;
            yyval.signature.nrArgs++;
        }
break;
case 367:
#line 2689 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            yyval.throwlist = NULL;
        }
break;
case 368:
#line 2692 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            if (currentSpec->genc)
                yyerror("Exceptions not allowed in a C module");

            yyval.throwlist = yystack.l_mark[-1].throwlist;
        }
break;
case 369:
#line 2700 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Empty list so use a blank. */

            yyval.throwlist = sipMalloc(sizeof (throwArgs));
            yyval.throwlist -> nrArgs = 0;
        }
break;
case 370:
#line 2706 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* The only or first exception. */

            yyval.throwlist = sipMalloc(sizeof (throwArgs));
            yyval.throwlist -> nrArgs = 1;
            yyval.throwlist -> args[0] = findException(currentSpec, yystack.l_mark[0].scpvalp, FALSE);
        }
break;
case 371:
#line 2713 "/tmp/BUILD.el8.x86_64/trinity-sip4-tqt-14.1.4/sipgen/parser.y"
	{
            /* Check that it wasn't ...(,arg...). */

            if (yystack.l_mark[-2].throwlist -> nrArgs == 0)
                yyerror("First exception of throw specifier is missing");

            /* Check there is room. */

            if (yystack.l_mark[-2].throwlist -> nrArgs == MAX_NR_ARGS)
                yyerror("Internal error - increase the value of MAX_NR_ARGS");

            yyval.throwlist = yystack.l_mark[-2].throwlist;
            yyval.throwlist -> args[yyval.throwlist -> nrArgs++] = findException(currentSpec, yystack.l_mark[0].scpvalp, FALSE);
        }
break;
#line 8321 "parser.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
